
// TYPE_HERE: here you can type your mnemonic constants, using the #define directive
// like trng did it in the "Tomb_NextGeneration.h" file
// in this source you can also type your declaration of tomb raider function
// like it happens for "functions.h" source

// -------- START PRESET CONSTANTS ---------------------------------
// please don't remove the constants in this "PRESET CONSTANT" zone. 
// They will be used by some preset function in your plugin source

#define MAX_MYPROGR_ACTIONS 100
#define MAX_ASSIGN_SLOT_MINE 200
#define MAX_LAST_TARGETS 4

#define ENDLESS_DURATE 0xFFFF // to use as number of frames to set an infinite durate
#define NGTAG_END_SEQUENCE		   0   // signals the end of ng token sequence
#define NGTAG_PROGRESSIVE_ACTIONS  1
#define NGTAG_LOCAL_DATA           2
#define NGTAG_GLOBAL_DATA          3

// --------- END PRESET CONSTANTS ---------------------------------
// type here the constant name for new progressive action you create
// use progressive number to have always different value for each AXN_ constant/action


// MPS_ flags
// you should type here your MPS_ flags for plugin command.
// then you'll test the presence of these flags checking the Trng.MainPluginFlags  value using "&" operator
// please: do not use the value 0x40000000 (MPS_DISABLE) because it has been already set by trng engine

// constants for drones  ---------------------------
// my progressive action
#define AXN_FREE  0  // this record is to free an action record. You type this value in ActionType to free a action progress record
#define AXN_PUT_PICKUP_DRONE 1
#define AXN_TILT_DRONE_CAMERA 2

// constant for customize command
#define CUST_DRONE 1


// argument index in customize command (to access to customize fields in descriptive way)
#define ARG_Flags					0
#define ARG_CamViewFlags			1 
#define ARG_DronePickupSlot			2
#define ARG_DroneFullPickupSlot    3
#define ARG_ControllerPickupSlot	4
#define ARG_BatteryPickupSlot		5
#define ARG_FirstDroneExtraString	6
#define ARG_HelpImageIndex			7
#define ARG_MaskImageIndex			8
#define ARG_BatteryTime				9 
#define ARG_MaxDistance				10
#define ARG_SpriteCmdId				11
#define ARG_Extra1					12
#define ARG_Extra2					13
#define ARG_AMOUNT					14

// -- position of drone strings respect the first to pass to ShowDroneString()
// note: don't pass ever the "_SHORT_" version of text, pass the normal version and then, it will be ShowDroneString to change it
//		to "short" version, when VIEW_CAM_DRONE is active
#define MSG_HINT_FOR_HELP		0
#define MSG_DISTANCE			1
#define MSG_SHORT_DISTANCE		2
#define MSG_HEIGHT				3
#define MSG_SHORT_HEIGHT		4
#define MSG_BATTERY				5
#define MSG_SHORT_BATTERY		6
#define MSG_SIGNAL				7
#define MSG_SHORT_SIGNAL		8
#define MSG_COMPASS				9
#define MSG_SHORT_COMPASS		10

#define MSG_HELP_TEXT			11
#define MSG_LOW_SIGNAL			12
#define MSG_LOW_BATTERY			13
#define MSG_LOST_DRONE			14
#define MSG_EMERGENCY_LANDING   15
#define MSG_RETURN_TO_HOME		16
#define MSG_LOOKING_FOR_LANDING 17
#define MSG_TAKEN_ITEM			18
#define MSG_OBSTACLE			19
#define MSG_LANDING				20 
#define MSG_READY               21
#define MSG_SAFE_RECOVERY       22
#define MSG_TAKE_OFF			23
#define MSG_FAILED_OPERATION	24
#define MSG_FALLING_DOWN        25
#define MSG_NO_BATTERY			26
#define MSG_IMPACT				27

// VIEW_ flags (to set the kind of view while drone is flying
#define VIEW_NO_CAM					0x0000 // no specific view cam (lara watches what she wishes and no drone csam)
#define VIEW_CAM_DRONE				0x0001
#define VIEW_CAM_CHASE_DRONE		0x0002
#define VIEW_CAM_LARA				0x0004
#define VIEW_CAM_ALL				0x0007
#define VIEW_CHAR_HALF			0x0008 // use half height charset
#define VIEW_CHAR_MICRO			0x0010 // use littles tomb raider font
#define VIEW_NO_TESTUAL_HELP	0x0020
#define VIEW_SHOW_TIP_FOR_HELP	0x0040 // display the hint about how to display help (FirstDroneExtraString text) when Lara takes the controller
										// note: at least first time in the advenutre the hint will be always showed but if you set this flag
										// the hint will be displayed every time lara grab the controller
#define VIEW_USE_YARDS			0x0080  // show values in yards 
#define VIEW_NO_TELE_ON_CHASE_CAM 0x0100 // disable telemetric texts on VIEW_CAM_CHASE_DRONE
#define VIEW_NO_WARNINGS_ON_CHASE_CAM 0x0200 // disable also warnign messages (like "ready", "Low signal", "Landing" ect
#define VIEW_NO_WARNINGS_ON_LARA_CAM 0x0400  // disable warning when there is lara cam (Lara is looking at drone while she is driving it)


// DP_  constnts for kind of general phase about drone management
#define DP_DRONE_PICKUP				0x0001   // currenly the real drone is missing, there is only a piclup drone and we wait that lara engaged the drone with controller
#define DP_QUIT_DRONE_MODE			0x0002  // we started to quit drone mode and we have to do land the drone, close its arm, convert in pickup mode ecc.
#define DP_FLYING				0x0004 // drone is fluying controlled by lara
#define DP_LANDING			0x0008 // drone is trying to land
#define DP_RETURN_TO_HOME			0x0010 // drose is trying to return to start point (from where it took off)
#define DP_PREPARING_TO_FLY			0x0020  // drone is going to open arms to be able to fly
#define DP_READY					0x0040  // drone is ready to be moved with controller but it is not yet flying
#define DP_PREPARING_TO_PICKUP		0x0080  // drone is closing its arm to become a pickup
#define DP_NO_DRONES				0x0100  // real drone invisible, pickupdrone in inventory
#define DP_TAKE_OFF					0x0200 // automatic take off
#define DP_RECOVER_OLD_HEIGHT		0x0400 // phase where the drone will move up to come back to previous heigth
#define DP_CHASE_TARGET				0x0800 // there is a target (BaseDrone.Target) to reach, in horizontal at start 
#define DP_REACH_Y_TARGET			0x1000  // there is the BaseDrone.Target_Y_Only coordinate to reach (moving up or down the drone). 
											// This phase will be always performed earlier than chase target phase
#define DP_TURN_LARA				0x2000 // lara turns to look at drone 
#define DP_REBOUND_ON_IMPACT		0x4000 // the drone will spring back after an impact (like a rebounding)
#define DP_LOST_DRONE				0x8000 // the signal (or the battery level too low) did loosing the drone
#define DP_NO_SIGNAL				0x10000 // reason of lost drone: no signal
#define DP_NO_BATTERY				0x20000 // reason for lost drone: no battery
#define DP_RECOVERING_SAFE_POSITION 0x40000  // drone is trying to come back to last positon where it had a contact with controller
#define DP_EMERGENCY_LANDING		0x80000 // drone is landing for an emergency (lost drone)
#define DP_HELP_IN_PROGRESS			0x100000  // the screen is showing the help text
#define DP_CRASH_IN_PROGRESS		0x200000 // the drone is plummeting
#define DP_FAILURE					0x400000 // drone failed some automatic phase
#define DP_FLOATING					0x800000 // drone is floating on water surface
#define DP_NOISES_ON_SCREEN			0x1000000 // added disturbs of control's screen for no signal
#define DP_FAILED_TAKE_OFF          0x2000000 // drone collide immediately with Lara in take off phase
// ---------- PROFILING CONSTANTS FOR DRONE -----------------

// changing below values you can affect the behaviour of the drone
// drivining/ movements drone

#define PROF_UP_KEEP_HEIGHT 10 // automatic vertical speed up, used to restore prevuous height when drone was going to loose height
#define PROF_YGAP_TO_KEEP_HEIGHT 128 // difference in height to force drone to move up to recover old height (tollerance)
									// this will be the height of oscillation
#define PROF_GRAVITY_SPEED 5  // the drone should move down with this vertical speed (simulation of gravity)


#define PROF_VSPEED 15  //  vertical speed for UP/DOWN commands
#define PROF_HSPEED 40   // Horizontal speed for movement forward/backward/left/right
#define PROF_MAX_FALLING_SPEED 64  // when the drone crash (falling down) this will be max falling speed
#define PROF_ROTATE_SPEED  512 // speed (degrees where 0x8000 = 180 degrees, to rotate drone
#define PROF_LARA_ROTATE_SPEED 256 // rotation speed for lara when she has to turn to look at drone in VIEW_CAM_LARA mode
#define PROF_FLOATING_VSPEED 2 // speed of up/down movement when drone is foating on water surface
#define PROF_GAP_SWINGING_ON_FLOATING 20 // step, up/down to move the drone on water surface. this vlaue will be multiplied by water intensity of given room
#define PROF_FLOATING_PAUSE_ON_PEAK  3  // little brak in up/down movement, when the drone is at peak of its movement
#define PROF_DISTANCE_WATER_FOR_WAVES 512 // when distanc from water surface is less than this value, there will be waves on the surface
#define PROF_DISTANCE_FROM_GROUND_FOR_WAVES 512 // to avoid waves on the ground close to water surface, there will be this safe distance before waving
#define PROF_DURANTE_PAUSE_BETWEEN_WAVES 10  // amount of frames between a "splash" effect and the next
#define PROF_TAKE_OFF_HEIGHT 512 // height (from start point) to reach, in automatic take off with ENTER command
#define PROF_MIN_DISTANCE_LARA_FOR_TAKE_OFF  512 // if lara is closer than this distance the drone will not take off (with DRF_PROXIMITY_SENSOR flag)
#define PROF_HALF_SIZE_DRONE 100 // this should be (about) the half of horizontal size of the drone. It will used to check if 
								// in front (of curreen direction) or sidely, of drone there is a wall
#define PROF_FULL_HSIZE_DRONE 60 // this is (about) the size of vertical height of drone object (its collision box)
								// it will be used to check (in upward movement) if it is going to touch the ceiling

#define PROF_GAP_OVER_FLOOR 12  // keep the drone (in landing) a bit heigher than floor to have same gap of pickup drone
#define PROF_FLOAT_DISTANCE_MIN 150  // min valid distance from lara and floating drone to pickup it
#define PROF_FLOAT_DISTANCE_MAX 300 // max valid   "    "      "     "    "     "     "    "    "
#define PROF_FLOAT_MAX_ORIENT_FACING 0x1800  // max difference between lara's facing and ideal facing to look at floating drone
#define PROF_FLOAT_PICKUP_MAX_SWING 0x800 // max value of inclination of pickup drone to simulate the waving on water surface
#define PROF_FLOAT_SWING_SPEED 128  // increement used to change inclination of piclup drone on water surface
#define PROF_DRONE_MAX_TILT 0x0c00  // max inclination of drone to follow directions
#define PROF_DRONE_TILT_SPEED 160  // speed to tilt drone
// sound used by drone
#define PROF_SFX_LITTLE_HIT 310 // MAPPER_CLUNK map_clnk.wav
#define PROF_SFX_BIG_HIT    306  // MAPPER_SWITCH_ON  map_swch.wav
#define PROF_SFX_MOTOR  308  // MAPPER_LAZER l_maplzr.wav 


#define PROF_MAX_MESSAGE_LIST 5 // number of message to show in a row
// game commands used in drone mode, you can change the CMD_ values at right with
// another CMD_ value, to change input commands to handle the drone
// note: if you want add a double command, or modify a double command, try to get fine how they work: read about this issue in plugin_drone.htm file
#define PROF_GAME_FORWARD	CMD_UP    // move forward
#define PROF_GAME_BACKWARD	CMD_DOWN   // move backward
#define PROF_GAME_LEFT       CMD_LEFT   // move left
#define PROF_GAME_RIGHT      CMD_RIGHT  // move right

#define PROF_GAME_UP         CMD_DASH   // raise up the drone
#define PROF_GAME_DOWN       CMD_DUCK  // move down the drone 
#define PROF_GAME_TURN_LEFT  (CMD_WALK+CMD_LEFT)  // (DOUBLE COMMAND) rotate drone in counter clockwise direction 
#define PROF_GAME_TURN_RIGHT (CMD_WALK+CMD_RIGHT)  // (DOUBLE COMMAND) rotate drone in clockwise direction 
#define PROF_GAME_CAM_DOWN_TILT  (CMD_WALK+CMD_UP) // (DOUBLE COMMAND) rotate down the drone's cam
#define PROF_GAME_CAM_UP_TILT     (CMD_WALK+CMD_DOWN) // (DOUBLE COMMAND) rotate up the drone's cam

#define PROF_GAME_TAKE_OFF_LANDING CMD_ENTER  // perform a take-off (when drone was on ground) or a landing (when drone was flying)
#define PROF_GAME_SWAP_CAM    CMD_DRAW_WEAPON // swap type of cam view while drone is flying
#define PROF_GAME_QUIT      CMD_INVENTORY  // quit drone driving
#define PROF_GAME_SWITCH_LIGHTS  CMD_JUMP // enable/disable landing lights
#define PROF_VK_SHOW_HELP     VK_F8		// you can modify this only using another VK_ (Windows Virtual Key) value ( but not a CMD_ value)
#define PROF_VK_CAPTURE_SCREENSHOT VK_F3       // hardcoded, you cannot change this
#define PROF_VK_RETURN_TO_HOME VK_HOME // key command to engage return to home
// --- ohter profiling constant
#define PROF_FRAME_LEAVE_DRONE 86  // this is the number of frame, of animation 0 of drone, when there will the swap mesh to let pickup drone
									// on the ground and swap lara's right hand with a free hand. Note: this has to be the same number
									// in animcommand of animation 0, to trigger the mesh swapping
#define PROF_FRAME_PICKUP_FROM_WATER 16 // frmae index (in animation 7 of Drone_lara, when lara picked up the pickup drone on water surface
#define PROF_MORE_DISTANCE_FOR_ONE_WALL 4 // Used when it has been enabled the DRF_WALL_REDUCTION flag. 
										// It will be used to compute the lost of signal when there ara walls: 
										// each full wall (about 2 meters) as obastacle, it will be seen as (PROF_MORE_DISTANCE_FOR_ONE_WALL)*2 = 8 meters more
										// of current distance, This value then will be used to compute the percentage on max_distance and finally to get 
										// the signal percentage. Note that the signal formula, will consider also fractions of wall, with one click 
										// (about half meter) as littlest unit.
#define PROF_WARN_LEVEL_LOW_BATTERY 10 // percentage level of battery to warn "low battery"
#define PROF_BATTERY_LEVEL_EMERGENCY_LANDING 5.0f  // when the battery level is less than this value, it will start an emergency landing
#define PROF_WARN_LEVEL_LOW_SIGNAL 20 // percentage level of signal strength to warn "low signa"
#define PROF_SIGNAL_LEVEL_EMERGENCY 5  // when the signal strenght is less than (this value) the drone will start
								// a recovery of safe position, or an emergency landing

#define PROF_CONTROLLER_LARA_YGAP -654  // this is the difference, on Y axis, between Lara's coordiante (on her feet) and the Controller
										// while lara is holding it. It used to have a better precision controller position in 3d space
#define PROF_FRAME_DURATE_WARNINGS 30 // most messages (warnings) will be kept on screen for this amount of frames (30 frames = one second)
#define PROF_SHORT_TIME_WARNING_MSG 15 // durante (shorter) for some warning messages
#define PROF_LONG_TIME_WARNING_MSG 50 // long durante for some warning messages
#define PROF_BLINKING_TIME 15   // amount of game frames (one second = 30 frames) to invert the color of back light
#define PROF_SECONDS_FOR_HELP_HINT 3 // amount of second for text "f8 for help"
// --- profiling for VIEW_CAM 
// for VIEW_CAM_CHASE_DRONE mode:
#define PROF_CHASE_CAM_DISTANCE  600	// Distance of cam respect drone. Littler values and cam will be closer drone
#define PROF_CAM_MAX_TILT 0x38e0 // max degrees of tilt for chase or cam view mode (tomb values one degreee = 182 tomb rotation)
#define PROF_CAM_MIN_TILT 0 // min degress of "     "    "    "  "    "
#define PROF_SPEED_CAM_TILT  182 // speed to tilt the drone's cam with specific game command
// for VIEW_CAM_DRONE mode
#define PROF_DRONE_CAM_DISTANCE 1024  // distance between the drone cam and the fake (invisible) target to look at


// ----------  COLL_... type of collision returned by CheckCollisionForDrone() function
#define COLL_WALL			0x0001
#define COLL_CEILING		0x0002
#define COLL_MOVEABLE_ITEM	0x004
#define COLL_STATIC_ITEM	0x008
#define COLL_BOX_SECTOR		0x010
#define COLL_FLOOR			0x020
#define COLL_NO_COLLISION   0  // to check with "==" of course and not with "&" (and)

// ------- UCMD_  values: User Commands from triggers -----------------
#define UCMD_LANDING			1
#define UCMD_FALLING_DOWN		2
#define UCMD_SHAKE_AND_TROUBLE  3
#define UCMD_DIVERT_DRONE			4
#define UCMD_ROLLING			5
#define UCMD_FOLLOW_LARA         6
#define UCMD_QUIT_CUTSCENE 7

// ------- DRF_.. flags (same of cutomize=CUST_DRONE script command

#define DRF_FORBIDDEN_BOXES			0x0001  // drone canno't flying (or landing) over (gray) box sectors
#define DRF_MAGNET_SKILL			0x0002 // the drone is able to catch keys where it will land (if the key item has ocb = 512)
#define DRF_USE_YARDS				0x0004  // show values in yards 
#define DRF_WALL_REDUCTION			0x0008  // reduce drammatically the signal strenght when there is a wall between the controller and the drone
#define DRF_USE_BATTERIES			0x0010  // enable battery management
#define DRF_SAFE_RECOVERY           0x0020  // when the drone lost contatct, it will try to come back to last position where it had a contact
#define DRF_PROXIMITY_SENSOR		0x0040 // the drone will stop before smashing against obstacles
#define DRF_ENGAGE_PAD_HEAVY		0x0080  // when the drone touch the ground, it will activate the (further) heavy trigger on that sector
#define DRF_ENGAGE_OVER_HEAVY		0x0100 // when the drone flies over (or touches) a sector with heavy triggers they will be triggered  
#define DRF_ENGAGE_TGROUP_ON_ITEM_COLLISION   0x0200 // when drone touch the item with slot of Extra1, it will perform the the triggergroup with id 
													//  in Extra2
#define DRF_DESTROY_SHATTERS        0x0400  // the drone will be able to destroy shatter statics
#define DRF_NOISE_EFFECT_ON_NO_SIGNAL	0x0800 // it will add a frequency noise effect on contorller's screen, when there is no signal from drone
#define DRF_ENGAGE_TGROUP_ON_STATIC_COLLISION 0x1000 // when drone collides with static of slot in Extra1 it will be engaged the triggergorup in extra2
#define DRF_NO_TRIGGERS_ON_FOLLOWME 0x2000 // when drone is followig lara the further heavy triggers will be not triggered by drone
#define DRF_DYNAMIC_ENGINE_SOUND 0x4000 // enable the change of pitch for propeller sound while drone is flying
// --------- OCB valuse for drone
#define OCB_MASK_FOR_PICKUP   0x01ff   // mask to save only ocb for further pickup (drone) item
#define OCB_SET_EMPTY_BATTERY 0x0200   // drone (to pickup) will have an empty battery
#define OCB_RESET_HUB		  0x0400   // reset all drone's data for this levle
// --------- GLOBAL TRIGGERS

#define GT_DRONE_COLLIDE_STATIC 180  // drone collided with static item with slot of Parameter
#define GT_DRONE_COLLIDE_ITEM   181  // drone collided with moveable item with slot of Parameter


