// let below pragma directive at top of this source
#pragma pack(1)

// TYPE_HERE: here you can type your structure definitions like it has been done
// in the "structures.h" file for trng dll

typedef struct	StrSpeed {
	int Speed; // distance to cover in one cycle
	WORD Direction; // (facing) to show the direction
}SpeedFields;

typedef struct StrWarning {
	short Frames;  // amount of frames to keep on screen this message
	short TypeMSG; //  MSG_... value
}WarningFields;

typedef struct StrBaseDrone {
	bool TestPresent;  // = true,it means all required drone items are present in current level
	bool TestJustLoaded; // signal to know that, current BaseDrone has been just loaded from savegame (=true)
						// while if it is false, then it weas new level
	WORD Flags; // DRF_..
	WORD ViewFlags;   // VIEW_...
	int DronePhase;  // macro operation that we are going to perform DP_... values
	short Extra1;
	short Extra2;
	int LevelNow; // index of level (when it has been saved BaseDrone to savegame
	short SlotBattery;
	short SlotController; // slot of pickable controller
	short PickupDroneSlot; // slot of pickable foldable drone (with not completely full battery)
	short PickupFullDroneSlot; // slot of pickup drone with full battery
	short FirstStringIndex; // index (in ng extra strings) of first drone string
	short HelpImageIndex;  // id of help image (or -1 if missing)
	short MaskImageIndex;  // id of image to show with Drone View
	short BatteryMinutes; // minutes with  full battery
	short MaxDistance;		// max distance in game units
	short SpriteCmdId;		// id for Parameters=PARAM_SHOW_SPRITE to simulate "no signal" effect on controller's monitor
	short IndexPickupDrone; // index of drone in pickup state, on the ground, or -1 when in inventory or missing (replaced by real drone)
	short IndexRealDrone; // index of moveable of real drone
	short PickedUpKey;  // slot of key picked up by drone (whereby magnet) or -1 if it is missing
	bool TestStoppedKeys; // if true we had stopped keyboard
	int OldStopMask;  // we save the old setting for stop key, to restore and preserve further previous stopping key from other plugins
	int Old_Y_ToKeep;		// previous Y coordinate of drone to preserve
	GAME_VECTOR StartPoint; // save the point from the drone took off, usefull for return to home and to preserve always same height
					      // indeed, the Y coordinate will be used to compute the currnet drone's height
	GAME_VECTOR LastSafePoint; // last positon where drone had a signal greater or even than PROF_WARN_LEVEL_LOW_SIGNAL value
	GAME_VECTOR LastPosition;  // position of drone in previous game cycle
	GAME_VECTOR LastLaraTargetOk; // last position of lara where it has been posisble get a target for follow-me
	bool TestSuspendTakeOff; // to avoid that this key was read many times, and thre was a take off and a landing in a row
							// after having detected a hit, it will remain suspended until it will be not released

	bool TestSuspendQuit; // invnetory key, don't read it furtherly, untile it has been released
	bool TestSuspendDrawWeapon;
	bool TestSuspendHelpKey;
	bool TestSuspendRthKey; 
	GAME_VECTOR Target; // this sub  structute defines a target point to reach for landing pahse or return home
	int Target_Y_Only; // new heigth (y coordinate to reach) in DP_REACH_Y_TARGET phase
	int CollisionItemIndex; // index of item collided with drone in last collision check (or -1, if no collision)
	short CollisionStaticRoom; // room of static with whom drone collided
	int CollisionStaticIndex;  // index of static .. . ..  ..     ...
	StrSpeed SpeedNow;  // curren speed (it works like aceleration to increase gradually until max speed PROF_HSPEED
	StrSpeed SpeedOld;  // speed and direction in previous cycle, to use newly in SpeedNow (if same direction) or usign it as intertial movement
						// after a change of direction
	int SpeedVertical;  // variable vertical speed for keep_height and gravity with intertial movements
	int ViewCamNow; // current cam view (a VIEW_CAM...value)
	int ViewCamOld;  // cam view in previous game cycle
	short IncRot; // increment to turn lara to get her always faced to drone
	int Rebound_H_Speed; // horizonfal speed on DP_REBOUND_ON_IMPACT phase, versus Rebound_H_Direction
	int Rebound_V_Speed; // Vertical speed   "     "     "      "           "     "  Rebound_V_Direction
	WORD Rebound_H_Direction; // direction (facing) where to move in DP_REBOUND_ON_IMPACT phase
	int Rebound_V_LoseHeight; // a sort of super gravity when drone loses height
	WORD LastDirection; // direction of last valid movment
	int IndexCamera; // index of my camera (get with CreateNewCamera()) to manage the differen VIEW_CAM modes
	short TiltCamera;  // vertical rotation of drone's cam: from 0 to 90 degrees 
	bool TestAlreadyShowedHint; // to display only once, at start of the adventure the hint stiring like "F8 for Help"
	bool TestVisibleRealDrone; // =true when the real drone is visible, false = real drone is invisible because there is the piclup drone
	bool TestStartedSaveLoadGame; /// true when ProcDroneControl enable f5 / f6 keys to save the game
	bool TestSuspendEnter;	// these three TestSuspend are used immediately after the quit of load/save game panel 
	bool TestSuspendAction;//         to avoid that a residual of these keys (used in load/save game panel) could
	bool TestSuspendInventory;   // affect driving drone manamangemt
	bool TestSuspendLightSwitch;
	short IndexStringDistance; // mine ng string to host  elaborated Distance
	short IndexStringHeight;   // "    "    "    "    "      "    "  Height
	short IndexStringBattery;  // "    "    "    "    "      "    "  Battery level
	short IndexStringSignal;   // "    "    "    "    "      "    "  Signal Strenght
	short IndexStringCompass;  // "    "    "    "    "      "    "  Compass degrees
	short IndexStringWarnings; // used for all warning messages
	short WarningFrameDurate; // amount of frame to let on screen the last warning message
	bool TestTelemetryON; // true when there are texts on screen for telemetry
	bool TestWaWarnTelemetryON; // true when it has been already allocated the string to show warning messages
	short WarningLastMSG; // index of last ng string used to display a message
	int BatteryLevel; // value of battery level (in frames) when it is 0 it means no energy
	short TotMessages;  // messages queu (when there is alrewad a message and other have to wait 
	StrWarning VetMessages[PROF_MAX_MESSAGE_LIST];  
	float PercBattery;	// float value for percentage batery level
	float PercSignal;	// float value for percentage signal strength level
	bool TestCollision; // true if in last game cycle drone smashed (or stopped) against walls or items
	char BufLastMsg[256]; // really this buffer will be used only for messages with argument
	bool TestOldCollision;  // if "true" there has been a collision in last game cycle
	int FallingSpeed; // veritcal speed for crash
	int BlinkingCounter; // keep the time (in frames) of last time that the back red/green light has been changed
	bool TestLandingLights; // when it's true downstairs lights weill be on in according with back green led
	int FloatingIncY;  // vertical direction on moving while drone is floating on the water surface
	int FloatingPause; // time to stop the up/down movement, when drone is at peak of the wave
	int FloatIncRotV;	// increments to do swinng the pickup drone on water surface 
	int FloatIncRotT;	//  ""     "    "      "    "    "    "      "      "
	int DelayForWaves;  // when drone is close to water surface there will be waves on water but it's necessary let some pause between one and the next
	float UserChangeWalls; // amount of (simulated) clicks of walls (one click = 256 game units) in the compute of signal strenght
	float UserChangeDistance; // amount of meters to add or subtract by real distance between drone and controller
	int UserChangeDistMode; // mode to change distance 
	int UserChangeWallMode; // mode to change walls
	int UserMsgIndex;  // index string to show, required by a trigger
	int UserMsgMode;  // mode to show the text
	int UserMinHDistnce; // min horizontal distance for follow me
	int UserMinVDistance; // min vrtical distance for follow me
	bool TestUserCommand; // there is a user command in progresso to execute
	int UserCommand; // a command required by some trigger  UCMD_ values (User CoMmanDs)
	int UserParameter; // generic parameter used by some user commands
	bool TestMaskImageOn; // the mask image (used in VIEW_CAM_DRONE) is currently displayed on screen)
	bool TestCutScene; // if true, drone is following commands via triggers to reach some target
	bool TestUserChangePos; // if true a trigger changed the position of drone
	bool TestAlitudeLimit; // when it's true the drone will be not allowed to raise over the AltitudeLimit Y coordinate
	int AltitudeLimit;  // value of Y Coordinate to do not pass over (rasing)
	bool TestLimitForever; // it's true if altitude limit has been enabled forever (until a flipeffect 68 to disable it)
	int TotLastTargets; // amount of (in a row) attempts to target to reach in random way (used by FindRandomDirectionAsTarget() function)
	POINT VetLastTarget[MAX_LAST_TARGETS]; // save (only x,z) coordinates of last attempt of target to random direction (to avoid to turn endlessly)

}BaseDroneFields;

// --------------- PRESET STRUCTURE ZONE -----------------------------
// Please, don't remove structures and fields you find in this "PRESET ZONE". They will be used by some
// preset functions of your plugin sources
// However, you can add new fields and structures in following structures, of course
typedef struct StrSavegameGlobalData {
	// FOR_YOU:
	// define here your variables that you wish were saved (and then restored) to/from savegame in GLOBAL section 
	//           (only one for all levels)
	// note: the size of this structure should be always even (if you add BYTE variable, remember to compensate that 
	//       with another BYTE vairable or placefolder)
	// save (a copy of) BaseDrone structure
	StrBaseDrone SaveDrone;
	
}SavegameGlobalDataFields;
typedef struct StrSavePickupDrone {
	int Index;
	DWORD CordX;
	int CordY;
	DWORD CordZ;
	short Room;
	WORD HOrient;
	WORD SlotId;
}SavePickupDroneFields;

typedef struct StrSavegameLocalData {
	// FOR_YOU:
	// define here your variables that you wish were saved (and then restored) to/from savegame in LOCAL section (one for each different level)
	// note: the size of this structure should be always even (if you add BYTE variable, compensate it with another BYTE vairable or placefolder)

	StrSavePickupDrone PickupData;  // used to save position of pickup drone in local (hub) data, used in jumps between levels
}SavegameLocalDataFields;


typedef struct StrSavegameData {
	StrSavegameGlobalData Global;
	StrSavegameLocalData  Local;
}SavegameDataFields;


typedef struct StrBaseAssignSlotMine {
	int TotAssign;
	StrRecordAssSlot VetAssignSlot[MAX_ASSIGN_SLOT_MINE];
}BaseAssignSlotMineFields;

typedef struct StrMyData {
	StrSavegameData Save;  // variable that it will be saved and restored to/from savegame
	// FOR_YOU:
	// define here all your global variables, i.e. those variables that will be seen from all procedures and keep 
	// their value between all cycles of the game.
	// after you defined a variabile like:
	// int  Alfa;
	// then you'll be able to access to them using syntax like:
	// MyData.Alfa = 3;
	// if (MyData.Alfa == 5) .
	int TotProgrActions;
	int LastProgrActionIndex; // used in case of overloading

	StrProgressiveAction VetProgrActions[MAX_MYPROGR_ACTIONS];
	StrBaseGenericCustomize BaseCustomizeMine;  // stored all your customize script commands for current level
	StrBaseGenericParameters BaseParametersMine; // store of all your parameters= script commands of current level
	StrBaseAssignSlotMine BaseAssignSlotMine; // stored all AssignSlot= command script commands of current level


}MyDataFields;
// ----------------- END PRESET STRUCTURE ZONE ---------------------------------------


// let below pragma directive at bottom of this source
#pragma pack(2)