// FOR_YOU:
// This is the main source of your plugin.
// It's in this source you'll type all your assembly or c++ code and all 
// the variables and memory zones you need.

// ------------- INCLUDE HEADERS (.h) FILES -------------
#include "stdafx.h"
#include <string.h>
#include <stdio.h>
#include <math.h>
#include "bass.h"		// prototypes for extra sound library: bass.dll
	// Following header files will be updated for every new version of 
	// the tomb_NextGeneration.dll, so it's better you don't change them
	//  because they will be replaced for any new update.

#include "Tomb_NextGeneration.h" // mnemonic constants defined in tomb_NextGeneration.dll
#include "structures.h" // structure of tomb4 program and trng dll
#include "DefTomb4Funct.h" // defines of tomb4 procedure prototypes
#include "functions.h"  // assigments of real tomb4 address to each tomb4 procedures
#include "macros.h"  // definition of macros

	// FOR_YOU:
	// While the followings are the headers you can use 
	// to type your structures, constants and new tomb4 procedures you 
	// discovered. 
	// Following files are only yours and trng will not ever change them:
#include "macros_mine.h"  // here you define your own macros
#include "constants_mine.h" // here you define your mnemonic constants
#include "structures_mine.h" // here you type your structure definitions
#include "Tomb4Discoveries_mine.h" // here type tomb4 procedures you discovered

#include "trng.h" // list of trng functions imported from trng.cpp source. 

#pragma warning( error : 4706 )
#pragma warning(disable: 4996)
// function declared in advance to avoid error "undeclard identifier" and then "Redefinition: different type modifiers"
void TransformPickupToRealDrone(void);
int GetRelativeAnimation(StrItemTr4 *pItem);
void RemoveMSG(int TypeMSG);
void RemoveTelemetry(void);
void ShowMessage(bool TestShowNow, int TypeMSG, short FrameDurate, char *pMexExtraArgument);
char * GetTextFailedPhase(int FailedPhase);
void RemoveWarningsTelemetry(void);
void EnableWarningsTelemetry(void);
void SetSizeChar(void);
void SendErrorToDiskLog(char *pMessage, DWORD PluginID, bool TestMsgBox);
void RemoveLastMessages(void);
char *LogCords(DWORD x, DWORD z);
int FindIncrementsForTarget(StrItemTr4 *pSource, StrItemTr4 *pTarget, int MaxInc, int *pIncX, int *pIncY, int *pIncZ);
void DisplayShadow(StrItemTr4 *pDrone, bool TestShow);
void RemoveMaskImage(void);
int ConvertLinearUnitToGameUnits(int MeterYards);
float ConvertUnits(float GameUnits);
void ManageFailure(StrItemTr4 *pDrone);
void LogCamera(char * pMexIntro, StrAdrCamera *pCam);
bool FindTargetRTH(StrItemTr4 *pDrone, GAME_VECTOR *pNewTarget);
// ------------ END INCLUDE HEADERS (.h) FILES ----------
 
// ------------- GLOBAL VARIABLES -------------------------

// FOR_YOU:
// here you type the variables or memory zones you wish use in different
// C++ procedures.
// If you use the assembly you'll have to type ALL your variables in this
// section.
// for example if you wish have a 32 bits signed variable to store big
// numbers you can type:
// TYPE_HERE:
// int MyNumber;
// and then you can use it in asm in this way:
//		mov  eax, [MyNumber]
// or
//      mov eax, dword ptr [MyNumber]
// same speech for wide memory zones.
// If you wish having a memory zone of 13000 bytes you can type:
//  BYTE MyZone[13000];
// and then you can use it in this way:
//     mov  al, MyNumber[ecx]  ; read the ECXth byte and copy it in AL
// or also:
//     mov al, [MyNumber+ecx] ; same result of above instruction

// Variables and memory zone to TYPE_HERE:

HINSTANCE MyDllInstance=NULL;  // the instance handle of your dll

extern char BufferLog[4096]; // temporary global buffer to host error and warning messages
// increments to check 8 sectors around one sector
POINT VetIncAttempts[] = {     {1,0}, {0 ,  1}, {-1,  0}, {0, -1},  {1 ,-1}, {1 , 1},  {-1 , 1},{-1, -1}, {0,0}}; 
WORD  VetDirectionAttempt[] = {0x4000,  0x0000,  0xc000,  0x8000,   0x6000,  0x2000,    0xe000,   0xa000,  0x0000};  
StrItemTr4 TargetFakeItem; // used to work as (invisible) target when drone is VIEW_CAM_DRONE mode
bool TestRemovedDroneCam=false;
char *VetDroneFields[] = {"04:4:ContactFlags", "08:4:MesVisibilityMask", "0E:2:StateId", "10:2:StateIdNext", "14:2:Animation", 
							"16:2:Frame", "18:2:Room", "2C:2:OCBCode", "30:2:Transparency", "40:4:X_Cord", "44:4:Y_Cord", 
							"48:4:Z_Cord", "4C:2:Facing Vertical", "4E:2:Facing Horizontal", "50:2:Facing ClockWise",
							"15EA:4:Flags Main", "15EE:4:Flags Swap Mesh"};

bool TestLoadedLocalData; // it will set "true" when from hub or savegame have been loaded the local data of drone's indices
// FOR_YOU: If you mean create code patch (changes in tomb4 code to call your code in the plugin dll,
// you MUST change the MyTomb4PatcherAddress value (here below) 
// You can discover a free tomb4 zone using TrngPatcher program, with the 
// menu command "Tools->Get Assignment of Free Memory range"
// Note: choose an address, in the given range, terminating with hex 
// digits: 0,4,8, or C
// because it's usefull that the address was a multiple by 4
// If you chose an address used from other plugins you'll get an error and
// the game will be aborted
// note: if you don't mean use code patches you can let 0x0 in following line
DWORD MyTomb4PatcherAddress = 0x0; // <- TYPE_HERE: the new address you chose
								
// this text will contain your plugin name (omitting .dll extension).
// it will be used to give a title to messagebox for error messages or warnings
// note: the standard code in trng.cpp will perform for you this job
char TexMyPluginName[80];  
// in this MyData structure you can store all global variables for your plugin
// you have to define them in structures_mine.h source inside structure "StrMyData" or for variable
// to save and restore in savegames, in "StrSavegameGlobalData" or "StrSavegameLocalData" structures
StrMyData MyData;

// main structure where saving variables for drone management
StrBaseDrone BaseDrone;

// -------------- END GLOBAL VARIABLES --------------------

// --------------- PROCEDURE USED BY MANY OTHERS --------------------------------------


// --------------- CODE FOR TOMB4 "CODE" PATCHES  --------------
// Note: please, don't change or remove the C++ procedure you find here,
// because they are necessary to do work the plugin with the trng dll
// Anyway in many of these functions you can add your code


// --------------- CODE FOR TRNG PATCHES ----------------------------
// here you can copy the generator of dynamic patches function, you got from
// output of TrngPatcher program with menu command: "Assembly->Create Dynamic Patch Generator"

// --------------- END CODE FOR TRNG PATCHES ----------------------------

// FOR_YOU: In this function you insert the callings of functions used to change tomb4 code
// You can get these functions, in the correct format, using Trng Core -> Asm Souce Editor -> Debugging menu
// program
// note: if there is a conflict the function will return "false"
// and the tomb4 program will abort with an error message
bool CreateMyCodePatches(void)
{
	// the call of the code patch to TYPE_HERE:
	// example: 
	// SET_PATCH(Path_RedirCollision)
	// to call the function Patch_RedirCollision() created with TrngPatcher program (command Assmembly->Create Dynamic Patch Generator)

	return true;
}


// FOR_YOU: In the SubPatchArray you'll type all procedure names of your code in the dll you
// wish were called from tomb4 code.
// type them in the order of ax value. So first asm proc in the list, will be called
// with ax=0, while the second in the list will be called with ax=1 ect.

void *SubPatchArray[] = {
	
// TYPE_HERE your asm procedure names to call from tomb4 code
	NULL
};

// FOR_YOU: This is your main patcher procedure.
// All your patch in tomb4 code will call this procedure passing to it, in ax register,
// the number of subpatch to call

BEGIN_ASM_PROC(MainPatcher)
	and eax, 0ffffh
	mov eax, dword ptr [SubPatchArray+eax*4];
	jmp eax
END_ASM_PROC


// --------------- END CODE FOR TOMB4 "CODE" PATCHES ----------------



// --------------------- MAIN CODE --------------------------

// thsi null funciton has been placed only to correct a bug in vc++ parsing that happens because previously (above) there was asm macro that messed 
// the compiler

void NullFunction(void){
	}

int Abs(int Value)
{
	return abs(Value);
}
// funciotn to write in append mode on a disk file (pNomeFile)
void InviaToLogFile(char *pNomeFile, char *pMessaggio)
{
	FILE *pFile;

	pFile = fopen(pNomeFile, "a");
	if (pFile == NULL) return;
	fprintf(pFile, "%s\r\n", pMessaggio);
	fclose(pFile);


}
// called everytime an item has been selected from inventory   #DRONES#
// it returns:  true, when we'll manage the item, extraxctig it from inventory
//			 false, when we don't care about this item, or when lara is not able to use it (to get the "NO" sound)
// note: I had to use "__declspec(nothrow)" spec for this  function, because il will be called by asm code and, otherwise, the eax value
// for returned value, it should have been lost
__declspec(nothrow) BOOL SelectedInventoryItem(short ItemSlot)
{
	int IncX, IncZ;
	DWORD NewX, NewZ;
	short Room;
	StrTriplePoint NewPos;
	int i;
	int ItemIndex;
	int y;
	bool TestIgnore;
	int Index;
	StrBoxCollisione * pBox;

	// se drone is not present quit
	if (BaseDrone.TestPresent == false) return false;

	// verify they were present all right condition to manage pickupitem
	Get(enumGET.LARA, 0,0);
	// correct state id e animation. About gravity affected it looks to be used in original tomb4 code, so I did the same
	if (GET.pLara->StateIdCurrent != 2 ||
		GET.pLara->AnimationNow != 103 ||
		(GET.pLara->FlagsSwapMesh & enumFITEM.GRAVITY_AFFECTED) != 0) return FALSE;
	// hands should be free
	Get(enumGET.INFO_LARA, 0,0);
	if (GET.LaraInfo.TestFreeHands == false) return FALSE;

	if (ItemSlot == BaseDrone.SlotController) {

		//  slot for pickup1 controller
		// permit to use it, only if (pickup) drone is present in the level (and not in inventory)
		if (BaseDrone.IndexPickupDrone == -1) {
			// it looks that pickup drone is missing, anyway, if there is real drone and it is enabled, let lara to take newly the control of drone
			if ((BaseDrone.DronePhase & (DP_FLYING | DP_READY))==0) return FALSE;
			// ok, let lara use controller
			// perform animation to hold controller
			ForceAnimationForLaraFromSlot(1, enumSLOT.DRONE_LARA);

			// stop further precedent quitting phases
			BaseDrone.DronePhase &= ~(DP_QUIT_DRONE_MODE | DP_LANDING |  DP_EMERGENCY_LANDING | DP_PREPARING_TO_PICKUP | DP_CHASE_TARGET | DP_REACH_Y_TARGET);
			// disable all standard key 
			// earlier, save old stop mask
			BaseDrone.OldStopMask = Trng.pGlobTomb4->KeysToStop;
			// now we stop everything
			Trng.pGlobTomb4->KeysToStop = enumCMD.ALL;
			// ececpt save game
			Trng.pGlobTomb4->KeysToStop &= ~  (enumCMD.SAVE_GAME | enumCMD.LOAD_GAME);
			
			// then we'll read the command keys from: Trng.pGlobTomb4->KeysStopped 
			// where will find the key that player hits but that has been stopped
			BaseDrone.TestStoppedKeys=true;

			return TRUE;


		}

		// perform animation to hold controller
		ForceAnimationForLaraFromSlot(1, enumSLOT.DRONE_LARA);
		BaseDrone.DronePhase |= DP_PREPARING_TO_FLY;
		// disable all standard key 
		// earlier, save old stop mask
		BaseDrone.OldStopMask = Trng.pGlobTomb4->KeysToStop;
		// now we stop everything
		Trng.pGlobTomb4->KeysToStop = enumCMD.ALL;
		// except save game
		Trng.pGlobTomb4->KeysToStop &= ~ (enumCMD.SAVE_GAME | enumCMD.LOAD_GAME);
		// then we'll read the command keys from: Trng.pGlobTomb4->KeysStopped 
		// where will find the key that player hits but that has been stopped
		BaseDrone.TestStoppedKeys=true;

		return TRUE;
	}
	if (ItemSlot == BaseDrone.PickupDroneSlot || ItemSlot == BaseDrone.PickupFullDroneSlot) {
		// slot for picup drone (full or less)
		// further check: verify that, in front of Lara, where the drone will be placed, there was no item (moveable or static)
		// and that the floor was flat
		// if above conditions are false, we'll refuse to place the drone in this caee
		// discover coordinate 256 units in front of lara 
		// we'll use a distance (256) a bit greater than required to be sure that the drone was not place too close to walls, objects ect

		// if drone is out of power, refuse the item  and show a warnign message
		if (ItemSlot != BaseDrone.PickupFullDroneSlot && BaseDrone.BatteryLevel == 0) {
			SetSizeChar();

			Index = BaseDrone.FirstStringIndex + MSG_NO_BATTERY;

			PerformFlipeffect(NULL, 425, Index, 3);			
			return FALSE;

		}
		GetIncrements(GET.pLara->OrientationH, &IncX, &IncZ, 256);
		// compute the coordinates
		NewX = GET.pLara->CordX + IncX;
		y = GET.pLara->CordY;
		NewZ = GET.pLara->CordZ + IncZ;

		Room = GET.pLara->Room;

		// verify that floor was flat
		if (CheckFloor(NewX, y, NewZ, Room)==false) {
			// if floor is invalid, surely it's not a good side where placing the drone
			return FALSE;
		}
		if (FLOOR.SlopeType != enumSLOPE.FLAT ) return false;
		// floor is flat but it has to be at same height of lara

		if (FLOOR.FloorHeight != y) {
			// It's different than y coord of Lara's feet. We cannot place the drone here.
			// we return false: there will be the "NO" for the player
			return FALSE;
		}
		// don't permit to place the drone on water
		if (FLOOR.WaterHeight != WALL_FLOOR) return false;

		// the floor is ok, but now we have to verify that there were no static or moveable in that point

		// find further moveabels in sector where we'll place the drone
		NewPos.CordX = NewX;
		NewPos.CordY = y;
		NewPos.CordZ = NewZ;

		Find(enumFIND.ITEMS_SECTOR, -1, Room, -1, 0, &NewPos);
		// verify if thre is a moveable (different than Lara, of course)
		for (i=0;i<FIND.TotItems;i++) {
			ItemIndex = FIND.VetItems[i];
			Get(enumGET.ITEM, ItemIndex, 0);

			// if this item is a creature and it has not yet been activated, ignore it
			TestIgnore=false;
			if (GET.pItem->FlagsMain & enumFITEM.CREATURE) {
				if (TriggerActive(GET.pItem)==false) TestIgnore=true;
			}

			// if this item is own real drone (but get invisible) ignore it
			if (GET.pItem->SlotID== enumSLOT.DRONE) TestIgnore=true;
			
			// if item is Lara, ignore it
			if (GET.pItem->SlotID == enumSLOT.LARA) TestIgnore=true;

			// verify if its position is very higher than floor where lara is placing the drone
			if (TestIgnore==false) {
				pBox = GetBestFrame(GET.pItem);
				if ((y-760) > (GET.pItem->CordY + pBox->MaxY)) TestIgnore=true;
			}
	
			if (TestIgnore==false) {
				// this item is an obstacle: quit returning false
				return FALSE;
			}
		}
		// ok, there was no moveable (excepting lara)
		// now we check also for static items
		Find(enumFIND.STATICS_SECTOR, -1, Room, -1, 0, &NewPos);

		for (i=0;i<FIND.TotStatics;i++) {
			Get(enumGET.STATIC, FIND.VetStatics[i].RoomIndex, FIND.VetStatics[i].ObjIndex);
			TestIgnore=false;
			// if item has no collision: ignore it
			if (GET.pStatic->OCB & 0x04) TestIgnore=true;
			// if item has been destroyued: ignore it
			if ((GET.pStatic->OCB & 0x01)==0) TestIgnore=true;
			// if item is very higher than floor where we'll place the drone, ignore it
			if ((y-760) > GET.pStatic->y) TestIgnore=true;

			if (TestIgnore==false) return false;
			

		}

		// perform animation to place on the ground the drone
		ForceAnimationForLaraFromSlot(0, enumSLOT.DRONE_LARA);
		// remove drone item from inventory
		remove_inventory_item(ItemSlot);
		// start a progressive action to monitor the animation and active the pickup drone 
		// on the ground in right moment (frame 20 of animation 1)
		Get(enumGET.PROGRESSIVE_ACTION, 0,0);
		GET.pAction->ActionType = AXN_PUT_PICKUP_DRONE;
		// save the absolute animation index (just forced in lara, so just reading the value in pLara)
		GET.pAction->Arg1 = GET.pLara->AnimationNow;
		// and the frame index of animation 1 in DRONE_LARA when she leave the drone
		Get(enumGET.SLOT, enumSLOT.DRONE_LARA,0);
		// set frame index when lara will place drone on the ground
		GET.pAction->Arg2 = PROF_FRAME_LEAVE_DRONE;
		// if the picked up item, was the (fully charged) drone, set at max level the battery
		if (ItemSlot  == BaseDrone.PickupFullDroneSlot) {
			BaseDrone.BatteryLevel = BaseDrone.BatteryMinutes * 60 * 30;
			BaseDrone.DronePhase &= ~(DP_LOST_DRONE | DP_NO_BATTERY);
			RemoveMSG(MSG_LOW_BATTERY);
			RemoveMSG(MSG_LOST_DRONE);
			RemoveMSG(MSG_NO_BATTERY);
		}

		return TRUE;
	}
	
	return FALSE;
}
// TYPE_HERE: your callback function


// my callback when there is patch 53h
// in  4AC064h  //  ;ItemChosenFromInventory there will be slot of item selected in inventory (or 0xffff (-1) if no item has been selected)
// as return value:
// eax = 1  item has been used ( by my patch)
// eax = 0 ignored
int MyRetValueForPatch53;

BEGIN_ASM_PROC(cbMyPatch53)
          pushad
		  mov eax, 4AC064h  //  ;pInventoryChosenItem
		  mov cx, word ptr [eax]
		  // since I saved (and thren will restore register values (with pushad/popad) but I need to change eax register value
		  // I'll use a global variable "MyRetValueForPatch55" to let a different value for eax register
		  mov dword ptr [MyRetValueForPatch53], 0
		  cmp cx, 0ffffh
		  jz QuitNoItem

		  // pass the selected slot to my c++ function to handle (in more comfortable way) this job
		  push ecx
		  call SelectedInventoryItem
		  add esp, 4 
		  // save the return value (true/false) to return it to main code of tomb4
		  mov dword ptr [MyRetValueForPatch53], eax
		  cmp al, 0
		  jz QuitNoItem
		  // returned true: disable the "NO" sound
			mov eax, 7FE924h    ;TestSelectedAnItem
			mov byte ptr [eax], 0
			mov eax, 4AC064h  //  ;pInventoryChosenItem
			mov dword ptr [eax], -1

QuitNoItem:
		  popad
		// let a return value for eax
		mov eax, dword ptr [MyRetValueForPatch53]
          retn
END_ASM_PROC
void cbInitProgram(int NumberLoadedPlugins, char *VetPluginNames[]) 
{

	// save number of plugins (enclosed yours and the tomb_nextgeneration.dll ) and their names
	// these data will be used to locate IDs of any loaded plugins using FindPluginID() function
	Trng.TotPlugins = NumberLoadedPlugins;
	Trng.pVetPluginNames = VetPluginNames;

	// clear all my global variables
	ClearMemory(&MyData, sizeof(StrMyData));
}


void cbInitGame(void)
{
	// here you can initialize your global data for whole adventure
	// this procedure will be called only once, before loading title level
	// initiliaze BaseDrone structure
	memset(&BaseDrone, 0, sizeof(StrBaseDrone));
	BaseDrone.IndexPickupDrone=-1;

}
// only for #debug# show data about two skeleton to kill, items with ngle indices 977 and 978
void LogSkeleton(void)
{
	int Index;
	StrItemTr4 *pSkel977;
	StrItemTr4 *pSkel978;

	Index = Convert(enumCONV.ItemIndexFromNgleToTomb, 977,0, NULL);
	if (Index==-1) return;

	if (Get(enumGET.ITEM, Index,0)==false) return;
	pSkel977 = GET.pItem;

	Index = Convert(enumCONV.ItemIndexFromNgleToTomb, 978,0, NULL);
	if (Index==-1) return;

	if (Get(enumGET.ITEM, Index,0)==false) return;
	pSkel978 = GET.pItem;

	LogOnDebug("Skel977 Anim=%d  ;  Skel978 Anim=%d",
		Convert(enumCONV.AnimIndexFromAbsToRelative, pSkel977->AnimationNow ,0,pSkel977),
		Convert(enumCONV.AnimIndexFromAbsToRelative, pSkel978->AnimationNow, 0, pSkel978));

}
// little function to verify se Slot is an inventory item
bool IsInventorySlot(int Slot)
{
	if (Slot < enumSLOT.PUZZLE_ITEM1 || Slot >= enumSLOT.SWITCH_TYPE1 )  return false;
	return true;

}

void SetDroneVisibility(bool TestVisible)
{
	Get(enumGET.SLOT, enumSLOT.DRONE,-1);
	if (TestVisible==true) {
		GET.pSlot->pProcDraw = (void *) 0x44F600; // DrawAnimatingItem
		BaseDrone.TestVisibleRealDrone = true;
	}else {
		GET.pSlot->pProcDraw = NULL;
		BaseDrone.TestVisibleRealDrone = false;
	}

}
// transform the pickup drone in real drone and start animation to open arms
void TransformPickupToRealDrone(void)
{
	StrItemTr4 *pRealDrone;

	// copy in real drone coordinates and facing of pickup drone
	Get(enumGET.ITEM, BaseDrone.IndexRealDrone, -1);
	pRealDrone = GET.pItem;


	LogOnDebug("TransformPickupToRealDrone() Old Position RealDrone: x=%d y=%d z=%d Room=%d", 
			pRealDrone->CordX, pRealDrone->CordY, pRealDrone->CordZ, pRealDrone->Room );

	// get struicture of pickup drone
	Get(enumGET.ITEM, BaseDrone.IndexPickupDrone, -1);

	pRealDrone->CordX  = GET.pItem->CordX;
	pRealDrone->CordY  = GET.pItem->CordY;
	pRealDrone->CordZ  = GET.pItem->CordZ;
	pRealDrone->OrientationH = GET.pItem->OrientationH;
	pRealDrone->HeightFloor = GET.pItem->HeightFloor;
	// now we cannot change immediately the room, we have to
	// update the items in old room before to be able to move the real drone
	// in a new room
	ForceNewRoomForItem(BaseDrone.IndexRealDrone , GET.pItem->Room );



	// now we get newly visible the real drone
	SetDroneVisibility(true);
	// dispaly shadow
	DisplayShadow(pRealDrone, true);

	// now we have to remove the piclupdrone
	KillItem(BaseDrone.IndexPickupDrone);
	BaseDrone.IndexPickupDrone=-1;


	// and finally we force (for real drone) the animation to open the arms
	// with animation 5
	ForceAnimationForItem(pRealDrone, 5, -1);

	BaseDrone.DronePhase |= DP_PREPARING_TO_FLY;
	BaseDrone.DronePhase &= ~(DP_NO_DRONES | DP_DRONE_PICKUP);
	RemoveLastMessages();
}

void RemoveLastMessages(void)
{
	// remove furtherly message of previous flight, like "landing, low signal, recovery last safe position" that should be useless, when
	// we are going to start a new flight
	BaseDrone.DronePhase &= ~(DP_LANDING | DP_RETURN_TO_HOME | DP_REBOUND_ON_IMPACT | DP_NO_SIGNAL | DP_FAILURE |
									DP_RECOVERING_SAFE_POSITION | DP_EMERGENCY_LANDING | DP_CRASH_IN_PROGRESS);
	RemoveMSG(MSG_LOW_SIGNAL);
	RemoveMSG(MSG_EMERGENCY_LANDING);
	RemoveMSG(MSG_RETURN_TO_HOME);
	RemoveMSG(MSG_LOOKING_FOR_LANDING);
	RemoveMSG(MSG_OBSTACLE);
	RemoveMSG(MSG_LANDING);
	RemoveMSG(MSG_SAFE_RECOVERY);
	RemoveMSG(MSG_FAILED_OPERATION);
	RemoveMSG(MSG_FALLING_DOWN);
	RemoveMSG(MSG_IMPACT);
	RemoveMSG(MSG_NO_BATTERY);

}
// transfrom the real drone (with index in BaseDrone) in pickup item and return the index of this pickup
int TransformDroneToPickUp(WORD OcbValue)
{
	StrItemTr4 *pRealDrone;
	DWORD x, z;
	int y;
	short Room;
	int IndexPickup;
	int PickupSlot;
	int i;


	LogOnDebug("TransformDroneToPickup()");

	Get(enumGET.ITEM, BaseDrone.IndexRealDrone, -1);

	pRealDrone = GET.pItem;

	x = pRealDrone->CordX;
	y = pRealDrone->CordY+PROF_GAP_OVER_FLOOR;
	z = pRealDrone->CordZ;
	Room = pRealDrone->Room;
	// choose the kind of pickup slot, in according with currnet battery level
	if (BaseDrone.BatteryLevel == (BaseDrone.BatteryMinutes * 60 * 30)) {
		PickupSlot= BaseDrone.PickupFullDroneSlot;
	}else {
		PickupSlot = BaseDrone.PickupDroneSlot;
	}

	IndexPickup = CreateNewMoveable(PickupSlot, x,y,z, Room);	

	Get(enumGET.ITEM, IndexPickup,-1);

	GET.pItem->OcbCode = OcbValue;

	// copy also facing
	GET.pItem->OrientationH = pRealDrone->OrientationH;
	GET.pItem->OrientationT = 0;
	GET.pItem->OrientationV = 0;
	GET.pItem->Intensity1 = 0x0c210;

	// now disable real drone
	SetDroneVisibility(false);


	// set to have reached drone pickup target, preserving further quit mode
	// if there was (testual) help showed quit now:
	if (BaseDrone.DronePhase & DP_HELP_IN_PROGRESS) {
		i=BaseDrone.FirstStringIndex + MSG_HELP_TEXT;
		PerformFlipeffect(NULL, 204, i, 0);
	}
	// verify now if real drone was on water surface (useful only at start of level, when the DP_FLOATING is not yet
	// set but the level builder could have placed the drone on water
	CheckFloor(pRealDrone->CordX, pRealDrone->CordY, pRealDrone->CordZ, pRealDrone->Room);

	if (FLOOR.WaterHeight != WALL_FLOOR) {
		// there is water below the drone, enable the floating phase
		BaseDrone.DronePhase |= DP_FLOATING;
		
	}

	// if the drone was floating on the water: disable the shadow for pickyp drone
	if (BaseDrone.DronePhase & DP_FLOATING) {
		DisplayShadow(GET.pItem, false);
		BaseDrone.FloatIncRotT = PROF_FLOAT_SWING_SPEED;
		BaseDrone.FloatIncRotV = -(PROF_FLOAT_SWING_SPEED / 2);
		BaseDrone.FloatingIncY = PROF_FLOATING_VSPEED;

	}else {
		DisplayShadow(GET.pItem, true);
	}

	// clear all previous phases, with exception for quit drone and floating
	BaseDrone.DronePhase &=  (DP_QUIT_DRONE_MODE | DP_FLOATING);
	// and add drone pickup
	BaseDrone.DronePhase |= DP_DRONE_PICKUP;
	return IndexPickup;
}

int GetParamFromSlot(int RealSlot)
{
	int i;

	i=0;

	while (Trng.pGlobTomb4->VetInventory[i] != -1) {
		if (RealSlot== Trng.pGlobTomb4->VetInventory[i]) return i;
		i++;
	};
	// not found
	SendToLog("ERROR: cannot locate the parameter index for %d slot", RealSlot);

	return -1;
}
// this function will be called by tomb4 when the player select Battery and set the command to combine with drone
// if TestDivide == true it means that player wants divide full drone from battery but we'll not allow that
void RechargeDrone(bool TestDivide)
{
	short Parameter;
	// since we set only this rule with this function (RechargeDrone), we have no need to read rule-list to discover the items to change
	//		we already know them
	
	// now we have to reduce the amount of batteries
	// we use flipeffect 49 to reduce the amount of battery 
	// remark: flipeffect about inventory (of ngle) use a different index list, so we have to convert the real slot
	// in the index used as parameter for these flipeffect
	Parameter = GetParamFromSlot(BaseDrone.SlotBattery);
	PerformFlipeffect(NULL, 49, Parameter, 0);

	// now we remove the empty drone with flipeffect 47
	Parameter = GetParamFromSlot(BaseDrone.PickupDroneSlot);
	PerformFlipeffect(NULL, 47, Parameter, 0);

	// and, finally, we create a full drone item with flipeffect 50
	Parameter = GetParamFromSlot(BaseDrone.PickupFullDroneSlot);
	PerformFlipeffect(NULL, 50, Parameter, 1);
}

// other the combine-rule list, there is a list to detect what items could have the status of combinable
// this function the SlotInvItem in this list
void AddCombinableStatus(WORD SlotInvItem)
{
	int i;

	// se era gia' stato memorizzato uscire subito
	for (i=0;i<Trng.pGlobTomb4->TotCombinabili;i++) {
		if (SlotInvItem == Trng.pGlobTomb4->VetCombinabili[i]) return;
	}

	if (Trng.pGlobTomb4->pAdr->pVetFlagsInventoryItems[SlotInvItem] & FINV_COMBINE) return;

	// ok, salvarlo
	i = Trng.pGlobTomb4->TotCombinabili;
	Trng.pGlobTomb4->VetCombinabili[i] = SlotInvItem;
	Trng.pGlobTomb4->TotCombinabili++;

}
// perform a sort of CombineItem= script command to get the rule that "battery can be combined with discharged
// drone to get a full drone
// 
void CreateCombineItem(short SlotBattery, short SlotEmptyDrone, short SlotFullDrone)
{
	StrCombine *pCombine;
	short InvBattery;
	short InvEmptyDrone;
	short InvFullDrone;
	bool TestNewRecord;

	// the inventory items have (in tomb4 code) a differnt slot index, so now we convert them
	InvBattery = convert_obj_to_invobj(SlotBattery);
	InvEmptyDrone = convert_obj_to_invobj(SlotEmptyDrone);
	InvFullDrone = convert_obj_to_invobj(SlotFullDrone);

	// set as "combinable" the battery and InvEmptyDrone
	AddCombinableStatus(InvBattery);
	AddCombinableStatus(InvEmptyDrone);

	// now we check in combine-rule list (of tomb4 code) to find right record where set our new nule

	pCombine = &Trng.pGlobTomb4->pAdr->pVetNewCombine[0];
	// the list of rules ends with a record that has pProcecure field == NULL
	while (pCombine->pProcedura != NULL) {
		// if there was already a rule for our battery item, we'll use that
		if (pCombine->PrimoItem == InvBattery) break;

		pCombine++;
	};

	// now we have to remember if this (pCombine) was a new record (at end of the list) or an old record that we are going to overwrite
	TestNewRecord=false;
	if (pCombine->pProcedura == NULL) TestNewRecord=true;
	// now we insert data for our rule
	pCombine->PrimoItem = InvBattery;
	pCombine->SecondoItem = InvEmptyDrone;
	pCombine->ItemFinale = InvFullDrone;
	// set specific flags for these inventory items
	Trng.pGlobTomb4->pAdr->pVetFlagsInventoryItems[pCombine->PrimoItem] = FINV_COMBINE | FINV_USE;
	Trng.pGlobTomb4->pAdr->pVetFlagsInventoryItems[pCombine->SecondoItem] = FINV_USE;
	Trng.pGlobTomb4->pAdr->pVetFlagsInventoryItems[pCombine->ItemFinale] = FINV_USE;
	// now we set the procedure that will becalled,  when there will be the combine command
	pCombine->pProcedura = &RechargeDrone;

	// if we had added a new record, now we have to add, after it, an empty record as "end-list" signal
	if (TestNewRecord == true) {
		pCombine++;
		pCombine->pProcedura = NULL;
	}

}

// I had to use this function to get ng strings, because the Get(enumGEY.StringNg..) function never return "false". When the string is misisng, 
// it will return a string with message like "Missing string with index...", that is very useful to discover a missing string but in drone
// managmeent there is the chance to omit a string to avoid to see that displayed, and in this case it should be bad to see the "missing string" message
// below function return a NULL pointer when the string is missing
char *LocateNGString(int Index)
{
	int i;

	Index &= 0x7fff;

	// stringa NG
	for (i=0;i<Trng.pGlobTomb4->TotExtraStrings;i++) {
		if (Trng.pGlobTomb4->VetExtraStrings[i].Indice == Index) {
			return Trng.pGlobTomb4->VetExtraStrings[i].pTesto;

		}
	}

	return NULL;

}
// perfomrmed at begin of each level, it will be set right value in BaseDrone structure and it will allocate required global data
void InitializeDroneData(int LevelNow)
{

	// it will be called only once for level, when all items has been already initialized
	// and just a moment before entering in main game cycle.
	int i;
	int j;
	WORD OcbValues;
	short Value;
	bool TestLevelNow;
	StrSavePickupDrone *pPick;
	StrItemTr4 *pDrone;

	// we have to verify if the level started with new game or with a load game operation
	// in this second case, we'll have nothing to initialise because BaseDrone data will have already correct data, taken from savegame
	// anyway, about the index of real drone we'll have to get it dynamically, because we cannot use the index from previous level
	// (in the case of a level jump with lara target)

	// first we verify if in this level there is the DRONE slot, otherwise it could be title level or
	// another level without drone
	Get(enumGET.SLOT, enumSLOT.DRONE, -1);

	// in the case the slot was missing we quit avoiding error messages
	if ((GET.pSlot->Flags & enumFSLOT.PRESENT)==0) return;

	// looking for the real drone 
	for (i=0;i< *Trng.pGlobTomb4->pAdr->pTotItems ;i++) {
		Get(enumGET.ITEM, i, -1);
		if (GET.pItem->SlotID == enumSLOT.DRONE) break;
	}

	if (i == *Trng.pGlobTomb4->pAdr->pTotItems) {
		// real drone is missing
		SendToErrorLog(false, "ERROR: missing Drone (slot=%d) item in the level map", enumSLOT.DRONE);
		BaseDrone.TestPresent=false;
		return;
	}
	// save the index and the ocb values of drone (to tranfer them to pickup drone)
	BaseDrone.IndexRealDrone= i;
	pDrone= GET.pItem;
	// verify if there is a secon drone in the level
	for (j=i+1; j < *Trng.pGlobTomb4->pAdr->pTotItems;j++) {
		Get(enumGET.ITEM, j, -1);
		if (GET.pItem->SlotID == enumSLOT.DRONE) {
			SendToLog("ERROR: found another real drones in current level. The drone in %d room will be ignored while it will be used only the drone in %d room",
				GET.pItem->Room, pDrone->Room);
			
		}
	}

	// if drone has OCB_RESET_HUB ocb flag, reset from scratch alla data, like this was first level with drone
	if (pDrone->OcbCode & OCB_RESET_HUB) {
		TestLoadedLocalData=false;
		BaseDrone.TestJustLoaded=false;
	}

	if (TestLoadedLocalData == true) {
		BaseDrone.IndexPickupDrone = MyData.Save.Local.PickupData.Index;
	}else {
		BaseDrone.IndexPickupDrone =-1;
	}
	

	// use BaseDrone just loaded only if it was of current level
	if (BaseDrone.TestJustLoaded == true) {
		// there was BaseDrone in savegame or level hub, anyway we have to check if data were for this level or less
		TestLevelNow=false;
		if (BaseDrone.LevelNow == LevelNow) TestLevelNow=true;

		// data of drone has been already restored from load game or jump level with hub, proocedure


		BaseDrone.TestJustLoaded=false;
		BaseDrone.TestStartedSaveLoadGame =false; // it could have been "true" for load savegame panel

		BaseDrone.TestSuspendAction =false;
		BaseDrone.TestSuspendEnter =false;
		BaseDrone.TestSuspendInventory=false;

		// allocate the new extra strigns
		BaseDrone.IndexStringBattery = CreateNewExtraString("",-1);
		BaseDrone.IndexStringCompass = CreateNewExtraString("",-1);
		BaseDrone.IndexStringDistance = CreateNewExtraString("", -1);
		BaseDrone.IndexStringHeight = CreateNewExtraString("", -1);
		BaseDrone.IndexStringSignal = CreateNewExtraString("", -1);
		BaseDrone.IndexStringWarnings = CreateNewExtraString("", -1);

		if (BaseDrone.Flags & DRF_USE_BATTERIES) {
			// create combine item between battery and drone
			CreateCombineItem(BaseDrone.SlotBattery, BaseDrone.PickupDroneSlot, BaseDrone.PickupFullDroneSlot);
		}
		// if the keys were disabled (lara was holding the controller) then we have to stop newly the keyboard
		if (TestLevelNow==true) {
			// data to use/analyse only when they were for current level
			RemoveWarningsTelemetry();
			TestLoadedLocalData=false;
			if (BaseDrone.TestStoppedKeys==true) {
				Trng.pGlobTomb4->KeysToStop = enumCMD.ALL;
				Trng.pGlobTomb4->KeysToStop &= ~(enumCMD.LOAD_GAME | enumCMD.SAVE_GAME);
				ShowMessage(true, MSG_READY, 2, NULL);
				EnableWarningsTelemetry();
			}
			// only operation to perform in this case, is to verify if the real drone has to be visible or less
			SetDroneVisibility(BaseDrone.TestVisibleRealDrone);
			// if, in the moment when it has been save the savegame (that now it has been just loaded) there were
			// string on the screen (telemetry ok) we have to refresh the strings, removing and reupdating them
			if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE || BaseDrone.ViewCamNow == VIEW_CAM_CHASE_DRONE) {
				RemoveTelemetry();
				// then, in game, it will be newly reenabled but we have to be sure that, also that, a warning message, was immeditaly
				// displayed, to set correct positional formatter
				// so we have to set a message immediately
				ShowMessage(true, MSG_READY, 2, NULL); // only two frames of durate
			}

		}else {
			// if there was no BaseDrone for this level (actual situaiton in this "else"
			// this means that we are just arrived in this level with a jump and surely drone was not flying
			// so we have to initialize some data
			BaseDrone.DronePhase = 0;
			BaseDrone.ViewCamNow= VIEW_NO_CAM;
			BaseDrone.ViewCamOld= VIEW_NO_CAM;
			BaseDrone.CollisionItemIndex =-1;
			BaseDrone.LevelNow = LevelNow;
			BaseDrone.SpeedNow.Speed =0;
			BaseDrone.SpeedOld.Speed =0;
			BaseDrone.TestCollision =false;
			BaseDrone.TestOldCollision =false;
			BaseDrone.TestStoppedKeys=false;
			BaseDrone.TotMessages =0;
			BaseDrone.TestPresent =true;
			// allocate the camera to handle different cam views
			BaseDrone.IndexCamera = CreateNewCamera();
			PerformActionTrigger(NULL, 43, BaseDrone.IndexRealDrone , 0);

			// set invisible real drone (becaue, if we are just came in a (new)level (the basedrone was not of this level) it's not possible
			// that the drone was flying and therefor the real drone has to be invisible 
			SetDroneVisibility(false);

			// if there are local data for pickup drone, create it now
			if (TestLoadedLocalData==true) {
				TestLoadedLocalData=false;
				
				pPick = &MyData.Save.Local.PickupData;

				if (pPick->Index != -1) {
					// there was pickup in this level (so, not in invnetory but placed somewhere)

					BaseDrone.DronePhase |= DP_DRONE_PICKUP;
					BaseDrone.DronePhase &= ~DP_NO_DRONES;
					// it's' necessary create it because in HUB of savegame, tomb4 saves only flare and torch, not other (created) items
					BaseDrone.IndexPickupDrone = CreateNewMoveable(pPick->SlotId , 
													pPick->CordX ,pPick->CordY ,pPick->CordZ , pPick->Room );	

					Get(enumGET.ITEM, BaseDrone.IndexPickupDrone,-1);
					pDrone = GET.pItem;

					// copy also facing
					pDrone->OrientationH = pPick->HOrient;
					pDrone->OrientationT = 0;
					pDrone->OrientationV = 0;
					pDrone->Intensity1 = 0x0c210;
					
					// verify now if pickup drone was on water surface 
					CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room);


					if (FLOOR.WaterHeight != WALL_FLOOR) {
						// there is water below the drone, enable the floating phase
						BaseDrone.DronePhase |= DP_FLOATING;
		
					}

					// if the drone was floating on the water: disable the shadow for pickyp drone
					if (BaseDrone.DronePhase & DP_FLOATING) {
						DisplayShadow(pDrone, false);
						// initialize data for simulation of floating
						BaseDrone.FloatIncRotT = PROF_FLOAT_SWING_SPEED;
						BaseDrone.FloatIncRotV = -(PROF_FLOAT_SWING_SPEED / 2);
						BaseDrone.FloatingIncY = PROF_FLOATING_VSPEED;

					}else {
						// it it was not on water surface, enable shadow
						DisplayShadow(pDrone, true);
					}
				}

			}
		}

		return;
	}
	// we start from new level.
	// we have to set all drone stuff
	TestLoadedLocalData=false;



	// look for the CUST_DRONE
	if (Get(enumGET.MY_CUSTOMIZE_COMMAND, CUST_DRONE, -1)==false) {
		// CUST_DRONE is missing: abort
		SendToErrorLog(false, "ERROR: missing the CUST_DRONE customize= script command. The drone will not work");
		return;
	}

	// if customize has less argument than requird, giving another error
	if (GET.pCust->NArguments != ARG_AMOUNT) {
		SendToErrorLog(false, "ERROR: wrong number of arguments (%d) in CUSTOMIZE=CUST_DRONE command.", GET.pCust->NArguments);
		return;
	}

	// loading in BaseDrone all data from customize


	// if value of parameter is -1 (= IGNORE), set the default value for that field
	Value=GET.pCust->pVetArg[ARG_Flags];
	if (Value == -1) Value=0;
	BaseDrone.Flags = Value;
	
	Value = GET.pCust->pVetArg[ARG_CamViewFlags];
	if (Value == -1) Value=VIEW_CAM_ALL;
	BaseDrone.ViewFlags = Value;

	Value=GET.pCust->pVetArg[ARG_BatteryTime];
	if (Value == -1) Value = 5;
	BaseDrone.BatteryMinutes = Value;

	Value=GET.pCust->pVetArg[ARG_MaxDistance];
	if (Value == -1) Value=50;
	BaseDrone.MaxDistance = Value;

	BaseDrone.SpriteCmdId = GET.pCust->pVetArg[ARG_SpriteCmdId];

	// other parameters where it's not allowed an IGNORE value
	BaseDrone.SlotController = GET.pCust->pVetArg[ARG_ControllerPickupSlot];
	BaseDrone.SlotBattery = GET.pCust->pVetArg[ARG_BatteryPickupSlot];
	BaseDrone.PickupDroneSlot = GET.pCust->pVetArg[ARG_DronePickupSlot];
	BaseDrone.PickupFullDroneSlot = GET.pCust->pVetArg[ARG_DroneFullPickupSlot];
	BaseDrone.FirstStringIndex = GET.pCust->pVetArg[ARG_FirstDroneExtraString];
	BaseDrone.HelpImageIndex = GET.pCust->pVetArg[ARG_HelpImageIndex];
	BaseDrone.MaskImageIndex = GET.pCust->pVetArg[ARG_MaskImageIndex];
	BaseDrone.Extra1 = GET.pCust->pVetArg[ARG_Extra1];
	BaseDrone.Extra2 = GET.pCust->pVetArg[ARG_Extra2];

	// save current level
	BaseDrone.LevelNow = LevelNow;

	// mamager further IGNORE or wrong values
	if (IsInventorySlot(BaseDrone.PickupDroneSlot) == false) {
		SendToErrorLog(false, "ERROR: Invalid slotId (%d) for pickup drone", BaseDrone.PickupDroneSlot );
		return;
	}

	if (IsInventorySlot(BaseDrone.SlotController) == false) {
		SendToErrorLog(false, "ERROR: Invalid slotId (%d) for controller item", BaseDrone.SlotController );
		return;
	}

	if (BaseDrone.Flags & DRF_USE_BATTERIES) {
		if (IsInventorySlot(BaseDrone.SlotBattery) == false) {
			SendToErrorLog(false, "ERROR: Invalid slotId (%d) for controller item (%d)", BaseDrone.SlotController);
			return;
		}
		// if different than puzzle_item, it will be not possible having more than one battery
		if (BaseDrone.SlotBattery < enumSLOT.PUZZLE_ITEM1 || BaseDrone.SlotBattery > enumSLOT.PUZZLE_ITEM12) {
			SendToErrorLog(false, "WARNING: for battery item you chose a slot (%d) that cannot be increased in inventory", BaseDrone.SlotBattery );
		}

		if (IsInventorySlot(BaseDrone.PickupFullDroneSlot) == false) {
			SendToErrorLog(false, "ERROR: invalid value (%d) for (full) pickup drone SLOT", BaseDrone.PickupFullDroneSlot);
			return;
		}
	}else {
		// if it has not been enabled the battery usage, then we'll set as PickupFullDroneSlot the same slot for not full drone
		BaseDrone.PickupFullDroneSlot = BaseDrone.PickupDroneSlot;
		
	}

	if ((BaseDrone.ViewFlags & VIEW_CAM_ALL) == 0) {
		SendToErrorLog(false, "ERROR: you have to set at least one kind of VIEW_ for the drone");
		return;

	}

	if (BaseDrone.BatteryMinutes < 1) {
		SendToErrorLog(false, "ERROR: invalid amount for Batterytime. You have to set at least one minute");
		return;
	}
	if (BaseDrone.Flags & DRF_USE_BATTERIES) {
		// create combine item between battery and drone
		CreateCombineItem(BaseDrone.SlotBattery, BaseDrone.PickupDroneSlot, BaseDrone.PickupFullDroneSlot);
	}
	// set max levle of battery
	BaseDrone.BatteryLevel = BaseDrone.BatteryMinutes * 60 * 30;
	BaseDrone.PercBattery = 100.0f;
	BaseDrone.PercSignal = 100.0f;

	BaseDrone.LastSafePoint.Room = -1; // signal that it has not yet been saved a valid safe position
	BaseDrone.PickedUpKey = -1; // picked up item (-1, not yet picked up anything)

	// management of ocb (real drone, first time in the adventure)
	OcbValues = pDrone->OcbCode;
	pDrone->OcbCode=0;

	// verify if we have to set 0 battery
	if (OcbValues & OCB_SET_EMPTY_BATTERY) {
		BaseDrone.BatteryLevel = 0;
		BaseDrone.DronePhase |= (DP_NO_BATTERY | DP_LOST_DRONE);

	}

	// pass the ocb code of real drone to the pickup drone (that we are going to creatre)

	// now we active the drone using the action 43 (as exported funtion, get from ngle, trigger window)
	// note: until the read drone item is not active, the control procedure of the drone will now be
	// performed, and we need that works always
	PerformActionTrigger(NULL, 43, BaseDrone.IndexRealDrone , 0);

	// now create a pickup drone in same position and disable (get not active) the real drone
	OcbValues &= OCB_MASK_FOR_PICKUP;

	BaseDrone.IndexPickupDrone = TransformDroneToPickUp(OcbValues);
	

	// ok, drone is present with all its stuff
	BaseDrone.TestPresent=true;
	// allocate resources for drone
	// the camera to handle different cam views
	BaseDrone.IndexCamera = CreateNewCamera();
	// some new extra strings to host elaborated string with distance,height, signal ect.
	// at start we set random texs, then we'll type correct values in dynamic way

	
	BaseDrone.IndexStringBattery = CreateNewExtraString("",-1);
	BaseDrone.IndexStringCompass = CreateNewExtraString("",-1);
	BaseDrone.IndexStringDistance = CreateNewExtraString("", -1);
	BaseDrone.IndexStringHeight = CreateNewExtraString("", -1);
	BaseDrone.IndexStringSignal = CreateNewExtraString("", -1);
	BaseDrone.IndexStringWarnings = CreateNewExtraString("", -1);

	BaseDrone.UserChangeDistance  = 0;
	BaseDrone.UserChangeWalls =0;
	BaseDrone.UserMsgIndex =-1;

}

// here you can initialize specific items of currnet level.
void cbInitLevel(int LevelNow, int LevelOld, DWORD FIL_Flags)
{
	InitializeDroneData(LevelNow);

	
}

// called everytime player save the game (but also when lara move from a level to another HUB saving). 
// in this procedure your plugin will save its own data in savegame
// SavingType inform about the kind of saving it is happening (SAVT_... values)
// pAdrZone is a byte pointer where this procedure will save the address from where begin data to save in savegame
// this function will return the size of data to save
// note: It's better you don't change anything of this code. It will save byself of data you stored in MyData.Save
// structure. If you wish adding other variables to save, just you add new fields in Structures of MyData.Save 
DWORD cbSaveMyData(BYTE **pAdrZone, int SavingType)
{
	DWORD SizeData;
	int i;
	static WORD *pVetExtras;
	int TotNWords;
	int TotNewActions;
	StrSavePickupDrone *pPickup;

	if (SavingType & SAVT_COMPLETED) {
		// this call is not to save data but only it is a confirm that the previous saving has been completed
		// now we can free the temporary memory used to save the data in previous call
		if (pVetExtras != NULL) {
			FreeMemory(pVetExtras);
			pVetExtras=NULL;
		}

		return 0;
	}

	// copy the current BaseDrone data to MyData.SaveData
	memcpy(&MyData.Save.Global.SaveDrone  , &BaseDrone, sizeof(StrBaseDrone));


	TotNWords=0;
	pVetExtras = (WORD *) GetMemory(16);
	// save id of my plugin in first word

	pVetExtras[TotNWords++] = Trng.IdMyPlugin;

	if (SavingType & SAVT_LOCAL_DATA) {
		// save local data
		// save data about pickup item (olny for local section)
		pPickup = &MyData.Save.Local.PickupData;

		pPickup->Index  = BaseDrone.IndexPickupDrone;
		// if pickup drone is present, save also its position
		if (pPickup->Index != -1) {
			Get(enumGET.ITEM, pPickup->Index , 0);
			pPickup->CordX = GET.pItem->CordX;
			pPickup->CordY = GET.pItem->CordY;
			pPickup->CordZ = GET.pItem->CordZ;
			pPickup->Room = GET.pItem->Room;
			pPickup->HOrient = GET.pItem->OrientationH;
			pPickup->SlotId = GET.pItem->SlotID;	// save also slot, because there are two pickable drones: with full battery or less
		}

		// save Local structure
		AddNGToken(NGTAG_LOCAL_DATA, NO_ARRAY, sizeof(StrSavegameLocalData), &MyData.Save.Local, 
						&pVetExtras, &TotNWords);


		// save all (currently enabled) progressive actions
		// before saving, compact progressive action array to remove intermediate free records
		TotNewActions=0;

		for (i=0;i<MyData.TotProgrActions;i++) {
			if (MyData.VetProgrActions[i].ActionType != AXN_FREE) {

				MyData.VetProgrActions[TotNewActions] = MyData.VetProgrActions[i];

				TotNewActions++;
			}
		}
		// update new valuese after recompatting
		MyData.LastProgrActionIndex =0;
		MyData.TotProgrActions= TotNewActions;

		// store all progressive action records
		AddNGToken(NGTAG_PROGRESSIVE_ACTIONS, MyData.TotProgrActions, sizeof(StrProgressiveAction), 
				&MyData.VetProgrActions[0], &pVetExtras, &TotNWords);

	}

	if (SavingType & SAVT_GLOBAL_DATA) {
		// save global data
		AddNGToken(NGTAG_GLOBAL_DATA, NO_ARRAY, sizeof(StrSavegameGlobalData), &MyData.Save.Global , 
						&pVetExtras, &TotNWords);
	}
	// write final sequence
	AddTokenFinalSequence(&pVetExtras, &TotNWords);

	// return to trng the infos about start of memory where there are our data and their size:
	*pAdrZone = (BYTE *) pVetExtras;
	SizeData = TotNWords * 2;

	return SizeData;
	

}
// called when a savegame will be loaded (but also when lara move from a level to another)
// pAdrZone will point to memory zone with data just loaded from savegame
// SizeData is the size of data pointed by pAdrZone
// note: it's better you don't change anything of this code. It's alread thought to reload all data you saved in MyData.Save 
// structure. There is no need of changes by you
void cbLoadMyData(BYTE *pAdrZone, DWORD SizeData)
{

	WORD *pVetExtras;
	StrParseNGField  ParseField;
	int Indice;
	int i;
	WORD TotActions;

	
	pVetExtras = (WORD*) pAdrZone;

	Indice=0;

	while (ParseNgField(pVetExtras ,Indice, &ParseField)==true) {
		
		// recover different ng token
		switch (ParseField.Type) {
		case NGTAG_LOCAL_DATA:
			// local data
			memcpy(&MyData.Save.Local, ParseField.pData, sizeof(StrSavegameLocalData));
			TestLoadedLocalData=true;
			break;

		case NGTAG_GLOBAL_DATA:
			// global data
			memcpy(&MyData.Save.Global, ParseField.pData, sizeof(StrSavegameGlobalData));
			// now we update our BaseDrone structure
			memcpy(&BaseDrone, &MyData.Save.Global.SaveDrone  , sizeof(StrBaseDrone));
			// signal that there has been a loading from savegmae
			BaseDrone.TestJustLoaded=true;
			break;
			
		case NGTAG_PROGRESSIVE_ACTIONS:
			// progressive actions
			i= ParseField.StartDataIndex;
			// read tot actions value
			TotActions = pVetExtras[i++];
			// copy all tot records
			memcpy(&MyData.VetProgrActions[0], &pVetExtras[i], sizeof(StrProgressiveAction) * TotActions);
			MyData.TotProgrActions = TotActions;
			break;
		}
		Indice= ParseField.NextIndex; 
	}

}
// free memory used to store all data about your customize commands loaded in previous level
void FreeMemoryCustomize(void)
{
	int i;

	for (i=0;i<MyData.BaseCustomizeMine.TotCustomize;i++) {
		FreeMemory(MyData.BaseCustomizeMine.pVetCustomize[i].pVetArg);
	}

	if (MyData.BaseCustomizeMine.TotCustomize > 0) {
		FreeMemory(MyData.BaseCustomizeMine.pVetCustomize);
		MyData.BaseCustomizeMine.TotCustomize=0;
	}


	MyData.BaseCustomizeMine.pVetCustomize=NULL;
}

// free memory used to store all data about your parameters commands loaded in previous level
void FreeMemoryParameters(void)
{
	int i;

	for (i=0;i<MyData.BaseParametersMine.TotParameters;i++) {
		FreeMemory(MyData.BaseParametersMine.pVetParameters[i].pVetArg);
	}

	if (MyData.BaseParametersMine.TotParameters > 0) {
		FreeMemory(MyData.BaseParametersMine.pVetParameters);
		MyData.BaseParametersMine.TotParameters=0;
	}

	MyData.BaseParametersMine.pVetParameters=NULL;
}

// this procedure will be called at end of any level
// you can type here code to free resources allocated for level (that quits now)
void FreeLevelResources(void)
{

	// free memory used to store all data about your customize commands loaded in previous level
	FreeMemoryCustomize();
	// free memory used to store all data about your parameters commands loaded in previous level
	FreeMemoryParameters();
	MyData.BaseAssignSlotMine.TotAssign=0;
	// free created camera
	if (BaseDrone.IndexCamera != -1) {
		FreeNewCamera(BaseDrone.IndexCamera);
		BaseDrone.IndexCamera =-1;
	}
	if (BaseDrone.TestPresent == true) {

		// we have to free also allocated new extra ng strings
		if (BaseDrone.IndexStringBattery != -1) FreeNewExtraString(BaseDrone.IndexStringBattery);
		if (BaseDrone.IndexStringCompass != -1) FreeNewExtraString(BaseDrone.IndexStringCompass);
		if (BaseDrone.IndexStringDistance != -1) FreeNewExtraString(BaseDrone.IndexStringDistance);
		if (BaseDrone.IndexStringHeight != -1) FreeNewExtraString(BaseDrone.IndexStringHeight);
		if (BaseDrone.IndexStringSignal != -1) FreeNewExtraString(BaseDrone.IndexStringSignal);
		if (BaseDrone.IndexStringWarnings != -1) FreeNewExtraString(BaseDrone.IndexStringWarnings);
	}
}
// it will be called before beginning the loading for a new level.
// you can type here code to initialise all variables used for level (to clear old values changed by previous level)
// and to free resources allocated in old level since now we'are going to another new level.

void cbInitLoadNewLevel(void)
{
	int i;

	StrProgressiveAction *pAction;

	// clear all LOCAL variables
	ClearMemory(&MyData.Save.Local,sizeof(StrSavegameLocalData));

	// clear progressive actions
	pAction= &MyData.VetProgrActions[0];

	for (i=0;i<MyData.TotProgrActions;i++) {
		if (pAction->ActionType != AXN_FREE) {
			// here you could analise to free resoruce allocated from this specific action

			pAction->ActionType = AXN_FREE;
		}
	}

	MyData.TotProgrActions=0;
	MyData.LastProgrActionIndex=0;

	// here you can initialise other variables of MyData different than Local and progressive actions
	// free resources allocate in previous level
	FreeLevelResources();

}

// split a line in different parts, looking for "Separatore" character as mark diviser
// return an array of char pointers and set to pTotPezzi the amount of pointers
// max values: max 50 sub parts, and whole input pStringa has not to be larger than 1024 characters
char ** Split(char *pStringa, char Separatore, 
			  int* pTotPezzi, bool TestSoloPrimo) 
{
	static char * pVettore[50];
	static char Buffer[1024];

	DWORD		i;
	int  IndiceOld;
	int		TotItem;
	char *pTemp;
	DWORD  MaxLen;
	char *pOut;
	char **pVetPointer;

	pOut = Buffer;
	pVetPointer = pVettore;

	IndiceOld =0;
	strcpy(pOut,pStringa);
	TotItem=0;
	MaxLen = strlen(pOut);

	for (i =0;i<MaxLen;i++) {
		if (pOut[i] == Separatore) {
			// salvare il precedente
			pOut[i]=0;
			pVetPointer[TotItem++] = &pOut[IndiceOld];

			IndiceOld=i+1;
			if (TestSoloPrimo) break;
		}
	}
	
	// salvare ultimo indiceold a meno che non sia nullo
	pTemp = &pOut[IndiceOld];
	if (strlen(pTemp) > 0) {
	 	pVetPointer[TotItem++] = pTemp;
	}


	*pTotPezzi = TotItem;
	return  pVetPointer;

}

// called to swap between a view cam and another
// if ForceNewViewCam is different than -1, it will be selected next available cam view
// while when ForceNewViewCam is a valid VIEW_CAM value, it will force this nea view cam (if it is allowed by ViewFlags
void ChangeViewCam(int ForceNewViewCam)
{
	int i;
	int OldView;
	StrAdrCamera *pCam;
	int IncX, IncY, IncZ;
	StrItemTr4 *pDrone;
	StrItemTr4 FakeTarget;

	// select another viewcam
	OldView = BaseDrone.ViewCamNow;
	// if it has been required to force a specific viecam set i to select own that cam for first
	if (ForceNewViewCam == -1) {
		// start from current view cam, to be sure to do not select newly own that one
		i= BaseDrone.ViewCamNow >> 1;
	}else {
		// set i to have own ForceNewViewCam mode as first to check
		i = ForceNewViewCam >> 1;
		i++;
	}
	do {
		i--;
		if (i < 0) i = 2;
		// if we have to forbid the chase cam for no signal, then skip this value
		if ((BaseDrone.DronePhase & DP_LOST_DRONE) != 0 && (BaseDrone.Flags & DRF_NOISE_EFFECT_ON_NO_SIGNAL) != 0) {
			if ((1 << i) == VIEW_CAM_CHASE_DRONE) {
				i--;
				if (i < 0) i=2;
			}
		}
		// verify if current mode has been allowed by script command
	}while (((1<<i) & BaseDrone.ViewFlags)==0);
	BaseDrone.ViewCamNow = 1 << i;
	RemoveMaskImage();
	RemoveTelemetry();
	RemoveWarningsTelemetry();

	// now set the tilt camera at reasonable start value (when rewquired by this cam view)
	// but... change only if old tilt was not valid
	if (BaseDrone.TiltCamera < PROF_CAM_MIN_TILT || BaseDrone.TiltCamera > PROF_CAM_MAX_TILT) {

		switch (BaseDrone.ViewCamNow) {
		case VIEW_CAM_CHASE_DRONE:
			
			// set a middle value
			BaseDrone.TiltCamera = (PROF_CAM_MIN_TILT+PROF_CAM_MAX_TILT) / 2;
				
			break;
		case VIEW_CAM_DRONE:
			// set to do drone looks in front of it

			BaseDrone.TiltCamera = PROF_CAM_MIN_TILT;

			break;

		}
	}
	// permettere swap migliore tra cam
	if (BaseDrone.ViewCamNow == VIEW_CAM_LARA && (OldView == VIEW_CAM_DRONE || OldView == VIEW_CAM_CHASE_DRONE)) {
		// cercare di evitare il salto di cam
		// impostare come se cam attuale fosse gia' come target lara
		Get(enumGET.ITEM, BaseDrone.IndexRealDrone,0);
		pDrone = GET.pItem;
		FakeTarget.CordX = GET.pLara->CordX;
		FakeTarget.CordY = GET.pLara->CordY - 700;
		FakeTarget.CordZ = GET.pLara->CordZ;
		FakeTarget.Room  = GET.pLara->Room;

		FindIncrementsForTarget(pDrone, &FakeTarget, 64, &IncX, &IncY, &IncZ);

		// ora incrementare fino a ragggiungere distanza di circa 600 dietro lara
		FakeTarget.CordX += IncX * 10;
		FakeTarget.CordY += IncY * 10;
		FakeTarget.CordZ += IncZ * 10;

		pCam = & Trng.pGlobTomb4->pAdr->Camera;
		
		pCam->pCameraSrc->CordX = FakeTarget.CordX;
		pCam->pCameraSrc->CordY = FakeTarget.CordY;
		pCam->pCameraSrc->CordZ = FakeTarget.CordZ;
		pCam->pCameraSrc->Room = FakeTarget.Room;
		
	}
}

// check if:
// - there is following me in progress
// - and there is DRF_NO_TRIGGERS_ON_FOLLOWME flag
bool IgnoraTrigger(void)
{
	if (BaseDrone.TestUserCommand == true && BaseDrone.UserCommand == UCMD_FOLLOW_LARA &&
		(BaseDrone.Flags & DRF_NO_TRIGGERS_ON_FOLLOWME) != 0) return true;
	return false;
}
// this procedure will be called everytime a flipeffect of yours will be engaged
// you have to elaborate it and then return a TRET_.. value (most common is TRET_PERFORM_ONCE_AND_GO)
int cbFlipEffectMine(WORD FlipIndex, WORD Timer, WORD Extra, WORD ActivationMode)
{
	int RetValue;
	WORD TimerFull;
	int LevelBattery;
	char **pVetFields;
	int TotFields;
	int Flag;
	int Offset;
	BYTE *pByte;
	WORD *pWord;
	int *pLong;
	int NBytes;
	short Slot;
	StrItemTr4 *pDrone;
	char *pLinea;
	bool TestPickup;
	int i;
	StrProgressiveAction *pAction;
	int IncRot;
	int Value;

	RetValue = enumTRET.PERFORM_ONCE_AND_GO;
	// if the flip has no Extra paremeter you can handle a Timer value with values upto 32767
	// in this case you'll use the following TimerFull variable, where (with following code) we set a unique big number 
	// pasting togheter the timer+extra arguments:
	TimerFull = Timer | (Extra << 8);

	switch (FlipIndex) {
	case 47:
		// 47:Battery. Set <&>Battery level for battery currently plugged in Drone
		// convert percentage of level battery (stored in Timer argument) in real level
		LevelBattery = (BaseDrone.BatteryMinutes * 60 * 30 * Timer) / 100;
		BaseDrone.BatteryLevel = LevelBattery;
		BaseDrone.PercBattery = Timer;

		break;
	case 48:
		// 48:Signal. Decrease Signal strenght adding a wall of click depth<&> in (E)way
		BaseDrone.UserChangeWalls = (float) Timer;
		BaseDrone.UserChangeWallMode  = Extra;

		// if mode is "2:Only in while time drone is engaging current trigger"
		// we have to return a value that will cann again the trigger, untile the drone is over this sector
		if (Extra == 2) {
			RetValue = enumTRET.PERFORM_ALWAYS;
		}else {
			RetValue = enumTRET.PERFORM_ONCE_AND_GO;
		}
		break;
	case 49:
		//49:Signal. Increase Signal stringht removing walls for a click depth<&> in (E)way
		BaseDrone.UserChangeWalls = (float) -Timer;
		BaseDrone.UserChangeWallMode = Extra;


		if (Extra == 2) {
			RetValue = enumTRET.PERFORM_ALWAYS;
		}else {
			RetValue = enumTRET.PERFORM_ONCE_AND_GO;
		}
		break;
	case 50:
		// 50:Flags. Add <&>DRF_ flag for currently loaded Customize=CUST_DRONE script command
		// the timer argument could be: 0,1,2,3,4 ect
		// we have to convert in power by 2
		Flag = 1 << Timer;
		BaseDrone.Flags |= Flag;

		break;
	case 51:
		// 51:Flags. Remove <&>DRF_ flag for currently loaded Customize=CUST_DRONE script command
		Flag = 1 << Timer;
		BaseDrone.Flags &= ~Flag;

		break;
	case 52:
		// 52:Text. Display <&>Drone Message in (E)way

		BaseDrone.UserMsgIndex = Timer;
		BaseDrone.UserMsgMode = Extra;

		break;
	case 53:
		// 53:Text. Remove <&>Drone Message
		if (BaseDrone.UserMsgIndex != -1) {
			RemoveMSG(BaseDrone.UserMsgIndex);
			BaseDrone.UserMsgIndex=-1;
		}

		break;
	case 54:
		// 54:Signal. Decrease Signal strenght adding a simulated distance of <&>meters/yards in (E) way
		BaseDrone.UserChangeDistance = (float) Timer;
		BaseDrone.UserChangeDistMode = Extra;
		if (Extra == 2) {
			RetValue = enumTRET.PERFORM_ALWAYS;
		}else {
			RetValue = enumTRET.PERFORM_ONCE_AND_GO;
		}
		break;
	case 55:
		// 55:Signal. Increase Signal strenght substracting <&>meters/yards to real distance in (E) way
		BaseDrone.UserChangeDistance = (float) -Timer;
		BaseDrone.UserChangeDistMode = Extra;
		if (Extra == 2) {
			RetValue = enumTRET.PERFORM_ALWAYS;
		}else {
			RetValue = enumTRET.PERFORM_ONCE_AND_GO;
		}
		break;
	case 56:
	case 59:
		// 56:Customize. Set <&>value to (E)field of Customize=CUST_DRONE command
		// 59:Cutomize. Copy Trng Variable CurrentValue value to <&>field of currently loaded Customize=CUST_DRONE command	
		if (FlipIndex == 59) {
			// use value of CurrentValue variable
			// and swap index for field type, from timer to extra
			Extra = Timer;
			Timer = Trng.pGlobTomb4->pBaseVariableTRNG->Globals.CurrentValue;
		}

		switch (Extra) {
		case ARG_Flags:
			BaseDrone.Flags = Timer;
			break;
		case ARG_CamViewFlags:
			BaseDrone.ViewFlags = Timer;
			break;
		case ARG_DronePickupSlot:
			BaseDrone.PickupDroneSlot = Timer;
			break;
		case ARG_DroneFullPickupSlot:
			BaseDrone.PickupFullDroneSlot = Timer;
			break;
		case ARG_ControllerPickupSlot:
			BaseDrone.SlotController = Timer;
			break;
		case ARG_BatteryPickupSlot:
			BaseDrone.SlotBattery = Timer;
			break;
		case ARG_FirstDroneExtraString:
			BaseDrone.FirstStringIndex = Timer;
			break;
		case ARG_HelpImageIndex:
			BaseDrone.HelpImageIndex = Timer;
			break;
		case ARG_MaskImageIndex:
			BaseDrone.MaskImageIndex = Timer;
			break;
		case ARG_BatteryTime:
			BaseDrone.BatteryMinutes = Timer;
			break;
		case ARG_MaxDistance:
			BaseDrone.MaxDistance = Timer;
			break;
		case ARG_SpriteCmdId:
			BaseDrone.SpriteCmdId = Timer;
			break;
		case ARG_Extra1:
			BaseDrone.Extra1 = Timer;
			break;
		case ARG_Extra2:
			BaseDrone.Extra2 = Timer;
			break;
		}
		break;
	case 57:
		// 57:Flags. Add <&>VIEW_ to currently loaded customize=CUST_DRONE command
		Flag = 1 << Timer;
		BaseDrone.ViewFlags |= Flag;
		// if the flag is about text to show (size char) change dynamically
		if (BaseDrone.TestStoppedKeys == true) {
			// when input has been caught by drone procedure, it mean there is driving drone in progress
			ChangeViewCam(BaseDrone.ViewCamNow);
		}
		break;
	case 58:
		// 58:Flags. Remove <&>VIEW_ flag to currently loaded customize=CUST_DRONE command
		Flag = 1 << Timer;
		BaseDrone.ViewFlags &= ~Flag;
		// if the flag is about text to show (size char) change dynamically
		if (BaseDrone.TestStoppedKeys == true) {
			// when input has been caught by drone procedure, it mean there is driving drone in progress
			ChangeViewCam(BaseDrone.ViewCamNow);
		}

		break;
	case 60:
		// 60:Cutscene. Set <&>Camera View for drone with (E)degrees of tilt
		if (IgnoraTrigger()==true) break;

		Get(enumGET.LARA,0,0);
		// if lara is driving the drone: quit.
		if (GET.pLara->StateIdCurrent == 96) break;

		
		// if cam type and tilt have been already set, quit
		if (Timer == BaseDrone.ViewCamNow && (Extra*182) == BaseDrone.TiltCamera) break;
		if (Timer == 0) {
			// disable cam
			BaseDrone.ViewCamNow=VIEW_NO_CAM;
			RemoveTelemetry();
			RemoveWarningsTelemetry();
			RemoveMaskImage();
		}else {
			ChangeViewCam(Timer);
			BaseDrone.TiltCamera = Extra * 182;
		}
		break;

	case 61:
		// 61:Cutscene. Force drone to fly (indipendently by Lara) and trying to reach <&>LARA_START_POS target, reaching (E)meters height before moving for target
		// verify if there are condition to perform this command
		if (IgnoraTrigger()==true) break;
		if (BaseDrone.TestPresent==false) {
			SendToLog("ERROR: drone management is not working");
			RetValue= enumTRET.PERFORM_NEVER_MORE;
			break;
		}
		if (BaseDrone.TestCutScene == false && (BaseDrone.DronePhase & DP_FLYING)!=0) break;


		// try to locate the lara_start_pos with supplied OCB value
		if (Find(enumFIND.AI, enumSLOT.LARA_START_POS, -1, Timer, -1, NULL) == false) {
			SendToLog("ERROR: flipeffect 61: cannot find a LARA_START_POS item with ocb=%d", Timer);
			RetValue= enumTRET.PERFORM_NEVER_MORE;
			break;
		}

		if (FIND.TotAI > 1) {
			SendToLog("ERROR: flipeffect 61: there are %d LARA_START_POS item with ocb=%d", FIND.TotAI, Timer);
			RetValue= enumTRET.PERFORM_NEVER_MORE;
			break;
		
		}
		// get structure of given lara_start_pos
		Get(enumGET.AI_ITEM, FIND.VetAI[0], -1);

		if (BaseDrone.TestCutScene == true) {
			// a drone cutscene is already active.
			// verify if the target is the same or less
			if (GET.pAI->CordX == BaseDrone.Target.CordX &&
				GET.pAI->CordY == BaseDrone.Target.CordY &&
				GET.pAI->CordZ == BaseDrone.Target.CordZ) {
					// yes, it's the same: ignore this duplicate
					break;
			}

		}
		// if lara is controlling the drone: ignore this trigger
		Get(enumGET.LARA,0,0);
		if (GET.pLara->StateIdCurrent == 96) {
			SendToLog("ERROR: required drone cutscene (flipeffect 61) while lara was driving the drone");
			break;
		}
		if (BaseDrone.DronePhase & DP_NO_DRONES) {
			SendToLog("ERROR: flipeffect 61: no available drone in this moment (drone in inventory)");
			break;
		}

		// drone has to have battery value correct
		if (BaseDrone.PercBattery == 0) {
			SendToLog("ERROR: flipeffect 61: battery is out of power");
			break;
		}
	

		// verify if currently there is piclup drone or reale drone
		i= BaseDrone.IndexPickupDrone;
		TestPickup=true;
		if (i == -1) {
			// pickup drone not available, trying with real drone
			if (BaseDrone.TestVisibleRealDrone==false) {
				SendToLog("ERROR: flipeffect 61: no available drone in this moment (drone in inventory)");
				break;
			}
			i = BaseDrone.IndexRealDrone;
			TestPickup=false;
		}
		Get(enumGET.ITEM, i, -1);
		pDrone= GET.pItem;	



		// now let's set all data in basedrone
		BaseDrone.TestCutScene = true;
		// copy position for target
		BaseDrone.Target.CordX = GET.pAI->CordX;
		BaseDrone.Target.CordY = GET.pAI->CordY;
		BaseDrone.Target.CordZ = GET.pAI->CordZ;
		BaseDrone.Target.Room = GET.pAI->RoomIndex;

		// enable target
		BaseDrone.DronePhase |= DP_CHASE_TARGET;
		
		// compute height to reach
		BaseDrone.Target_Y_Only = pDrone->CordY - ConvertLinearUnitToGameUnits(Extra);
		
		// verify if required height will be enought to be upper the Y coordinate of target
		if ((BaseDrone.Target.CordY-256) < BaseDrone.Target_Y_Only) {
			// set valid y coord to reach to get drone a bit upper of target.y
			BaseDrone.Target_Y_Only = BaseDrone.Target.CordY - 256;

			// if drone is landed, to be sure to move up at least of 256
			if (TestPickup==true) {
				if (BaseDrone.Target_Y_Only > (pDrone->CordY -256)) {
					BaseDrone.Target_Y_Only = pDrone->CordY-256;
				}
			}
		}
		// enable y target
		BaseDrone.DronePhase |= DP_REACH_Y_TARGET;

		// if drone was piclup, start animation to open arms
		if (TestPickup==true) {
			TransformPickupToRealDrone();
		}else {
			// it was already a real drone
			// if was not flying, start take off
			if ((BaseDrone.DronePhase & DP_FLYING)==0) {
				BaseDrone.DronePhase |= DP_TAKE_OFF;
			}
		}
		// in the case there was no_signal for too far from controller, we can removing it
		BaseDrone.DelayForWaves &= ~(DP_NO_SIGNAL | DP_LOST_DRONE);

		break;
	case 62:
		// 62:Cutscene. Change vertical position of drone by <&>game units, moving it in(E) direction
		if (BaseDrone.TestCutScene == false) break;
		if (IgnoraTrigger()==true) break;
		// if drone is not flying, quit
		if ((BaseDrone.DronePhase & DP_FLYING)==0) {
			SendToLog("Flipeffect 62: drone is not flying, quit");
			break;
		}

		Get(enumGET.ITEM, BaseDrone.IndexRealDrone,0);
		pDrone = GET.pItem;

		// modify y coordinate of drone
		if (Extra == 0) {
			// rasing drone
			pDrone->CordY -= Timer;
		}else {
			// descending drone
			pDrone->CordY += Timer;
		}

		BaseDrone.TestUserChangePos=true;
		RetValue= enumTRET.PERFORM_ALWAYS;
		break;
	case 63:
		// 63:Cutscene. Move drone camera to reach <&>tilt degrees, in (E)seconds#REMARK#To use only when there is a drone cutscene in progress
		if (IgnoraTrigger()==true) break;
		Get(enumGET.LARA,0,0);

		// if lara is driving the drone: quit
		// the drone has to fly for this trigger
		if (GET.pLara->StateIdCurrent == 96 || (BaseDrone.DronePhase & DP_FLYING)==0) break;

		// if cam view is not chase or drone cam, quit
		if (BaseDrone.ViewCamNow != VIEW_CAM_DRONE && BaseDrone.ViewCamNow != VIEW_CAM_CHASE_DRONE) break;

		// if there is alread a progressive action to tilt camera, abort this trigger
		pAction= &MyData.VetProgrActions[0];

		// look for first free record
		for (i=0;i<MyData.TotProgrActions;i++) {
			if (pAction->ActionType == AXN_TILT_DRONE_CAMERA) break;
			pAction++;
		}
		if (i < MyData.TotProgrActions) break;

		// start a new progressive action to handle the tilt mod
		Get(enumGET.PROGRESSIVE_ACTION, 0,0);
		GET.pAction->ActionType = AXN_TILT_DRONE_CAMERA;

		// set the time, modiffying from seconds to frame (30 for second)
		GET.pAction->Arg1 = Extra * 30;
		GET.pAction->Arg2 = Timer * 182;

		// compute the single step on tilt to reach wished final degrees
		GET.pAction->VetArgShort[0] = ((Timer * 182) - BaseDrone.TiltCamera) / GET.pAction->Arg1;


		break;
	case 64:
		// 64:Command. Send <&>command to Drone
		// verify if there are right condition to execute it
		// if drone is not flying, quit
		if (IgnoraTrigger()==true) break;
		if ((BaseDrone.DronePhase & DP_FLYING)==0) {
			SendToLog("Flipeffect 64: drone is not flying, quit");
			break;
		}
		// if there is already in progress a user command, abort. 
		if (BaseDrone.TestUserCommand == true) break;

		BaseDrone.TestUserCommand =true;
		BaseDrone.UserCommand = Timer;

		// start the required effect
		Get(enumGET.ITEM, BaseDrone.IndexRealDrone,0);
		pDrone = GET.pItem;

		switch (Timer) {
		case UCMD_LANDING:
			BaseDrone.DronePhase |= (DP_LANDING | DP_EMERGENCY_LANDING);
			break;
		case UCMD_FALLING_DOWN:
			BaseDrone.DronePhase |= (DP_LOST_DRONE | DP_CRASH_IN_PROGRESS | DP_NO_SIGNAL);
			break;
		case UCMD_SHAKE_AND_TROUBLE:
			BaseDrone.DronePhase |= DP_REBOUND_ON_IMPACT;
			// force animation to shake drone
			ForceAnimationForItem(pDrone, 3, -1);
			// and set data for the rebound
			BaseDrone.Rebound_H_Direction = pDrone->OrientationH;
			BaseDrone.Rebound_H_Speed =0;
			BaseDrone.Rebound_V_Speed = 0;

			BaseDrone.Rebound_V_LoseHeight = PROF_VSPEED * 3;

			break;

		}
		break;
	case 65:
		// 65:Command. Divert drone, forcing it to reach <&>LARA_START_POS position
		if (BaseDrone.TestCutScene == true) break;
		if (BaseDrone.TestUserCommand == true) break;

		if ((BaseDrone.DronePhase & DP_FLYING)==0) {
			SendToLog("Flipeffect 65: drone is not flying: quit");
			break;
		}
	
		// try to locate the lara_start_pos with supplied OCB value
		if (Find(enumFIND.AI, enumSLOT.LARA_START_POS, -1, Timer, -1, NULL) == false) {
			SendToLog("ERROR: flipeffect 65: cannot find a LARA_START_POS item with ocb=%d", Timer);
			RetValue= enumTRET.PERFORM_NEVER_MORE;
			break;
		}

		if (FIND.TotAI > 1) {
			SendToLog("ERROR: flipeffect 65: there are %d LARA_START_POS item with ocb=%d", FIND.TotAI, Timer);
			RetValue= enumTRET.PERFORM_NEVER_MORE;
			break;
		
		}
		// get structure of given lara_start_pos
		Get(enumGET.AI_ITEM, FIND.VetAI[0], -1);

		Get(enumGET.ITEM, BaseDrone.IndexRealDrone,0);
		pDrone = GET.pItem;

		// set data for this command

		// remove further other targets
		BaseDrone.DronePhase &= ~DP_REACH_Y_TARGET;

		BaseDrone.TestUserCommand = true;
		BaseDrone.UserCommand = UCMD_DIVERT_DRONE;
		// replace last safe postion with that of Lara_start_pos
		BaseDrone.Target.CordX  = GET.pAI->CordX;
		// analuyse for y coordinate
		if (Extra == 0) {
			// use only (x,z) position of lara_start_pos, letting same current y drone coordinate
			BaseDrone.Target.CordY  = pDrone->CordY;
		}else {
			// move also to reach y coordinate of lara_start_pos
			BaseDrone.Target.CordY  = GET.pAI->CordY;

		}
		BaseDrone.Target.CordZ  = GET.pAI->CordZ;
		BaseDrone.Target.Room  = GET.pAI->RoomIndex;
		BaseDrone.DronePhase |= DP_CHASE_TARGET;

		break;
	case 66:
		// 66:Pickup: Set as drone had picked up the <&>inventory item
		// locate slot
		Slot = Trng.pGlobTomb4->VetInventory[Timer];
		if (Slot == BaseDrone.PickedUpKey) break;

		BaseDrone.PickedUpKey = Slot;

		if (Extra == 0) {
			// set message
			ShowMessage(false, MSG_TAKEN_ITEM, PROF_LONG_TIME_WARNING_MSG, NULL);
		}
		break;

	case 67:
		// Customize. Set as max altitude for drone the value of <&>sectors over current floor in (E)way
		// compute the absolute Y coordinate of the altitude limit
		Get(enumGET.ITEM, BaseDrone.IndexRealDrone,0);
		pDrone = GET.pItem;

		BaseDrone.AltitudeLimit = pDrone->HeightFloor - Timer * 1024;
		BaseDrone.TestAlitudeLimit=true;
		// check if the limit is forever or less
		if (Extra == 1) {
			// forever
			BaseDrone.TestLimitForever = true;
		}else {
			// not forever, only while trigger was enabled
			BaseDrone.TestLimitForever = false;
		}
		RetValue = enumTRET.PERFORM_ALWAYS;
		break;
	case 68:
		// 68:Customize. Remove max altitude limit.
		BaseDrone.TestAlitudeLimit=false;
		break;
	case 69:
		// 69:Cutscene. Force drone to perform a full rolling in <&>direction and int (E)frame time

		// drone has to fly and the view cam should be "chase cam" or "drone cam"
		if ((BaseDrone.DronePhase & DP_FLYING)==0) break;
		if (IgnoraTrigger()==true) break;
		if (BaseDrone.ViewCamNow != VIEW_CAM_DRONE && BaseDrone.ViewCamNow != VIEW_CAM_CHASE_DRONE) break;
	
		// compute the increment
		IncRot = 65536 / (Extra*30);
		if (Timer == 1) IncRot = -IncRot;
		// if there was already in progress the same rolling: quit
		if (BaseDrone.TestUserCommand==true && BaseDrone.UserCommand == UCMD_ROLLING && BaseDrone.UserParameter == IncRot) break;

		BaseDrone.TestUserCommand = true;
		BaseDrone.UserCommand = UCMD_ROLLING;
		BaseDrone.UserParameter = IncRot;

		break;
	case 70:
		// 70:Variables. Move index of (E)Drone item to <#>trng variable
		// parameter about type of drone:
		//		0:Real drone (slot 506)
		//		1:Pickup drone (pickable item, on the ground or water surface)
		switch (Extra) {
		case 0:
			i = BaseDrone.IndexRealDrone;
			break;
		case 1:
			i = BaseDrone.IndexPickupDrone;
			break;
		}
		// save to given variable
		WriteNumVariable(Timer, i);
		break;
	case 71:
		// 71:Variables. Move the value from (E)Field of real drone to <#>trng variable


		// verify if currently there is real drone (visible or less)
		i= BaseDrone.IndexRealDrone;

		if (i == -1) {
			// pickup drone not available, trying with real drone
			if (BaseDrone.TestVisibleRealDrone==false) {
				SendToLog("ERROR: flipeffect 71: no real drone is available in this moment");
				break;
			}
		}
		Get(enumGET.ITEM, i, -1);
		pDrone= GET.pItem;	

		pLinea = VetDroneFields[Extra];
		pVetFields=Split(pLinea, ':', &TotFields,false);
		if (TotFields != 3) {
			SendToLog("ERROR drone flipeffect 71: internal error, the parameter for field, with value %d has not been recognized",
				Extra);
			break;
		}
		// convert first value (offset, from hexdecimal format)
		sscanf(pVetFields[0], "%x", &Offset);
		// second value (decimal) is the size in bytes of this field
		sscanf(pVetFields[1], "%d", &NBytes);
		// third field is the name of the field
		pByte = (BYTE *)pDrone + Offset;
		switch (NBytes) {
		case 1:
			Value = *pByte;
			break;
		case 2:
			pWord = (WORD *) pByte;
			Value = *pWord;
			break;
		case 4:
			pLong = (int *) pByte;
			Value = *pLong;
			break;
		}
		WriteNumVariable(Timer, Value);
		break;
	case 72:
		// 72:Variables. Move the value from <#>trng variable to (E)field of real drone

		// verify if currently there is real drone (visible or less)
		i= BaseDrone.IndexRealDrone;

		if (i == -1) {
			// pickup drone not available, trying with real drone
			if (BaseDrone.TestVisibleRealDrone==false) {
				SendToLog("ERROR: flipeffect 71: no real drone is available in this moment");
				break;
			}
		}
		Get(enumGET.ITEM, i, -1);
		pDrone= GET.pItem;	

		Value = ReadNumVariable(Timer);
		pLinea = VetDroneFields[Extra];
		pVetFields=Split(pLinea, ':', &TotFields,false);
		if (TotFields != 3) {
			SendToLog("ERROR drone flipeffect 72: internal error, the parameter for field, with parameter index = %d has not been recognized",
				Extra);
			break;
		}
		// convert first value (offset, from hexdecimal format)
		sscanf(pVetFields[0], "%x", &Offset);
		// second value (decimal) is the size in bytes of this field
		sscanf(pVetFields[1], "%d", &NBytes);
		// third field is the name of the field
		pByte = (BYTE *)pDrone + Offset;
		switch (NBytes) {
		case 1:
			*pByte = Value;
			break;
		case 2:
			pWord = (WORD *) pByte;
			*pWord = Value;
			break;
		case 4:
			pLong = (int *) pByte;
			*pLong = Value;
			break;
		}
		break;
	case 73:
		// 73:Cutscene. Follow Lara, keeping <#>min distance and (E)Min height respect Lara
		if (IgnoraTrigger()==true) break;
		if (BaseDrone.TestPresent==false) {
			SendToLog("ERROR: drone management is not working");
			RetValue= enumTRET.PERFORM_NEVER_MORE;
			break;
		}
		Get(enumGET.LARA, 0,0);
		// if lara is driving the drone: abort
		if (BaseDrone.TestCutScene == false && GET.pLara->StateIdCurrent == 96 ) break;

		if (BaseDrone.DronePhase & DP_NO_DRONES) {
			SendToLog("ERROR: flipeffect 73: no available drone in this moment (drone in inventory)");
			break;
		}

		// drone has to have battery value correct
		if (BaseDrone.PercBattery == 0) {
			SendToLog("ERROR: flipeffect 73: battery is out of power");
			break;
		}
		// verify if currently there is piclup drone or reale drone
		i= BaseDrone.IndexPickupDrone;
		TestPickup=true;
		if (i == -1) {
			// pickup drone not available, trying with real drone
			if (BaseDrone.TestVisibleRealDrone==false) {
				SendToLog("ERROR: flipeffect 73: no available drone in this moment (drone in inventory)");
				break;
			}
			i = BaseDrone.IndexRealDrone;
			TestPickup=false;
		}
		// set as target the lara position
		BaseDrone.Target.CordX = GET.pLara->CordX;
		BaseDrone.Target.CordY = GET.pLara->CordY;
		BaseDrone.Target.CordZ = GET.pLara->CordZ;
		BaseDrone.Target.Room = GET.pLara->Room;

		BaseDrone.DronePhase |= DP_CHASE_TARGET;

		Get(enumGET.ITEM, i, -1);
		pDrone= GET.pItem;	
		// compute height to reach
		BaseDrone.Target_Y_Only = pDrone->CordY - PROF_TAKE_OFF_HEIGHT;
		// verify if required height will be enought to be upper the Y coordinate of target
		if ((BaseDrone.Target.CordY-256) < BaseDrone.Target_Y_Only) {
			// set valid y coord to reach to get drone a bit upper of target.y
			BaseDrone.Target_Y_Only = BaseDrone.Target.CordY - 256;

			// if drone is landed, to be sure to move up at least of 256
			if (TestPickup==true) {
				if (BaseDrone.Target_Y_Only > (pDrone->CordY -256)) {
					BaseDrone.Target_Y_Only = pDrone->CordY-256;
				}
			}
		}
		// enable y target
		BaseDrone.DronePhase |= DP_REACH_Y_TARGET;

		// if drone was piclup, start animation to open arms
		if (TestPickup==true) {
			TransformPickupToRealDrone();
		}else {
			// it was already a real drone
			// if was not flying, start take off
			if ((BaseDrone.DronePhase & DP_FLYING)==0) {
				BaseDrone.DronePhase |= DP_TAKE_OFF;
			}
		}
		// in the case there was no_signal for too far from controller, we can removing it
		BaseDrone.DelayForWaves &= ~(DP_NO_SIGNAL | DP_LOST_DRONE);
		BaseDrone.TestCutScene=true;

		// set also user command for following Lara
		BaseDrone.TestUserCommand=true;
		BaseDrone.UserCommand = UCMD_FOLLOW_LARA;
		BaseDrone.UserMinHDistnce = ConvertLinearUnitToGameUnits(Timer);
		BaseDrone.UserMinVDistance = ConvertLinearUnitToGameUnits(Extra);

		// reset last lara target
		BaseDrone.LastLaraTargetOk.CordX=0;

		break;
	case 74:
		// 74:Cutscene: Stop current cutscene in <#>way
		// if there is no cutscene in progress: quit
		if (BaseDrone.TestCutScene==false) break;
		i= BaseDrone.IndexPickupDrone;
		TestPickup=true;
		if (i == -1) {
			// pickup drone not available, trying with real drone
			if (BaseDrone.TestVisibleRealDrone==false) {
				SendToLog("ERROR: flipeffect 61: no available drone in this moment (drone in inventory)");
				break;
			}
			i = BaseDrone.IndexRealDrone;
			TestPickup=false;
		}
		Get(enumGET.ITEM, i, -1);
		pDrone= GET.pItem;	

		BaseDrone.TestUserCommand = true;
		BaseDrone.UserCommand = UCMD_QUIT_CUTSCENE;

		switch (Timer) {
		case 0:
			// 0:Falling down (mayday)
			BaseDrone.DronePhase |= (DP_FAILURE | DP_CRASH_IN_PROGRESS);
			break;
		case 1:
			// 1:Landing
			BaseDrone.DronePhase |= (DP_LANDING | DP_EMERGENCY_LANDING);
			break;
		case 2:
			// 2:Returning to Home
			BaseDrone.DronePhase |= DP_RETURN_TO_HOME;
			if (FindTargetRTH(pDrone, NULL)==false) {
				// failed
				ManageFailure(pDrone);
			}
			
			break;
		}
		break;

	default:
		SendToLog("WARNING: Flipeffect trigger number %d has not been handled in cbFlipEffectMine() function", FlipIndex);
		break;
	}

	// if there was the one-shot button enabled, return TRET_PERFORM_NEVER_MORE
	if (ActivationMode & enumSCANF.BUTTON_ONE_SHOT) RetValue= enumTRET.PERFORM_NEVER_MORE; 
	return RetValue;
}
// this procedure will be called everytime an action trigger of yours will be engaged 
// you have to elaborate it and then return a TRET_.. value (most common is TRET_PERFORM_ONCE_AND_GO)
int cbActionMine(WORD ActionIndex, int ItemIndex, WORD Extra, WORD ActivationMode)
{
	int RetValue;
	
	RetValue=TRET_PERFORM_ONCE_AND_GO;

	switch (ActionIndex) {
		// type here the code per your action trigger.
		// add "case Number:" and complete the code with "break;" instruction
	case -1:
		// note: remove this "case -1:" and its "break;" it has been added only to avoid warning messages about empty switch
		break;
	default:
		SendToLog("WARNING: action trigger number %d has not been handled in cbActionMine() function", ActionIndex);
		break;
	}
	
	// if there was the one-shot button enabled, return TRET_PERFORM_NEVER_MORE
	if (ActivationMode & enumSCANF.BUTTON_ONE_SHOT) RetValue= enumTRET.PERFORM_NEVER_MORE;
	return RetValue;


}

// this procedure will be called everytime a conditional trigger of yours will be engaged
// you have to elaborate it and then return a CTRET_.. value (most common for condition is CTRET_ONLY_ONCE_ON_TRUE)
// WARNING: take care to ADD to RetValue these two CTRET_ constants to signal the type of condition:
// enumCTRET.ON_MOVEABLE  (when the condition worked on a moveable)
// enumCTRET.EXTRA_PARAM  (when the conditon used also (E)extra argument
int cbConditionMine(WORD ConditionIndex, int ItemIndex, WORD Extra, WORD ActivationMode)
{
	int RetValue;
	float Parameter;
	int Value;
	StrItemTr4 *pDrone;
	int i;
	short Facing;
	short Tollerance;
	bool TestPickup;

	
	RetValue=CTRET_ONLY_ONCE_ON_TRUE;
	Parameter = (float) ItemIndex;
	// locate drone (real or pickup)
	TestPickup=false;
	i = BaseDrone.IndexRealDrone;
	if (BaseDrone.DronePhase & DP_DRONE_PICKUP) {
		i = BaseDrone.IndexPickupDrone;
		TestPickup=true;
	}

	if (Get(enumGET.ITEM, i, 0)== false) return RetValue;

	pDrone = GET.pItem;

	switch (ConditionIndex){
		// type here the code for your condition trigger, inserting the code in the section
		// beginning with "case NumberOfAction:" and ending with row "break;"
	case 1:
		// 1:Signal. Signal strenght of drone is less than <#>
		if (BaseDrone.PercSignal < Parameter) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 2:
		// 2:Signal. Signal strenght of drone is greater than <#>


		if (BaseDrone.PercSignal > Parameter) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 3:
		// 3:Signal. Signal strenght of drone is <#>
		Value = (int) BaseDrone.PercSignal;
		if (Value == ItemIndex) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 4:
		// 4:Battery. Battery level of drone is less than <#>
		if (BaseDrone.PercBattery < Parameter) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 5:
		// 5:Battery. Battery level of drone is greater than <#>
		if (BaseDrone.PercBattery > Parameter) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 6:
		// 6:Battery. Battery level of drone is <#>
		Value = (int) BaseDrone.PercBattery;
		if (Value == ItemIndex) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 7:
	case 8:
	case 9:
		// 7:Distance. Distance from drone and controller is less than <#>
		// 8:Distance. Distance from drone and controller is greater than <#>
		// 9:Distance. Distance from drone and controller is <#>


		Get(enumGET.LARA,0,0);

		// compute distace 
		Parameter = (float) GetDistanceXYZ(GET.pLara->CordX, GET.pLara->CordY+PROF_CONTROLLER_LARA_YGAP, GET.pLara->CordZ,
									pDrone->CordX, pDrone->CordY, pDrone->CordZ);
		// converte in meters/yards
		Value = (int) ConvertUnits(Parameter);

		// now perform the condition
		switch (ConditionIndex) {
		case 7:
			// 7:Distance. Distance from drone and controller is less than <#>
			if (Value < ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 8:
			// 8:Distance. Distance from drone and controller is greater than <#>
			if (Value > ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 9:
			// 9:Distance. Distance from drone and controller is <#>
			if (Value == ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;			
		
		}
		break;
	case 10	:
		// 10: Altitude. Altitude of drone from its starting point is less than <#>
		Value = BaseDrone.StartPoint.CordY - pDrone->CordY;
		Value = (int) ConvertUnits((float) Value);
		if (TestPickup==true) Value=0;
		if (Value < ItemIndex) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 11:
		// 11: Altitude. Altitude of drone from its starting point is greater than <#>
		Value = BaseDrone.StartPoint.CordY - pDrone->CordY;
		Value = (int) ConvertUnits((float) Value);
		if (TestPickup==true) Value=0;
		if (Value > ItemIndex) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 12:
		// 12: Altitude. Altitude of drone from its starting point is <#>
		Value = BaseDrone.StartPoint.CordY - pDrone->CordY;
		Value = (int) ConvertUnits((float) Value);
		if (TestPickup==true) Value=0;
		if (Value == ItemIndex) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 13:
		// 13: Compass. Drone is facing to <#> degrees with (E) tollerance
		RetValue |= enumCTRET.EXTRA_PARAM;

		Facing = ItemIndex * 0x2000;
		// convert percentage in degrees
		Value = (Extra * 360) / 100;
		// convert in tomb raider degrees
		Tollerance = Value * 182;


		Value = Abs(Facing - pDrone->OrientationH);
		if (Value <= Tollerance) RetValue |= enumCTRET.IS_TRUE;
		break;
	case 14:
	case 15:
	case 16:
		// 14:Distance. Distance from drone and its last taking-off point is less than <#> meters/yards
		// 15:Distance. Distance from drone and its last taking-off point is greater than <#> meters/yards
		// 16:Distance. Distance from drone and its last taking-off point is <#> meters/yards
		Value = GetDistanceXZ(pDrone->CordX, pDrone->CordZ, BaseDrone.StartPoint.CordX, BaseDrone.StartPoint.CordZ);
		if (TestPickup==true) Value=0;
		Value = (int) ConvertUnits((float) Value);

		switch (ConditionIndex) {
		case 14:
			if (Value < ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 15:
			if (Value > ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 16:
			if (Value == ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		}
		break;
	case 17:
		// 17:Speed. Current speed of drone is(E) than <#>game units
		RetValue |= enumCTRET.EXTRA_PARAM;

		// find the speed
		Value = BaseDrone.SpeedNow.Speed;

		switch (Extra) {
		case 0:
			// 0:Less than
			if (Value < ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 1:
			// 1:Greater than
			if (Value > ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 2:
			// 2:Even, the same...
			if (Value == ItemIndex) RetValue |= enumCTRET.IS_TRUE;
			break;
		}
		break;
	case 18:
		// 18:Status. Currently drone (or some item for drone) is in<#>Status
		switch (ItemIndex) {
		case 0:
			// 0:Flying drone
			if (BaseDrone.DronePhase & DP_FLYING) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 1:
			// 1:Real drone on the ground (open arms but with still propellers)
			if (BaseDrone.TestVisibleRealDrone == true && (BaseDrone.DronePhase & DP_READY) != 0 &&
				(BaseDrone.DronePhase & DP_FLOATING)==0 && (BaseDrone.DronePhase & DP_FLYING)==0) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 2:
			// 2:Real drone is invisible (probably it is a pickup item now)
			if (BaseDrone.TestVisibleRealDrone==false) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 3:
			// 3:Real drone is landed on water surface (open arms but with still propellers)
			if (BaseDrone.TestVisibleRealDrone == true && (BaseDrone.DronePhase & DP_READY) != 0 &&
				(BaseDrone.DronePhase & DP_FLOATING)!=0 && (BaseDrone.DronePhase & DP_FLYING)==0) RetValue |= enumCTRET.IS_TRUE;
			break;
		case 4:
			// 4:Pickup drone is on the ground (no real drone in this moment)
			if (BaseDrone.TestVisibleRealDrone == false && (BaseDrone.DronePhase & DP_DRONE_PICKUP) != 0 &&
				(BaseDrone.DronePhase & DP_FLOATING)==0) RetValue |= enumCTRET.IS_TRUE;		
			break;
		case 5:
			// 5:Pickup drone is floating on the water surface (no real drone in this moment)
			if (BaseDrone.TestVisibleRealDrone == false && (BaseDrone.DronePhase & DP_DRONE_PICKUP) != 0 &&
				(BaseDrone.DronePhase & DP_FLOATING)!=0) RetValue |= enumCTRET.IS_TRUE;		
			break;
		case 6:
			// 6:Pickup drone is in inventory (and not in some side of the level)
			if (Inventory(enumINV.READ, BaseDrone.PickupDroneSlot, 0) > 0 ||
				Inventory(enumINV.READ, BaseDrone.PickupFullDroneSlot, 0) >0) RetValue |= enumCTRET.IS_TRUE;	
			break;
		case 7:
			// 7:Controller is in inventory
			if (Inventory(enumINV.READ, BaseDrone.SlotController, 0) > 0) RetValue |= enumCTRET.IS_TRUE;	
			break;
		case 8:
			// 8:There are batteries in inventory
			if (Inventory(enumINV.READ, BaseDrone.SlotBattery, 0) > 0) RetValue |= enumCTRET.IS_TRUE;	
			break;
		case 9:
			// 9:Drone is empty (no energy but there could be batteries inventory)
			if (BaseDrone.BatteryLevel == 0) RetValue |= enumCTRET.IS_TRUE;	
			break;

		}
		break;
	default:
		SendToLog("WARNING: condition trigger number %d has not been handled in cbConditionMine() function", ConditionIndex);
		break;


	}
	return RetValue;
	  
}

// this procedure vill be called for each Customize=CUST_... command read from script
// having one of yours CUST_ constant
// CustomizeValue will be the value of your CUST_ constant
// NumberOfItems will be the number of following Item (signed 16 bit values) following
// the CUST_ constant in the customize= script command
// pItemArray is the array with all NumberOfItems arguments of customize command
void cbCustomizeMine(WORD CustomizeValue, int NumberOfItems, short *pItemArray)
{
	// here you can replace this default management of anonymous customize commands
	// with your procedure where you can recognize each different CUST_ value and 
	// save its arguments in meaningful names fields, or elaboriting them immediatly
	// when it is possible (warning: in this moment nothing of level it has been yet loaded, excepting the script section)

	// ----- default management (optional)----
	// all customize values will be saved in MyData structure
	DWORD SizeMem;
	StrGenericCustomize *pMyCust;
	int TotCust;

	// ask memory to have another (new) record of StrGenericCustomize structure
	TotCust= MyData.BaseCustomizeMine.TotCustomize;
	TotCust++;
	SizeMem = TotCust * sizeof(StrGenericCustomize);
	if (TotCust == 1) {
		MyData.BaseCustomizeMine.pVetCustomize = 
				(StrGenericCustomize *) GetMemory(SizeMem);
	}else {
		MyData.BaseCustomizeMine.pVetCustomize = 
				(StrGenericCustomize *) ResizeMemory(MyData.BaseCustomizeMine.pVetCustomize, SizeMem);
	}
	pMyCust = & MyData.BaseCustomizeMine.pVetCustomize[TotCust-1];
	
	// now require memory for all arguments (NumberOfItems) store in pItemArray

	pMyCust->pVetArg = (short *) GetMemory(2 * NumberOfItems);
	// copy data
	pMyCust->NArguments = NumberOfItems;
	memcpy(pMyCust->pVetArg, pItemArray, 2*NumberOfItems);
	pMyCust->CustValue = CustomizeValue;

	MyData.BaseCustomizeMine.TotCustomize= TotCust;
	// ---- end of default managemnt for generic customize -------------	
}
// callback called everytime in current level section of the script it has been found an AssignSlot command
// with one of your OBJ_ constants
void cbAssignSlotMine(WORD Slot, WORD ObjType)
{
	int i;

	i = MyData.BaseAssignSlotMine.TotAssign;

	if (i >= MAX_ASSIGN_SLOT_MINE) {
		SendToLog("ERROR: too many AssignSlot= commands for current plugin");
		return;
	}

	MyData.BaseAssignSlotMine.VetAssignSlot[i].MioSlot = Slot;
	MyData.BaseAssignSlotMine.VetAssignSlot[i].TipoSlot = ObjType;
	MyData.BaseAssignSlotMine.TotAssign++;


}
// this procedure vill be called for each Parameters=PARAM_... command read from script
// having one of yours PARAM_ constants
// ParameterValue will be the value of your PARAM_ constant
// NumberOfItems will be the number of following Item (signed 16 bit values) following
// the PARAM_ constant in the customize= script command
// pItemArray is the array with all NumberOfItems arguments of Parameter command
void cbParametersMine(WORD ParameterValue, int NumberOfItems, short *pItemArray)
{
	// here you can replace this default management of anonymous parameters commands
	// with your procedure where you can recognize each different Param_ value and 
	// save its arguments in meaningful names fields, or elaboriting them immediatly
	// when it is possible (warning: in this moment nothing of level it has been yet loaded, excepting the script section)

	// ----- default management (optional)----
	// all parameters values will be saved in MyData structure
	DWORD SizeMem;
	StrGenericParameters *pMyParam;
	int TotParam;

	// ask memory to have another (new) record of StrGenericparameters structure
	TotParam= MyData.BaseParametersMine.TotParameters;
	TotParam++;
	SizeMem = TotParam * sizeof(StrGenericParameters);
	MyData.BaseParametersMine.pVetParameters = 
		(StrGenericParameters *) ResizeMemory(MyData.BaseParametersMine.pVetParameters, SizeMem);

	pMyParam = & MyData.BaseParametersMine.pVetParameters[TotParam-1];
	
	// now require memory for all arguments (NumberOfItems) store in pItemArray

	pMyParam->pVetArg = (short *) GetMemory(2 * NumberOfItems);
	// copy data
	pMyParam->ParamValue = ParameterValue;
	pMyParam->NArguments = NumberOfItems;
	memcpy(pMyParam->pVetArg, pItemArray, 2*NumberOfItems);

	MyData.BaseParametersMine.TotParameters= TotParam;
	// ---- end of default managemnt for generic parameters -------------


}
char *FlagPhaseToText(DWORD Flags)
{
	static char Buffer[1024];
	static char *pVetMexFlag[] = {" DP_DRONE_PICKUP", "DP_QUIT_DRONE_MODE", "DP_FLYING", "DP_LANDING", 
		"DP_RETURN_TO_HOME", "DP_PREPARING_TO_FLY", "DP_READY", "DP_PREPARING_TO_PICKUP", "DP_NO_DRONES",
		"DP_TAKE_OFF","DP_RECOVER_OLD_HEIGHT", "DP_CHASE_TARGET", "DP_REACH_Y_TARGET", "DP_TURN_LARA","DP_REBOUND_ON_IMPACT", 
		"DP_LOST_DRONE", "DP_NO_SIGNAL", "DP_NO_BATTERY", "DP_RECOVERING_SAFE_POSITION", "DP_EMERGENCY_LANDING",  "DP_HELP_IN_PROGRESS",
		"DP_CRASH_IN_PROGRESS", "DP_FAILURE", "DP_FLOATING", "DP_NOISES_ON_SCREEN", "DP_FAILED_TAKE_OFF", NULL};
	int i;
	DWORD ValFlag;

	Buffer[0]=0;
	i=0;
	// remove DP_RECOVER_OLD_HEIGHT because changes continuosly
	ValFlag &= ~DP_RECOVER_OLD_HEIGHT;

	while (pVetMexFlag[i]) {
		ValFlag = 1 << i;
		if (Flags & ValFlag) {
			strcat(Buffer, pVetMexFlag[i]);
			strcat(Buffer, " ");
		}
		i++;
	}
	return Buffer;

}
void LogDrone(void)
{

	if (Get(enumGET.ITEM, BaseDrone.IndexRealDrone,0)==false) return;
	if (Get(enumGET.LARA, 0,0)==false) return;

	LogOnDebug("Phase=%s DStateId=%2d DAnim=%d Room=%d Input=$%x",
		FlagPhaseToText(BaseDrone.DronePhase), GET.pItem->StateIdCurrent, GetRelativeAnimation(GET.pItem), 
		GET.pItem->Room ,
		Trng.pGlobTomb4->KeysStopped);
}

// this procedure will be called every game cycle (at begin of cycle)
void cbCycleBegin(void)
{



	// only for #debug#
	//LogDrone();


}


// Not yet linked! To link it add to RequireMyCallBacks() function the row:
//  	GET_CALLBACK(CB_CYCLE_END, 0, 0, cbCycleEnd);
// this procedure will be called everygame cycle, at end.
// you have to return a RET_CYCLE_ value
int cbCycleEnd(void)
{
	return RET_CYCLE_CONTINUE;
}

void ProcDroneInit(short ItemIndex)
{
	BaseDrone.DronePhase =0;

	Get(enumGET.ITEM, ItemIndex,0);

	GET.pItem->StateIdCurrent = 0;
	GET.pItem->StateIdNext = 0;

	Get(enumGET.SLOT, GET.pItem->SlotID ,0);
	
	GET.pItem->AnimationNow = GET.pSlot->IndexFirstAnim;

	Get(enumGET.ANIMATION, GET.pItem->AnimationNow,0);

	GET.pItem->FrameNow = GET.pAnimation->FrameStart;
	
	GET.pItem->FlagsMain = enumFITEM.NOT_YET_ENABLED | enumFITEM.CREATURE  | enumFITEM.NOT_VISIBLE;

	GET.pItem->CordY -= PROF_GAP_OVER_FLOOR;
}

void ProcDroneCollision(short ItemIndex, StrItemTr4 *pLara, StrCollisionLara *pLaraCollision)
{
	int StateId;

	// if real drone is invisible ignroe collisions
	if (BaseDrone.TestVisibleRealDrone == false) return;
	Get(enumGET.ITEM, ItemIndex, 0);

	if (TriggerActive(GET.pItem)== false) return;
	// if drone has not running propellers, don't hurt lara
	StateId = GET.pItem->StateIdCurrent;
	if (StateId == 1 || StateId == 5 || StateId == 6 || StateId == 7) return;


	if (GetMaxDistance(&GET.pItem->CordX, &pLara->CordX, false) > 1024) return;

	if (TestBoundCollide(GET.pItem, pLara, pLaraCollision->LaraSizeX)==false) return;

	if (TestCollision(GET.pItem, pLara)==false) return;

	// lara and drone are in collision
	// reduce health of lara (at least if she was not already dead)
	if (pLara->Health > 0) {
		// avoid to perform two hurting in a row
		if ((pLara->FlagsMain & enumFITEM.ITEM_HAS_BEEN_HIT) ==0) {
			// toggle HP value
			pLara->Health -= 10;
			// sound for LARA_INJURY
			SoundEffect(31, &GET.pLara->CordX, 0);
			// show HP bar on the screen
			pLara->FlagsMain |= 0x10;
		}

	}
	
}


void DestroyShatterObject(int Index, int RoomIndex)
{

	StrMeshInfo *pMeshInfo;
	int i;

	pMeshInfo = &Trng.pGlobTomb4->pAdr->pVetRooms[RoomIndex].Ptr_StaticMesh[Index];
	if ((pMeshInfo->OCB & OCBS_ATTIVO)==0) return;

	ShatterObject(NULL, pMeshInfo,  0x80, RoomIndex, -2);
	pMeshInfo->OCB &= ~OCBS_ATTIVO;
	SoundEffect(0x15b, pMeshInfo, 0);
	i = *Trng.pGlobTomb4->pAdr->pTotDestroyedShatters;
	Trng.pGlobTomb4->pAdr->pVetRoomOfDestroyedShatter[i] = RoomIndex;
	Trng.pGlobTomb4->pAdr->pVetStructOfDestroyedShatter[i] = pMeshInfo;
	(*Trng.pGlobTomb4->pAdr->pTotDestroyedShatters)++;
	pMeshInfo->OCB |= OCBS_SALVARE;

}
// try to kill a semigod
void KillSemigod(short ItemIndex)
{
	// action trigger14: Exploding creature
	PerformActionTrigger(NULL, 14, ItemIndex, 4);

	// action trigger14: Remove immediatly (disappear any item)
	PerformActionTrigger(NULL, 14, ItemIndex, 1);
}
int GetRelativeAnimation(StrItemTr4 *pItem)
{
	StrSlot *pSaveSlot;
	int FirstAnimation;
	int RelativeIndex;

	// save the slot structure in GET structure to avoid to change this value that it could be used from calling code
	pSaveSlot = GET.pSlot;

	Get(enumGET.SLOT, pItem->SlotID,0);

	FirstAnimation = GET.pSlot->IndexFirstAnim;

	// restore slot structure
	GET.pSlot = pSaveSlot;


	RelativeIndex = pItem->AnimationNow - FirstAnimation;

	return RelativeIndex;
}

void GetItemSize(int ItemIndex, int *pTopY, int *pRadius)
{

	int CordYTop;
	int Distance;

	Get(enumGET.ITEM, ItemIndex,0);

	Get(enumGET.ITEM_COLL_BOX, ItemIndex,0);

	CordYTop = GET.pItem->CordY + GET.pCollItem->MinY;

	Distance = GET.pCollItem->MaxX - GET.pCollItem->MinX;

	Distance = Distance / 2;

	*pTopY = CordYTop;
	*pRadius = Distance;
}

// push away item with index SecondaryIndex to get it more far by ItemMainIndex
void ItemPushAwayItem(short ItemMainIndex, short SecondaryIndex)
{
	StrItemTr4 *pMain;
	short Direction;
	int IncX;
	int IncZ;
	StrItemTr4 *pSaveItem;
	int Radius;
	int TopY;


	pSaveItem= GET.pItem;

	// discover radius (medium half size of main item):
	GetItemSize(ItemMainIndex, &TopY, &Radius);

	Get(enumGET.ITEM, ItemMainIndex,0);
	pMain= GET.pItem;

	Get(enumGET.ITEM, SecondaryIndex,0);
	// discover direction from main item to secondary item:
	Direction=GetDirection(pMain->CordX, pMain->CordZ, GET.pItem->CordX, GET.pItem->CordZ);
	GetIncrements(Direction, &IncX, &IncZ, 32);
	// to push away the item until there are no more collision between two collision boxes
	while (TestBoundCollide(pMain, GET.pItem, Radius) == true) {
		// move secondary item
		GET.pItem->CordX += IncX;
		GET.pItem->CordZ += IncZ;
	}

	UpdateItemRoom(SecondaryIndex);
	CheckFloor(GET.pItem->CordX, GET.pItem->CordY, GET.pItem->CordZ, GET.pItem->Room);
	GET.pItem->HeightFloor = FLOOR.FloorHeight;
	// restore GET.pItem
	GET.pItem = pSaveItem;
	
}


void QuitDroneMode(void)
{
	WORD StateIdNow;

	// if it is already in progress, quit
	if (BaseDrone.DronePhase & DP_QUIT_DRONE_MODE) return;

	LogOnDebug("QuitDroneMode()");

	if (BaseDrone.TestCutScene == false ) {
		// set animation (for lara) to put off the controller
		// if lara is under attack use the fast version of animation
		if (GET.pLara->FlagsMain & enumFITEM.ITEM_HAS_BEEN_HIT) {
			ForceAnimationForLaraFromSlot(6, enumSLOT.DRONE_LARA);
		}else {
			// otherwise, the normal animation
			ForceAnimationForLaraFromSlot(3, enumSLOT.DRONE_LARA);
		}
	}
	BaseDrone.DronePhase |= DP_QUIT_DRONE_MODE;
	// removing further "ready" phase
	BaseDrone.DronePhase &= ~DP_READY;
	RemoveMSG(MSG_READY);
	// removing further "take off" phase
	BaseDrone.DronePhase &= ~DP_TAKE_OFF;
	RemoveMSG(MSG_TAKE_OFF);

	if (BaseDrone.DronePhase & DP_FLYING) {
		// drone is flying
		// if there is no return to home
		// then activate landing
		if (BaseDrone.DronePhase & DP_RETURN_TO_HOME) return;
		// there was no RTH
		// then set the landing
		BaseDrone.DronePhase |= DP_LANDING;
		return;
	}
	// if drone is not flying, analyse state id
	Get(enumGET.ITEM, BaseDrone.IndexRealDrone,-1);

	StateIdNow = GET.pItem->StateIdCurrent;		

	switch (StateIdNow) {
	case 1:
		// drone is already on the ground with stil propellers, just only force animation to close the arms
		ForceAnimationForItem(GET.pItem, 4,-1);
		BaseDrone.DronePhase |= DP_PREPARING_TO_PICKUP;
		break;
	case 7:
		// drone e' gia' con braccia chiuse
		// basta trasformarlo in pickup
		BaseDrone.IndexPickupDrone = TransformDroneToPickUp(0);
		break;
		
	}


}
// return true if drone is moving up, comparing lastposition (in previous game cycle) and current given Y coordinate)
bool IsDroneMovingUp(int NowY)
{

	if (NowY < BaseDrone.LastPosition.CordY) return true;
	return false;
}
// perform a check for collision ONLY on room geometry of given point
// the CordY should be always the Y drone and it will performed a test for top side of drone adding to CordY a negative value to
//		to simulate the top height (tall) of drone's object
// if there is a collision, it will return "true" and will set in *pTypeColl the collision type
bool IsThereGeoCollision(int *pTypeColl, DWORD CordX, int CordY, DWORD CordZ, int Room, int CmdDirection)
{

	// now perform  check about floor in NewX, NewY, NewZ position
	if (CheckFloor(CordX , CordY , CordZ , Room  )==false) {
		// invalid floor: there ia a collsiion. We have to get if it was against wall or celing, anwyay, when
		// there is invalid floor it should be a wall collision, because below the ceiling there should be anyway a valid
		// floor data
		*pTypeColl |= COLL_WALL;
		return true;
	}
	if (BaseDrone.Flags & DRF_FORBIDDEN_BOXES) {
		// if current sector is a gray sector: collide
		if (FLOOR.TestGraySector == true) {
			*pTypeColl |= COLL_BOX_SECTOR;
			return true;
		}
	}
	// if heigth of floor is over bottom (origy) of drone, we are smashing against a wall
	// anyway, we have to remmeber that upwad size has little y values, so when FlooHeight has lower value
	// than Y Drone position, it means that floor is heigher in 3d space
	if (FLOOR.FloorHeight < (CordY-PROF_GAP_OVER_FLOOR)) {
		if (CordY != BaseDrone.LastPosition.CordY ) {
			*pTypeColl |= COLL_FLOOR;
		}else {

			*pTypeColl |= COLL_WALL;
		}

		return true;
	}


	// if ceiling is lower (in 3d space) of highest Y 3d pos of drone, we have another collision
	if (FLOOR.CeilingHeight > (CordY - PROF_FULL_HSIZE_DRONE)) {
		// now we have to understand if this is a collision againt ceiling or wall. Let's say it will depend
		// by current direction
		if (IsDroneMovingUp(CordY)==true) {
			// drone was movign upward, so a collision with ceiling
			*pTypeColl |= COLL_CEILING;
			return true;
		}
			
		// otherwise it's a collison with wall
		*pTypeColl |= COLL_WALL;
		return true;
		
	}
	return false;
}
// this function will be called when drone is touching a moveable item
void DroneCollidesWithItem(StrItemTr4 *pItem, int ItemIndex)
{

	// singal GT_DRONE_COLLIDE_ITEM global trigger
	Trng.pGlobTomb4->IndiceItemCondizione = ItemIndex;
	DetectedGlobalTriggerEvent(GT_DRONE_COLLIDE_ITEM, pItem->SlotID,false);

	// verify if there was flag to engage trigger group for a collision with this item
	if (BaseDrone.Flags & DRF_ENGAGE_TGROUP_ON_ITEM_COLLISION) {
		// let's see if the item has right slot

		if (pItem->SlotID == BaseDrone.Extra1) {
			// yes, it is
			// execute triggergorup
			// using flipeffect 371: "TriggerGroup. Perform <&>TriggerGroup from script.dat (Single execution to use when in TriggerGroup there are only commands"
			// save index of item to "item found on last condition" trng variable
			Trng.pGlobTomb4->IndiceItemCondizione = ItemIndex;
			// and perform the triggergroup

			PerformFlipeffect(NULL, 371, BaseDrone.Extra2, 0);

		}
	}

}

// drone collided with static item
// note: if static was a shatter and it has been destroyed by drone, the function will return "true"
bool DroneCollidesWithStatic(StrMeshInfo* pStatic, int StaticNgleIndex)
{
	bool RetValue;

	RetValue=false;

	// engage GT_DRONE_COLLIDE_STATIC global trigger
	Trng.pGlobTomb4->IndexNgleStaticCondition = StaticNgleIndex;
	DetectedGlobalTriggerEvent(GT_DRONE_COLLIDE_STATIC, pStatic->SlotId, false);

	// verify if it is a shatter to destroy
	if (BaseDrone.Flags & DRF_DESTROY_SHATTERS) {
		// verify if static item is a shatter

		if (pStatic->SlotId >= Trng.pGlobTomb4->pBaseCustomize->ShatterInizio &&
				pStatic->SlotId <= Trng.pGlobTomb4->pBaseCustomize->ShatterFine) {
			// it is a shatter: destroy it

			// now we use the flieffect 160 to destroy the shatter
			PerformFlipeffect(NULL, 160, StaticNgleIndex, 0);

			// signal destroying of static
			RetValue=true;
		}

	}

	if (BaseDrone.Flags & DRF_ENGAGE_TGROUP_ON_STATIC_COLLISION) {
		// verify if this is right static to engage triggergroup
		if (pStatic->SlotId == BaseDrone.Extra1) {
			// yes: now we save the (ngle) index of static to "last condition"
			Trng.pGlobTomb4->IndexNgleStaticCondition = StaticNgleIndex;
			// and perform the triggergroup
			PerformFlipeffect(NULL, 371, BaseDrone.Extra2, 0);
		}
	}
	return RetValue;
}
// function to verify if drone will collide with geometry or some item
// return a COLL_ value with info if there is a collison and of what kind
// se drone was mvoign, supplying in CmdDirection the received CMD_ command , this function
// we'll be able to return correct collsion with walls or ceiling
// INPUT VALUES:
// pDrone = pointer for Drone with coordinate set at new positon (the postion to check for collision with items)
// TestMain = if "true" it means the function has been called in "main" control for real movmenet of drone. In some
//				circustance it will be "false" because the code is parsing secondary paths to verify how to reach a target
//				only when TestMain is true, it will be engaged triggergroup or global triggers for collisions with moveable or static items.
// pGeo = position only for geomtry check: it should be the pDrone position +/- half size of drone in the direction of moving
//		In the case we are checking that is already final position (in pDrone), the pGeo position could be let the same of pDrone's position
// CmdDirection = CMD flag with input command that affected last movement
int CheckCollisionForDrone(StrItemTr4 *pDrone, bool TestMain, GAME_VECTOR *pGeo, int CmdDirection)
{
	bool TestIgnore;
	int TypeColl;
	int StaticNgleIndex;
	int ItemIndex;
	int YTopBox;
	short RoomIndex;
	int YBottomBox;
	StrMeshInfo* pStatic;
	StrItemTr4 *pItem;
	StrBoxCollisione * pBox;
	int IncX;
	int IncZ;
	int Index;

	
	TypeColl= COLL_NO_COLLISION;
	BaseDrone.CollisionItemIndex = -1;

	// perform check on current point
	if (IsThereGeoCollision(&TypeColl, pGeo->CordX, pGeo->CordY, pGeo->CordZ, pGeo->Room,CmdDirection) ==true) return TypeColl;
	// now, if direction is forward, check also two other point of collision box; at left and at right
	if ((CmdDirection & PROF_GAME_FORWARD) == PROF_GAME_FORWARD) {
		// drone is movign forward
		// compute the two points, at its left and then at its right
		// at left (-90 degrees respect current facing)
		GetIncrements(pDrone->OrientationH -0x4000, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);
		if (IsThereGeoCollision(&TypeColl, pGeo->CordX+IncX, pGeo->CordY, pGeo->CordZ+IncZ, pGeo->Room,CmdDirection) ==true) return TypeColl;

		// now at right (+90 degrees)
		GetIncrements(pDrone->OrientationH + 0x4000, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);
		if (IsThereGeoCollision(&TypeColl, pGeo->CordX+IncX, pGeo->CordY, pGeo->CordZ+IncZ, pGeo->Room,CmdDirection) ==true) return TypeColl;

	}


	// ---------------------------- CHECK FOR COLLISION WITH ITEMS ------------------------------------------

	// now we have to verify also a further collision on an object: moveable or static item
	// to check collision with items, we'll use the pDrone position that should be new positon where we are trying to place
	// the drone after the last movement

	GetCollidedObjects(pDrone, 0, true, &pItem, &pStatic, true);


	if  (pItem != NULL) {
		ItemIndex = ConvertFromStrItemToItemIndex(pItem);
		// collision with a moveable, anyway let's see if we can ignore this moveable
		// if the item is the same drone, ignore it
		if (pItem->SlotID == enumSLOT.DRONE) pItem=NULL;
	}
	if (pItem != NULL) {
		// we'll perform a second check on vertical collision if drone is over (or below) the item, 
		// because I saw that GetCollidedObjects() function create a large margin above an item

		// let's get current collision box
		pBox = GetBestFrame(pItem);


		// and now we'll check if the drone is really able to touch lara in vertical
		// we'll compare the Y origin of drone (that is its lower side) with
		// MinY value of lara's collision box (that is higher side of the box)
		// we'll add also a little safety gap
		// the collision box values are realative to the item but we need to have the absolute coordinate
		// adding the positon of the item

		YTopBox = pBox->MinY + pItem->CordY;

		if (pDrone->CordY  < YTopBox) {
			// the drone is above this item, it's not possible it's touching it
			// so we reset found item
			pItem=NULL;

		}

		// oher chance, that drone was below item

		if (pItem != NULL) {
			YBottomBox = pBox->MaxY + pItem->CordY;
			if ((pDrone->CordY - PROF_FULL_HSIZE_DRONE) > YBottomBox) {
				// the drone is below the collision box of this item
				pItem=NULL;
			}
		}
		
		// if the item is a keyitem ignore it
		if (pItem != NULL) {
			if (pItem->SlotID >= enumSLOT.KEY_ITEM1 && pItem->SlotID <= enumSLOT.KEY_ITEM12) {
				if (TestMain==true) DroneCollidesWithItem(pItem,ItemIndex);
				pItem=NULL;
			}
		}
		// if the itme is a creature but it has not yet been activated (then it is practally invisble)
		if (pItem != NULL) {
			if ((pItem->FlagsMain & enumFITEM.CREATURE)!= 0 && TriggerActive(pItem)==false) pItem=NULL;
		}

		if (pItem) {
			TypeColl |= COLL_MOVEABLE_ITEM;
			BaseDrone.CollisionItemIndex = ItemIndex;

			if (TestMain == true) DroneCollidesWithItem(pItem, ItemIndex);

		}
	}

				
	// check further static item
	if (pStatic != NULL) {
		// now we have to discover the single ngle index of this static, working on its room and static index in that room
		RoomIndex = Trng.pGlobTomb4->RoomOfCollidedStatics;
		Get(enumGET.ROOM, RoomIndex,0);
		// compute the index
		Index = (int) ( pStatic - GET.pRoom->Ptr_StaticMesh);
		StaticNgleIndex= Convert(enumCONV.StaticIndexFromTombToNgle, RoomIndex, Index, NULL);

		// verify if this item can really stop drone
		TestIgnore=false;

		if (pStatic->OCB & 0x004) {
			// static has no collision, anyway drone is touching it: check if there were actions to engange for collision with this kind of static
			if (TestMain==true) DroneCollidesWithStatic(pStatic, StaticNgleIndex);
			
			TestIgnore=true;
		}
		// if static is not active (or it has been destroyed) ignore it
		if ((pStatic->OCB & 0x001)==0) TestIgnore=true;

		if (TestIgnore==false) {
			// if static is a shatter, perhaps the drone could destroy it, removing collision
			if (TestMain==true) {
				if (DroneCollidesWithStatic(pStatic, StaticNgleIndex)==true) {
					// static was a shatter and it has been destroyed by drone: no more collision with it
					TestIgnore=true;
				}
			}
		}

		if (TestIgnore==false) {
			TypeColl |= COLL_STATIC_ITEM;
			
			BaseDrone.CollisionStaticIndex = Index;
			BaseDrone.CollisionStaticRoom = RoomIndex;
			if (TestMain) DroneCollidesWithStatic(pStatic, StaticNgleIndex);


		}
	}
	return TypeColl;
}
// when it's not possible reaching some target, on Y coordinate (DP_REACH_Y_TARGET) or for (x,z) coorrdinate (DP_CHASE_TARGET)
// this function try to set how to handle this situation
void ManageFailure(StrItemTr4 *pDrone)
{
	char *pArg;

	LogOnDebug("ManageFailure()");


	BaseDrone.TestUserCommand=false;

	if (BaseDrone.TestCutScene == true) {


		// remove all old phases
		BaseDrone.DronePhase &= ~( DP_RETURN_TO_HOME | DP_READY | DP_TAKE_OFF | DP_CHASE_TARGET |
										DP_REACH_Y_TARGET | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION );	
		// now: if drone has still a bit of energy (not battery = 0) and the failed phase was not landing, then try now to land
		if (BaseDrone.PercBattery > 0 && (BaseDrone.DronePhase & DP_LANDING) == 0) {
			// force now the landing
			BaseDrone.DronePhase |= (DP_LANDING | DP_EMERGENCY_LANDING | DP_FAILURE);
			return;

		}
		// in other cases: do to fall down the drone
		// start crash phase
		BaseDrone.DronePhase |= (DP_CRASH_IN_PROGRESS|DP_FAILURE);
		return;
	}
	// if drone has been lost (no signal) and it has been failed a landing or recover last safe postion, 
	// enable a crash
	if (BaseDrone.PercSignal == 0) {
		if ((BaseDrone.DronePhase & (DP_LANDING | DP_EMERGENCY_LANDING)) !=0) {
			// remove all other intermeidate phases
			BaseDrone.DronePhase &= ~(DP_LANDING | DP_RETURN_TO_HOME | DP_READY | DP_TAKE_OFF | DP_CHASE_TARGET |
										DP_REACH_Y_TARGET | DP_EMERGENCY_LANDING | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION );			
			// start crash phase
			BaseDrone.DronePhase |= (DP_CRASH_IN_PROGRESS|DP_FAILURE);
			return;
		}
	}
	// if battery is exhaust then there is no chance, the drone will crash on the ground
	if ((BaseDrone.DronePhase & DP_LOST_DRONE) != 0 && BaseDrone.PercBattery < PROF_BATTERY_LEVEL_EMERGENCY_LANDING) {


		BaseDrone.FallingSpeed = PROF_VSPEED;
		// remove all other intermeidate phases
		BaseDrone.DronePhase &= ~(DP_LANDING | DP_RETURN_TO_HOME | DP_READY | DP_TAKE_OFF | DP_CHASE_TARGET |
										DP_REACH_Y_TARGET | DP_EMERGENCY_LANDING | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION );
		// start crash phase
		BaseDrone.DronePhase |= (DP_CRASH_IN_PROGRESS|DP_FAILURE);
		return;
	}
	// there is still a bit of battery

	// try to get what was the drone trying to get
	if (BaseDrone.DronePhase & DP_RETURN_TO_HOME) {
		// trying a return to home: fail the return to home
		pArg=GetTextFailedPhase(DP_RETURN_TO_HOME);
		ShowMessage(true, MSG_FAILED_OPERATION, PROF_LONG_TIME_WARNING_MSG, pArg);
		// remove return to home phase and all target chasing
		BaseDrone.DronePhase &= ~(DP_RETURN_TO_HOME | DP_LANDING | DP_EMERGENCY_LANDING | DP_CHASE_TARGET | DP_REACH_Y_TARGET);
		// add failure phase, to avoid to retry again
		BaseDrone.DronePhase |= (DP_LANDING | DP_EMERGENCY_LANDING | DP_FAILURE);
		return;
	}

	if (BaseDrone.DronePhase & DP_RECOVERING_SAFE_POSITION) {
		// failed the recovery of safe position
		pArg=GetTextFailedPhase(DP_RECOVERING_SAFE_POSITION);
		ShowMessage(true, MSG_FAILED_OPERATION, PROF_LONG_TIME_WARNING_MSG, pArg);
		// remove the attempt to recover safe position
		BaseDrone.DronePhase &= ~(DP_RECOVERING_SAFE_POSITION | DP_LANDING | DP_EMERGENCY_LANDING | DP_CHASE_TARGET | DP_REACH_Y_TARGET);
		BaseDrone.DronePhase |= DP_FAILURE;
		return;
	}
	// some sort of landing?
	if ((BaseDrone.DronePhase & (DP_LANDING | DP_EMERGENCY_LANDING))!=0) {
		pArg=NULL;

		if (BaseDrone.DronePhase & DP_EMERGENCY_LANDING) pArg= GetTextFailedPhase(DP_EMERGENCY_LANDING);

		if (pArg==NULL) {
			pArg= GetTextFailedPhase(DP_LANDING);
		}
		ShowMessage(true, MSG_FAILED_OPERATION, PROF_LONG_TIME_WARNING_MSG, pArg);
		// remove the attempt to recover safe position
		BaseDrone.DronePhase &= ~(DP_LANDING | DP_EMERGENCY_LANDING | DP_CHASE_TARGET | DP_REACH_Y_TARGET);
		BaseDrone.DronePhase |= DP_FAILURE;
		return;

	}

	if (BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT) {
	
		// start crash phase
		BaseDrone.DronePhase |= DP_CRASH_IN_PROGRESS;
		BaseDrone.FallingSpeed = PROF_VSPEED;
		// remove all other intermeidate phases
		BaseDrone.DronePhase &= ~(DP_LANDING | DP_EMERGENCY_LANDING | DP_RETURN_TO_HOME | DP_READY | DP_TAKE_OFF | DP_CHASE_TARGET |
										DP_REACH_Y_TARGET | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION );
		BaseDrone.DronePhase |= DP_FAILURE;
		return;
	
	}
	// generic failure
	pArg="To reach target";
	ShowMessage(true, MSG_FAILED_OPERATION, PROF_LONG_TIME_WARNING_MSG, pArg);
	// remove the target phases
	BaseDrone.DronePhase &= ~(DP_CHASE_TARGET | DP_REACH_Y_TARGET);
	BaseDrone.DronePhase |= DP_FAILURE;

}
// this function check if it's possible move drone from Start_Y position, upto EndY
// if it's not possible performing any movement in that y direction will return false
// if it's possible, it will return "true" and in pFinal_Y will set the real Y reached coordinate that
// could be different than End_Y
bool CheckForYTarget(StrItemTr4 *pDrone, int Start_Y, int End_Y, int *pFinal_Y)
{
	int IncY;
	int DifY;
	GAME_VECTOR OldPos;
	GAME_VECTOR GeoPos;
	int GapY;
	bool TestCollision;
	int TypeColl;
	int CmdDirection;



	*pFinal_Y = -32400;
	// now we save original drone's position (to restore then, at end)
	CopyItemToPos(pDrone, OldPos);

	do {
		TestCollision=false;
		// discover increment to use ,to check upward or backward direction
		DifY = End_Y - Start_Y;

		if (DifY == 0) {
			// we reached end_y
			IncY =0;
		}else {


			if (DifY < 0) {
				// we'll use a negative incremnt
				IncY = -PROF_VSPEED;
				// since we are moving upward, we set a GapY the tall of drone object
				GapY = -PROF_FULL_HSIZE_DRONE;

				// simultate upward game command
				CmdDirection = PROF_GAME_UP;
		
			}else {
				// in this case a positive incrmeent
				IncY = PROF_VSPEED;
				// we are moving down, no gap to set, the Y position of drone is already on its base
				GapY=0;
				CmdDirection = PROF_GAME_DOWN;
		
			}
			// if the y distance is littler than curnet increment, use y difference as increment
			if (abs(IncY) > abs(DifY)) IncY=DifY;

		}
		if (IncY != 0) {
			// check for collision in this position
			pDrone->CordY += IncY;
			// update room
			if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room)==true) {
				pDrone->Room = FLOOR.RoomIndex;

				CopyItemToPos(pDrone, GeoPos);
				GeoPos.CordY += GapY;

				TypeColl= CheckCollisionForDrone(pDrone, false, &GeoPos, CmdDirection);
				if (TypeColl == COLL_NO_COLLISION) {
					TestCollision=false;
				}else {
					TestCollision =true;
				}
			}else {
				// invalid floor: surely there is collison
				TestCollision=true;
			}
		
		}
		// untile there is no collisione, we save current cordy as "good" final y
		if (TestCollision==false){
			*pFinal_Y = pDrone->CordY;
		}
	}while (IncY !=0 && TestCollision);
	// restore old pos for drone
	CopyPosToItem(OldPos, pDrone);

	// let's see how we completed the compute
	if (IncY == 0) {
		// ok, reached the wished target
		*pFinal_Y = End_Y;
		return true;
	}

	// we ddidnt', so there has been collision
	// we'll return last valid final y, at least there had not been either one
	if (*pFinal_Y == -32400) {
		*pFinal_Y = Start_Y;
		return false;
	}

	return true;

}
// save current x,z position (of new random target) in last target array
// keeping always last targets
void SaveLastTarget(DWORD x, DWORD z)
{
	int i;
	int Index;

	Index = BaseDrone.TotLastTargets;
	if (Index >= MAX_LAST_TARGETS) {
		// we have to move old target by one index position, to keep only last three
		for (i=0;i < MAX_LAST_TARGETS-1;i++) {
			BaseDrone.VetLastTarget[i] = BaseDrone.VetLastTarget[i+1];
		}
		Index=MAX_LAST_TARGETS-1;
	}

	BaseDrone.VetLastTarget[Index].x = (int) x;
	BaseDrone.VetLastTarget[Index].y = (int) z;

	BaseDrone.TotLastTargets = Index+1;
	
}

// check if the input x,z coordinates are the same than some old last attempted target
bool IsLastTarget(DWORD x, DWORD z)
{
	int i;

	for (i=0;i<BaseDrone.TotLastTargets;i++) {
		if (BaseDrone.VetLastTarget[i].x == x &&
			BaseDrone.VetLastTarget[i].y == z) return true;
	}
	return false;
}
//the drone is trying to land but, below it there is no good sector
// in this function we set a a random horizontal direction (where there will be space in front) moving the drone of 2 sectors to retry newly
// to land
bool FindRandomDirectionAsTarget(StrItemTr4 *pDrone)
{

	int IncX;
	int IncZ;
	int i;
	bool TestCollisione;
	GAME_VECTOR Target;
	GAME_VECTOR OldPos;
	DWORD EndX, EndZ;
	bool TestOk;
	WORD SaveFacing;

	// if drone is not in the middle of current sector, force it at that position
	if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room)==true) {
		pDrone->CordX = FLOOR.SectorCoords.MiddleX;
		pDrone->CordZ = FLOOR.SectorCoords.MiddleZ;
	}
	// we save original position of drone, because now we are goin to change (temporarily) its position
	CopyItemToPos(pDrone, OldPos);
	SaveFacing = pDrone->OrientationH;

	// looking for a random direction where there is free way (in horizontal) for at least 2 sectors
	i=0;
	do {
		IncX=VetIncAttempts[i].x;
		IncZ=VetIncAttempts[i].y;
		pDrone->OrientationH = VetDirectionAttempt[i];

		if (IncX != 0 || IncZ != 0 ) {
			// ok scan for two sector this direction (at same currnet heiht of drone)
			// if it is free this will be target to reach 
			EndX = OldPos.CordX + IncX * 1024 * 2;
			EndZ = OldPos.CordZ + IncZ * 1024 * 2;
			if (IsLastTarget(EndX, EndZ) == true) {
				TestOk = false;
			}else{
				// now we'll check every 256 game units, to avoid to skip some little static in the midle
				// startic always from original drone position (save to OldPos)
				Target = OldPos;
				TestCollisione=false;
				TestOk=true;
				do {
					Target.CordX += (256 * IncX);
					Target.CordZ += (256 * IncZ);
				
					// check floor to update room
					if (CheckFloor(Target.CordX, Target.CordY, Target.CordZ, Target.Room)==true) {

						Target.Room = FLOOR.RoomIndex;

						// we have to copy this positon in pDrone
						CopyPosToItem(Target, pDrone);

						if (CheckCollisionForDrone(pDrone, false, &Target, PROF_GAME_FORWARD)!= COLL_NO_COLLISION) {
							// Collision! no good direction
							TestOk=false;
							break;
						}
					}else {
						// floor was invalid: quit
						TestOk=false;
						break;
					}

				}while (Target.CordX != EndX || Target.CordZ != EndZ);
			}
			if (TestOk==true) {

				// we reached the target
				// so this is good.
				// copy this as target
				BaseDrone.DronePhase |= DP_CHASE_TARGET;
				BaseDrone.Target = Target;
				SaveLastTarget(EndX, EndZ);
				// restore drone position
				CopyPosToItem(OldPos, pDrone);
				pDrone->OrientationH = SaveFacing;
				return true;
			}
		}
		i++;
	}while (IncX != 0 || IncZ != 0);
	// restore orignal drone position
	CopyPosToItem(OldPos, pDrone);
	pDrone->OrientationH = SaveFacing;

	// no direction it's possible (worst situation)

	// then... handle failure
	ManageFailure(pDrone);
	return false;

}
// a very complicated function...
// when there is an automatic landing the drone will have to choose a valid sector where landing
// it will be necessary avoid items, and tilted sectors. The problem is when, below the drone, there are
// only bad sectors. In this case the drone will have to cruise, moving horizontally (x and z) until to reach
// a valid targe.
// note: if it found immediately a good second to land, this function will return "true"
//       while, if it will be necessary peform some intermediate movements, it will return "false"
// This code will do:
// 1) Verify if, below drone (current sector below it) it's already a good sector (FLAT and with no items)
// 2) Ihe case the above point didn't work (point 1), it will look for all 6 sector around main sector (that below the drone)
// 3) If neither of these "border" sectors there is one good, the code will repeat this code (points 1 and 2) for Gentle slope sectors
//    It means that will get enough a sector with a little (walkable) tilt
// 4) In the case, neither gentle slope sectors were available, the drone we'll give up for target now, and it will move the drone 
//    in some random direction to try newly all above checks (points: 1,2)

bool FindTargetForLanding(StrItemTr4 *pDrone)
{

	GAME_VECTOR Target; // 3d point where drone could landing (to avoid items, and tilt sectors)
	bool TestGoodSector;
	StrItemTr4 *VetFoundItems[20];
	StrMeshInfo *VetFoundStatics[20];
	GAME_VECTOR OldPos;
	bool TestRealObstacle;
	int i;
	int IndexAttempt;
	int IncX, IncZ;
	bool TestStopBox;
	int FloorTypeTemp;
	bool TestOnWater;
	bool TestValidFloor;
	int GroundY;


	

	// in first attempt on border sector, we'll require a FLAT sector
	FloorTypeTemp = enumSLOPE.FLAT;
	// but, if first attempt will fail, we'll retry modifying FloorTypeTemp with enumSLOPE.GENTLE_SLOPE 

	// we save current position and room of drone, because we'll have (in this function) to change them to verify if it could land
	// in a far (and lower) sector
	CopyItemToPos(pDrone, OldPos);


	// we'll have to peform different attempts
	IndexAttempt=0;
	// at start we set as landing target the sector below the drone

	CopyItemToPos(pDrone, Target);
	
	TestGoodSector = false;
	// we'll check different sector, until to reach that good
	while (TestGoodSector==false) {
		TestOnWater=false;
		
		if (CheckFloor(Target.CordX  , Target.CordY , Target.CordZ , Target.Room )==false) {
			TestValidFloor=false;
		}else {
			TestValidFloor=true;
			// now we move the position on the floor
			Target.CordY = FLOOR.FloorHeight;
			// and update room
			Target.Room = FLOOR.RoomIndex;
			// and set the ideal coordinate in the middle of the sector
			Target.CordX = FLOOR.SectorCoords.MiddleX;
			Target.CordZ = FLOOR.SectorCoords.MiddleZ;
			GroundY= FLOOR.FloorHeight;

			// is a room with water?
			if (FLOOR.WaterHeight != WALL_FLOOR) {
				TestOnWater=true;
				GroundY = FLOOR.WaterHeight;
			}

			// note: in the case the point we are checking is invalid (inside a wall) there will TestFullWall =true

			// The sector has to be flat or gentle slope (this time we have to settle, because pretending only flag sector
			// could be impossible in some side of the level
			TestStopBox=false;
			if (BaseDrone.Flags & DRF_FORBIDDEN_BOXES) TestStopBox=FLOOR.TestGraySector;

		}


		if (TestValidFloor==true && FLOOR.TestFullWall == false &&  TestStopBox==false && 
						(TestOnWater==true || 
							( FLOOR.SlopeType == enumSLOPE.FLAT  || FLOOR.SlopeType == FloorTypeTemp ))) {
			TestGoodSector=true;
			// perform better check about the chance that currnet sector was GENTLE_SLOPE
			if (FLOOR.SlopeType == enumSLOPE.GENTLE_SLOPE  && TestOnWater==false) {
				// so, we are in second attempt, where we accept also GENTLE_SLOPE (instead that only FLAT, as it happens in first attempt)
				// but if the current gentle slope has 2 click of tilt we should refuse it
				if (FLOOR.SlopeClickGrade >= 2) TestGoodSector=false;
			}
		}
		// if the floor of sector we are analysing, is upper of drone position, it's not a good sector
		if (TestGoodSector==true) {
			if (OldPos.CordY > GroundY || OldPos.CordY < FLOOR.CeilingHeight) TestGoodSector=false;
		}

		if (TestGoodSector==true) {

			// sector type is fine, now we have to verify that there were no items in that sector
			// look for moveables
			Find(enumFIND.ITEMS_SECTOR, -1, Target.Room , -1,-1, &Target);
			
			for (i=0;i<FIND.TotItems;i++) {
				// there is an item, anyway we could ignore it in the case it was untriggere (still invisible) or very little (like KEY slots)
				Get(enumGET.ITEM, FIND.VetItems[i], 0);
				// consider as "not preset" the moveable if it is a creature and it's not have been activated
				TestRealObstacle = true;
				if ((GET.pItem->FlagsMain & enumFITEM.CREATURE)!=0 && TriggerActive(GET.pItem)==false) TestRealObstacle=false;

				if (TestRealObstacle==true) {
					// let's see if it is only a key or the same drone (it maybe ,if it was very close to the ground)

					if ((GET.pItem->SlotID >= enumSLOT.KEY_ITEM1 && GET.pItem->SlotID <= enumSLOT.KEY_ITEM12) ||
																		GET.pItem->SlotID == enumSLOT.DRONE) TestRealObstacle=false;
				}
				if (TestRealObstacle==true) {
					//This sector is not good for landing
					TestGoodSector=false;
					break;
					
				}
			}

			if (TestGoodSector==true) {
				// current sector is good about moveable items, now we'll check for static items
				// since static items could have a big size, and collision box, we'll use the GetCollidedObjects() function

				// we move the drone in position of current sector
				CopyPosToItem(Target, pDrone);
				GetCollidedObjects(pDrone, 0, true, VetFoundItems, VetFoundStatics, true);

				for (i=0;i<FIND.TotStatics;i++) {
					// there is a static, let's see if there is ocb flag to signal "no collision"
					Get(enumGET.STATIC, FIND.VetStatics[i].RoomIndex, FIND.VetStatics[i].ObjIndex);

					if ((GET.pStatic->OCB & 4)==0) {
						// no, it has collision. This is not a good sector
						TestGoodSector=false;
						break;
					}
				}

			}
		}

		// if we have not yet found a good sector, we should test another sector
		if (TestGoodSector==false) {
			IncX = VetIncAttempts[IndexAttempt].x;
			IncZ = VetIncAttempts[IndexAttempt].y;


			if (IncX == 0 && IncZ == 0) {
				// we have verifiied all sectors around main sector.
				// if we had checked only for FLAT sector, now we reapeat the check for GENTLE slope sectors
				if (FloorTypeTemp  == enumSLOPE.FLAT) {
					LogOnDebug("Failed Target landing for flat sectors. Look for landing in gentle sectors");
					// ok,  now we retry with GENTLE slope sector

					FloorTypeTemp = enumSLOPE.GENTLE_SLOPE;
					IndexAttempt=-1; // then it will be increased by 1 to restart from 0
					IncX=0; // we'll start own from main sector, that below the drone
					IncZ=0;
				}else {
					// we had already tried also with GENTLE step: total faiulure
					// in this case we have only to choose a horizontal direction, keeping current heigth
					// until to reach a better zone and retry (at next cycle, not now, otherwise we could stop the game
					// restore original coordiate of drone

					CopyPosToItem(OldPos, pDrone);
					LogOnDebug("Failed target landing also for gentle sectors. Move drone to random direction and repeat the looking for.");
					// set phase looking for landing target
					FindRandomDirectionAsTarget(pDrone);
					return false;
				}
			}
			// perform anothe attempt with another sector on border
			Target.CordX = OldPos.CordX + IncX * 1024;
			Target.CordZ = OldPos.CordZ + IncZ * 1024;

			// restore old data
			Target.CordY = OldPos.CordY;
			Target.Room = OldPos.Room;

			IndexAttempt++;
		}


	}
	// found a target

	// restore old drone positon
	CopyPosToItem(OldPos, pDrone);
	LogOnDebug("Found Target for landing");
	// if position (x,z) of drone is different the (x,z) of target, start the DP_CHASE_TARGET phase
	if (pDrone->CordX != Target.CordX || pDrone->CordZ != Target.CordZ) {
		BaseDrone.DronePhase |= DP_CHASE_TARGET;
		BaseDrone.Target = Target;
	}

	return true;
		
}
// in this function we'll move the drone to reach the given target
// if there is a DP_REACH_Y_TARGET phase, first will be moved the drone to reach Target_Y_Only y coordinate
//		once the Target_Y_Only has been reached, it will start the movement to reach the further DP_CHASE_TARGET  (x,z) position
// when also DP_CHASE_TARGET x,z positon has bene reached, the function will return "true"

// we have no need to check for collisions because this check had already been made when has been set the target
bool MoveToTarget(StrItemTr4 *pDrone)
{
	int IncX, IncY, IncZ;
	WORD HDirection;
	int DifY;
	int DifX, DifZ;
	short IncRotate;
	IncX=0;
	IncY=0;
	IncZ=0;
	IncRotate=0;

	// if there is a DP_REACH_Y_TARGET phase, we should, earlier, move up the drone and only aftet reaching right height, move the 
	// drone in horizontal
	if (BaseDrone.DronePhase & DP_REACH_Y_TARGET) {

		// now, we discover the vertical movement
		DifY = BaseDrone.Target_Y_Only  - pDrone->CordY;
		// if dify = 0 we have already reached the right height, so we can cancel the DP_REACH_Y_TARGET phase
		if (DifY ==0 ) {
			BaseDrone.DronePhase &= ~DP_REACH_Y_TARGET;
		}else {
			// not yet reached: move drone in vertical.
			// we have to set a reasonable Y increment

			if (DifY != 0) {
				if (DifY > 0) {
					IncY = PROF_VSPEED;
					if (DifY < IncY) IncY = DifY;
				}else {
					IncY = -PROF_VSPEED;
					if (Abs(DifY) < Abs(IncY)) IncY = DifY;
				}
			}
		}
	}
	// we'll move in horizontale the drone, only when raising phase is complete
	if ((BaseDrone.DronePhase & DP_REACH_Y_TARGET)==0) {
		// completed rasing, now let's if there is to move horizontally the drone
		if (BaseDrone.DronePhase & DP_CHASE_TARGET) {
			// now we have to discover the specifi direct (facing) to reach target
			// horizonntal direction
			// in this case, indeed, we'll do the opposite of earlier (with DP_REACH_Y_TARGET phase)
			// now we should move the drone ONLY in horizontal
			DifX = BaseDrone.Target.CordX - pDrone->CordX;
			DifZ = BaseDrone.Target.CordZ - pDrone->CordZ;
			IncX =0;
			IncZ =0;
			IncRotate=0;
			if (DifX != 0 || DifZ !=0) {
				// if both difference (x and z) are less that hspeed, use this as increments to reach perfecty the target point

				if (abs(DifX) <= PROF_HSPEED && abs(DifZ) <= PROF_HSPEED) {
					// drone is almost at its target, force right Incrments to fit perfectly with final destination
					IncX = DifX;
					IncZ = DifZ;
				}else {
					// compute increments to move to target
					// but try also to rotate drone to reach the facing to aim to target (x,z)
					HDirection = GetDirection(pDrone->CordX, pDrone->CordZ, BaseDrone.Target.CordX, BaseDrone.Target.CordZ);
					// we have to force the facing of drone to be the same of required direction

					IncRotate = HDirection - pDrone->OrientationH;

					if (IncRotate != 0) {
						//  we have to rotate the drone, to change its facing
						if (IncRotate < 0) { 
							// we should use -PROF_ROTATE_SPEED , but, if current differnce is less (in absolute value)
							// we'll use the current IncRotate
							if (abs(IncRotate) > PROF_ROTATE_SPEED) IncRotate = -PROF_ROTATE_SPEED;
						}else {
							if (abs(IncRotate) > PROF_ROTATE_SPEED) IncRotate = PROF_ROTATE_SPEED;
						}

					}
					// note: until rotation has not been completd, we'll NOT move the drone
					// anyway, to avoid to suspend movement only for very little adjustment, we'll move anywya the drone
					// when the IncRotate is littler than standard rotate speed PROF_ROTATE_SPEED
					if (abs(IncRotate)< PROF_ROTATE_SPEED) {
						GetIncrements(HDirection, &IncX, &IncZ, PROF_HSPEED);
					}
				}
				
			}

			if (IncX == 0 && IncZ==0 && IncRotate==0) {
				// we completed also the DP_CHASE_TARGET phase
				BaseDrone.DronePhase &= ~DP_CHASE_TARGET;
			}
			
		}
		
	}
	
	// now we can modify drone coordinates

	pDrone->CordX += IncX;
	pDrone->CordY += IncY;
	pDrone->CordZ += IncZ;
	pDrone->OrientationH += IncRotate;

	if ((BaseDrone.DronePhase & (DP_CHASE_TARGET | DP_REACH_Y_TARGET))==0) {
		// completed all targets
		return true;
	}
	return false;

}

// I need of this function to create a mine version of LOS() (Line Of Shooting) tomb raider function.
// since the LOS() function stopped at first obstacle, and it stopped also for moveables, I need to make from scratch
// an alike function that was able to go on to analyse all walls
// So I had to do this function, to compute the 3d increments (X,Y,Z) to reach pTarget from pSource (both are two StrItemTr4 structures), 
// given the (about) max increment to use
// really this fucntion could return a max increment a bit bigger or littler to reach correctly pTarget in (returned) given
// amount of steps (amout of increments to move from source to target)
// INPUT: pSource (item structure of source moveable)
//		  pTarget (item structure of target moveable)
//        MaxInc (max speed, on some axis, for each step)
// OUTPUT: return amount of steps to perform 
//         *pIncX = increment on X axis to add to pSource to reach (after NSteps) X Target
//         *pIncY =   "    "     Y    "   "     "   "   "     "      "     "      Y Target
//         *pIncZ =   "    "     Z    "   "     "   "   "     "      "     "      Z Target
// note: bigger will be the MaxInc value and bigger also the error to reach target (stopping earlier or later)
//		since we are working on integer values 
int FindIncrementsForTarget(StrItemTr4 *pSource, StrItemTr4 *pTarget, int MaxInc, int *pIncX, int *pIncY, int *pIncZ)
{
	int XDistance;
	int ZDistance;
	int YDistance;
	int NSteps;


	XDistance = pTarget->CordX - pSource->CordX;
	YDistance = pTarget->CordY - pSource->CordY;
	ZDistance = pTarget->CordZ - pSource->CordZ;

	// discover amount of steps on biggest distance
	if (abs(XDistance) >= abs(YDistance)  && abs(XDistance) >= abs(ZDistance)) {
		NSteps = abs(XDistance) / MaxInc;
		
	}
	if (abs(YDistance) >= abs(XDistance) && abs(YDistance) >= abs(ZDistance)) {
		NSteps = abs(YDistance) / MaxInc;
	}

	if (abs(ZDistance) >= abs(XDistance) && abs(ZDistance) >= abs(YDistance)) {
		NSteps = abs(ZDistance) / MaxInc;
	}

	// if NSteps = 0 it means that soruce and target have a distance less than MaxInc
	if (NSteps == 0) return 0;
	// now we compute the inc on three axis in NSteps
	*pIncX = XDistance / NSteps;
	*pIncY = YDistance / NSteps;
	*pIncZ = ZDistance / NSteps;

	return NSteps;

}
// return the amount of walls (with a check every 1024 units)
// between pSource and pTarget
// note: this function will return the amount of wallw in floating point format, where a value 
//		 like 1.5 it means one wall (4 click depth) and another with half size (2 clicks)
float ComputeAmountOfWalls(StrItemTr4 *pSource, StrItemTr4 *pTarget)
{

	int IncX, IncZ;
	int IncY;
	int NSteps;
	int i;
	GAME_VECTOR Pos;
	float NWalls;

	// we use as max incx 200 (instead 256 or other multiple of square) because we have to have the chance to catch 4 times a wall side 
	// for each 4 click depth wall and since the FindIncrementsForTarget() function doesn't use trigonometric operations it could work
	// in excess, creating a moving (in diagonal) bigger than 256 units.
	NSteps = FindIncrementsForTarget(pSource, pTarget, 200, &IncX, &IncY, &IncZ);

	// now we add IncX, IncY and IncZ to pSoruce until it will reach pTarget
	// really, we'll not use coordinate of pSource (to don't modify them) but we'll use a Pos with starting coords of pSource
	CopyItemToPos(pSource, Pos);

	NWalls=0;

	for (i=0;i<NSteps;i++) {
		if (CheckFloor(Pos.CordX, Pos.CordY, Pos.CordZ, Pos.Room)==false) {
			// invalid floor: we are inside a wall
			NWalls++;
		}else {
			
			Pos.Room = FLOOR.RoomIndex;
			// valid floor but let's see if we are colliding with a heigher floor or a lower ceiling
			if (FLOOR.FloorHeight < Pos.CordY) {
				NWalls++;
			}else {
				if (FLOOR.CeilingHeight > Pos.CordY) {
					NWalls++;
				}
			}
		}

		// we increas pos
		Pos.CordX += IncX;
		Pos.CordY += IncY;
		Pos.CordZ += IncZ;

	}
	// we completed the amount of steps
	// now, since we could have until 4 NWalls for one single full wall (with a depth of 4 clicks) we'll divide this number by 4

	NWalls /= 4.0f;

	return NWalls;

}
// it has been received a command to move the drone in Direction
// if this direction is the same of SpeedNow, increase the speed
// if it's different, move SpeedNow to SpeedOld and clear speednow (at start 0)
void UpdateSpeed(WORD Direction)
{
	if (Direction == BaseDrone.SpeedNow.Direction) {
		BaseDrone.SpeedNow.Speed++;
		if (BaseDrone.SpeedNow.Speed > PROF_HSPEED) BaseDrone.SpeedNow.Speed=PROF_HSPEED;
		return;
	}

	// direction is different
	// move current speed to old speed and clear speed now
	if (BaseDrone.SpeedNow.Speed > BaseDrone.SpeedOld.Speed) {
		BaseDrone.SpeedOld = BaseDrone.SpeedNow;
	}
	BaseDrone.SpeedNow.Direction  = Direction;
	BaseDrone.SpeedNow.Speed = 1;

}
// function to discover what is, between two orientations (facing or direction) the less distance in degrees between them
// to reach EndRot from StartRot
// this operation is complicated by fact that facing in 16 bit format, could be seen as signed or unsigned
// and they are rotating sequence, where 0xffff is very close to 0x0000 (-1 and 0) but, seeing them as unsigned it will
// become a very big distance 0xffff = 65535 with 0
short GetLittlestRotation(short StartRot, short EndRot)
{
	short Difference;

	if (StartRot==EndRot) return 0;
	// discover if two rotations are in the worst side of circle
	if ((StartRot >= 16384 || StartRot <= -16384) &&
		(EndRot >= 16384 || EndRot <= -16384)) {
		// yeah, the worst
		// add to both rotations 180 degrees to move them in upward side of circle

		StartRot += 0x7fff;
		EndRot += 0x7fff;
		
	}

	Difference = EndRot-StartRot;
	return Difference;


}
// verify in what direction (between 8 directions there is feee space
WORD LookForFreeDirection(StrItemTr4 *pDrone)
{
	int IncX,IncZ;
	GAME_VECTOR OldPos;
	WORD Direction;
	int i;

	CopyItemToPos(pDrone, OldPos);

	i=0;
	while (VetIncAttempts[i].x != 0 || VetIncAttempts[i].y != 0) {
		i++;

		CopyPosToItem(OldPos, pDrone);
		IncX = VetIncAttempts[i].x;
		IncZ = VetIncAttempts[i].y;

		pDrone->CordX += IncX * 1024;
		pDrone->CordZ += IncZ * 1024;

		if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room) == true) {
			// it may be... but let's check if floor height is good to host drone

			if (FLOOR.FloorHeight >= pDrone->CordY && 
				FLOOR.CeilingHeight <= (pDrone->CordY - PROF_FULL_HSIZE_DRONE)) {

					// ok this is good. now check the direction
					Direction=GetDirection(OldPos.CordX, OldPos.CordZ, pDrone->CordX, pDrone->CordZ);

					// restore original drone position and quit
					CopyPosToItem(OldPos, pDrone);
					return Direction;
			}

		}

	}
	// not found any direction (epic fail!) 
	LogOnDebug("WARNING: LookForFreeDirection() failed to find any valid free direction");
	return 0;
}
// verify if the numeric formatter in pText is integer ("%d") (returns "true") or float (or other) it will return "false"
bool IsIntegerNumber(char *pText)
{
	char MyChar;
	int i;
	bool TestInteger;
	bool TestFormatter;
	bool TestOk;

	i=0;
	TestInteger=false;
	TestFormatter=false;

	while (pText[i] != 0) {
		MyChar = pText[i];

		if (TestFormatter==true) {
			if (MyChar == 'd') {
				TestInteger=true;
				break;
			}

			// let's see if we find a char that is not a valid argument for formatter
			TestOk=false;
			if (MyChar >= '0' && MyChar <= '9') TestOk=true;

			if (MyChar == '.' || MyChar == '+') TestOk=true;

			if (MyChar == 'f') {
				// we discover that was a floating point format, so it's not integer  
				return false;
			}

			if (TestOk==false) TestFormatter=false;

		}

		if (MyChar == '%') {
			// it could be the start of formatter, just that, previous character was not another '%' or a '\'
			TestFormatter=true;
			if (i > 0) {
				if (pText[i-1] == '%' || pText[i-1] == '\\') TestFormatter=false;
			}
		}
		i++;
	}

	return TestInteger;

}
// perform flipeffect to remove the string that was used to show warning mesages
void RemoveWarningsTelemetry(void)
{
	int Index;
	if (BaseDrone.TestWaWarnTelemetryON == false) return;

	Index = BaseDrone.IndexStringWarnings;
	if (Index != -1) {
		PerformFlipeffect(NULL, 204, Index, 0);
		BaseDrone.TestWaWarnTelemetryON =false;
	}
}
// remove all string used for telemerty from the screen, but with exception for warning string
void RemoveTelemetry(void)
{
	int Index;
	short *pVectIndices;
	int i;

	if (BaseDrone.TestTelemetryON == false) return;
	// we'll use flipeffect 204 to remove all telemetric string from screen
	// and we use a little trick to access to single string index, like they we were all in an array (a vector)
	pVectIndices = &BaseDrone.IndexStringDistance;

	// remove all strings except warning string
	for (i=0;i<5;i++) {
		Index= pVectIndices[i];
		if (Index != -1) PerformFlipeffect(NULL, 204, Index, 0);
	}
	BaseDrone.TestTelemetryON=false;
}

void SetSizeChar(void)
{
	int SizeType;

	SizeType= 0; // standard size
	if (BaseDrone.ViewFlags & VIEW_CHAR_HALF) SizeType=2; // half height
	if (BaseDrone.ViewFlags & VIEW_CHAR_MICRO) SizeType=3; // half width and height
	// using "standard" flipeffect 81 to set the character size
	PerformFlipeffect(NULL, 81, SizeType, 0);

}
// call the flipeffect to show the string that will be used to display warning messages
void EnableWarningsTelemetry(void)
{
	int Index;
	bool TestOk;

	if (BaseDrone.TestWaWarnTelemetryON == true) return;
	if (BaseDrone.ViewCamNow == VIEW_CAM_CHASE_DRONE &&  (BaseDrone.ViewFlags & VIEW_NO_WARNINGS_ON_CHASE_CAM)!=0) return;
	if ((BaseDrone.ViewCamNow == VIEW_CAM_LARA || BaseDrone.ViewCamNow== VIEW_NO_CAM) && 
												(BaseDrone.ViewFlags & VIEW_NO_WARNINGS_ON_LARA_CAM)!=0) return;
	
	// don't show warning messages if we are in cutscene and view cam is differnet that chase drone or drone cam
	TestOk=true;
	// if there is drone cutscene remove warning on screen, excepting for cam drone or chase cam (when tleemetry for it is enabled)
	if (BaseDrone.TestCutScene == true) {
		TestOk=false;
		if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE) TestOk=true;
		// if view is chase drone, it's ok, at least tleemetry for chase drone was not disabled
		if (BaseDrone.ViewCamNow == VIEW_CAM_CHASE_DRONE  && (BaseDrone.ViewFlags & VIEW_NO_TELE_ON_CHASE_CAM) == 0) TestOk=true;
	}

	if (TestOk==false) return;

	SetSizeChar();
	// -------------- WARNINGS ------------------------------
	Index = BaseDrone.IndexStringWarnings;
	if (Index != -1) {
		// verify that the string had a valid message with positional formatter
		ShowMessage(true, MSG_READY, 2, NULL);
		// ok, now it's possible put "on air" this string
		// we set "0" as seconds, and it means "forever"
		PerformFlipeffect(NULL, 425, Index, 0);
		BaseDrone.TestWaWarnTelemetryON =true;			
	}
}
// enable all texts for telemetry
// pratically it's only in this moment that all string will be displayed, only once forever
// note: it will work for all texts for telemtry but string for warnings has its own fucntion to enable it: EnableWarningTelemetry()
void EnableTelemetry(void)
{
	int Index;

	if (BaseDrone.TestTelemetryON == true) return;

	BaseDrone.TestTelemetryON=true;

	// print all strings for tleeetry on screen with infinite durate
	// then, these strings will be updated with UpdateTelemetricValue() function
	// set the size for all texts
	// set character size


	SetSizeChar();
	// -----------------  BATTERY --------------------------------------
	Index = BaseDrone.IndexStringBattery;
	if (Index != -1  && (BaseDrone.Flags & DRF_USE_BATTERIES)!=0) {
		// verify that the string was really available
		if (Get(enumGET.STRINGNG, Index,0)==true) {
			// ok, now it's possible put "on air" this string
			// we set "0" as seconds, and it means "forever"
			PerformFlipeffect(NULL, 425, Index, 0);
			
		}
	}

	// -------------- COMPASS ------------------------------
	Index = BaseDrone.IndexStringCompass;
	if (Index != -1) {
		// verify that the string was really available
		if (Get(enumGET.STRINGNG, Index,0)==true) {
			// ok, now it's possible put "on air" this string
			// we set "0" as seconds, and it means "forever"
			PerformFlipeffect(NULL, 425, Index, 0);
			
		}
	}

	// -------------- DISTANCE ------------------------------
	Index = BaseDrone.IndexStringDistance;
	if (Index != -1) {
		// verify that the string was really available
		if (Get(enumGET.STRINGNG, Index,0)==true) {
			// ok, now it's possible put "on air" this string
			// we set "0" as seconds, and it means "forever"
			PerformFlipeffect(NULL, 425, Index, 0);
			
		}
	}

	// -------------- HEIGHT ------------------------------
	Index = BaseDrone.IndexStringHeight;
	if (Index != -1) {
		// verify that the string was really available
		if (Get(enumGET.STRINGNG, Index,0)==true) {
			// ok, now it's possible put "on air" this string
			// we set "0" as seconds, and it means "forever"
			PerformFlipeffect(NULL, 425, Index, 0);
			
		}
	}

	// -------------- SIGNAL ------------------------------
	Index = BaseDrone.IndexStringSignal;
	if (Index != -1) {
		// verify that the string was really available
		if (Get(enumGET.STRINGNG, Index,0)==true) {
			// ok, now it's possible put "on air" this string
			// we set "0" as seconds, and it means "forever"
			PerformFlipeffect(NULL, 425, Index, 0);
			
		}
	}



}
// verify if we are in a view cam where we can (and we have to) display telemetric values on screen
bool IsCamForTelemetry(void)
{
	if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE) return true;

		if ((BaseDrone.ViewCamNow == VIEW_CAM_CHASE_DRONE) != 0 && (BaseDrone.ViewFlags & VIEW_NO_TELE_ON_CHASE_CAM)==0) return true;
	return false;
}

// This function is alike than above IsCamForTelemetry() function, but in this case we verify if it's reasonable to use
// a special cam view like VIEW_CAM_DRONE or VIEW_CAM_CHASE_DRONE
bool IsToKeepSpecialViewCam(StrItemTr4 *pDrone)
{
	// we keep a speical cam only if there was already a special cam
	if (BaseDrone.ViewCamNow != VIEW_CAM_DRONE && BaseDrone.ViewCamNow != VIEW_CAM_CHASE_DRONE) return false;

	// if lara is NOT holding the controller, surely she cann't see special cam views
	if (GET.pLara->StateIdCurrent != 96 && BaseDrone.TestCutScene==false) return false;

	// if drone closed its arm quit cam view
	if (pDrone->StateIdCurrent != 7) return true; 

	// if there is a message different than "ready" go on with cam
	if (BaseDrone.WarningLastMSG != MSG_READY) return true;

	// if there are othr messages in the waiting list, go on with current cam view
	if (BaseDrone.TotMessages > 0) return true;
	// ok, now the drone is on the ground and there is no other special warning to see, we can quit special view cam
	return false;
}

// this further function is to verify if we have to start (or go on) with some cam view (lara, chase drone or drone)
bool IsPhaseForCamView(StrItemTr4 *pDrone)
{
	// it's necessary that lara is holding the controller 

	if (GET.pLara->StateIdCurrent != 96 && BaseDrone.TestCutScene == false) return false;
	// and that the drone was flying or at least was ready
	if ((BaseDrone.DronePhase & (DP_FLYING | DP_READY))==0) {
		// if the drone was stopping propelleres, probably we in landign phase an between just a moment, it will come back "ready"
		// in this case don't quit view cma
		if (pDrone->StateIdCurrent !=3 ) return false;

	}

	return true;
}
// this fucntion will remove all message of TypeMSG, from current display (currently "on air") or from the waiting list
// it's useful when some situation (like "low signal") changed but there could be still an old sent "low signal" message
// in the waiting list
void RemoveMSG(int TypeMSG)
{
	int i;
	int j;

	// check if current "on air" message is that to remove
	if (BaseDrone.WarningLastMSG == TypeMSG) {
		// yes: clear the frame durate
		BaseDrone.WarningFrameDurate =0;
	}

	// remove also from waiting list the TypeMSG message
	j=0;
	for (i=0;i<BaseDrone.TotMessages;i++) {
		if (BaseDrone.VetMessages[i].TypeMSG != TypeMSG) {
			// re-copy all messages, skipping that one of TypeMSG type
			BaseDrone.VetMessages[j++] = BaseDrone.VetMessages[i];
		}
	}
	// set new amount of messages
	BaseDrone.TotMessages = j;

}
// return only the effective text of MSG_ type string, skipping the furhter positional formatters at begin
char *GetCleanText(int MSG_Type)
{
	int i;
	char *pText;
	int StringIndex;
	int j;
	int TotColons;

	StringIndex = BaseDrone.FirstStringIndex + MSG_Type;
	if (Get(enumGET.STRINGNG, StringIndex, 0)== false) return "Not Found";
	
	pText = GET.pStringNG;

	
	i=0;
	// skiiping frther spaces or null characters
	while (pText[i] == ' ' || pText[i] == '\t') i++;

	if (pText[i]=='#') {
		// there is a formatter: skipping it
		j=i+1;
		// but let's verify it was really a formatter
		// looking for two ':' colon chars
		TotColons=0;

		while (TotColons < 2 && pText[j] != 0) {
			if (pText[j++]== ':') TotColons++;
		}

		if (TotColons == 2) i=j;
	}
	return &pText[i];
	
}
// receive in input a DP_  phase and it will return the text to describe that phase (that it could be used as argument for ShowMessage() function
char * GetTextFailedPhase(int FailedPhase)
{
	char *pText;

	switch (FailedPhase) {
	case DP_LANDING:
		pText = GetCleanText(MSG_LANDING);
		break;
	case DP_EMERGENCY_LANDING:
		pText = GetCleanText(MSG_EMERGENCY_LANDING);
		break;
	case DP_RETURN_TO_HOME:
		pText = GetCleanText(MSG_RETURN_TO_HOME);
		break;
	case DP_RECOVERING_SAFE_POSITION:
		pText = GetCleanText(MSG_SAFE_RECOVERY);
		break;
	default:
		// generic failure to reach target
		pText = "To reach Target";
		break;
	}
	return pText;
}
// It will show the MSG message for FrameDurate frames 
// if TestShowNow is true the message will be immediately displayed
//    while if TestShowNow == false, the message will be saved in the "waiting list" to be showed when it will be its turn
//    NOTE: if TestShowNow == false (place in waiting list) but there is no other message in waiting list and NO message
//           currently displayed, then it will show immediately the message
// if pMexExtaArgument is diffferent than NULL, it will insrted in current TypeMsg messages with a sprintf("%s") operation, 
//		in this situattion the message will be showed immediately
// note: the messages will be always showed, also when the view cam is lara o chase drone (with disabling telemetry flag)
void ShowMessage(bool TestShowNow, int TypeMSG, short FrameDurate, char *pMexExtraArgument)
{
	char *pText;
	char *pMexNow;
	int StringIndex;
	int Index;
	int i;
	int n;
	DWORD j;

	StringIndex = BaseDrone.FirstStringIndex;
	// if user didn't set a first string index, it means he doesn't want any text to display
	if (StringIndex==-1) return;
	// locate specific message to show
	StringIndex += TypeMSG;

	pMexNow = LocateNGString(StringIndex);
	if (pMexNow == NULL) return;


	// locate (and verify) the always on air string for warning
	Index = BaseDrone.IndexStringWarnings;
	if (Get(enumGET.STRINGNG, Index, 0) ==false) return;
	// this will be the buffer where type message to be displayed on scree
	pText =GET.pStringNG;

	// in the case there was no other message in waiting list and no displayed message, change
	// the TestShowNow setting
	if (TestShowNow == false && BaseDrone.WarningFrameDurate == 0 && BaseDrone.TotMessages==0) TestShowNow=true;

	if (pMexExtraArgument != NULL) TestShowNow=true;

	if (TestShowNow==false) {
		// place message in the waiting list and quit
		// if current msg is already  in waiting list: ignore it
		for (i=0;i<BaseDrone.TotMessages;i++) {
			if (BaseDrone.VetMessages[i].TypeMSG == TypeMSG) return;

		}
		// ok, it's new.
		// save this message to the waiting list

		// add to the list
		i=BaseDrone.TotMessages;

		if (i < PROF_MAX_MESSAGE_LIST) {
			// add to new list slot
			BaseDrone.VetMessages[i].TypeMSG  = TypeMSG;
			BaseDrone.VetMessages[i].Frames  = FrameDurate;
			BaseDrone.TotMessages++;
		}else {
			// all slots were full: remove current message and scroll the list by one position
			BaseDrone.WarningFrameDurate=0;

			for (i=0;i<PROF_MAX_MESSAGE_LIST-1;i++) {
				BaseDrone.VetMessages[i] = BaseDrone.VetMessages[i+1];
			}

			// add at end
			i = PROF_MAX_MESSAGE_LIST-1;

			BaseDrone.VetMessages[i].Frames  = FrameDurate;
			BaseDrone.VetMessages[i].TypeMSG  = TypeMSG;					
		}
		return;
		
	}


	// dislay the message
	if (pMexExtraArgument != NULL) {
		// build a new text with supplied argument
		sprintf(BaseDrone.BufLastMsg, pMexNow, pMexExtraArgument);
		strcpy(pText, BaseDrone.BufLastMsg);
	}else {
	
		strcpy(pText, pMexNow);
		// if there is drone cutscene, remove "ready"  (because "ready" is a message for controller 
		//						to wait commands and it's not suitable for cutscene)

		if (BaseDrone.TestCutScene == true && TypeMSG== MSG_READY) {
			// let only positional formatter
			// #C499:130:Ready
			if (pText[0] == '#') {
				// skip upon two colons chars ':'
				n=0;
				for (j=0;j<strlen(pText);j++) {
					if (n==2) break;
					if (pText[j] == ':') n++;
					
				}
				if (n==2) pText[j]=0;
			}
		}
	}
	BaseDrone.WarningFrameDurate = FrameDurate;
	BaseDrone.WarningLastMSG  = TypeMSG;

}
// since compass is only one data to require two parameters (degrees and cardinal point) 
// I had to create a speicific function to show its telemetry (instead by using usual UpdateTelemetricValue() function)

void UpdateCompass(float Value, char *pCardinalPoint)
{
	int StringIndex;
	char *pText;
	int IntegerValue;
	char FinalText[256];
	int Index;
	int MsgIndex;


	if (IsCamForTelemetry()==false) return;
	MsgIndex = MSG_COMPASS;

	StringIndex = BaseDrone.FirstStringIndex;
	// if user didn't set a first string index, it means he doesn't want any text to display
	if (StringIndex==-1) return;
	// telemetric data text have always a value to show (distance, height, battery level ect)

	// verify if there is to change from long to short version

	if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE) {
		// there is cam drone active: use short version
		MsgIndex++;
	}

	StringIndex += MsgIndex;
	Get(enumGET.STRINGNG, StringIndex,0);

	pText = GET.pStringNG;

	if (strcmpi(pText, "STRING NOT FOUND")==0) {
		// string was missing
		return;
	}	

	if (IsIntegerNumber(pText)==true) {
		IntegerValue = (int) Value;
		sprintf(FinalText, pText, pCardinalPoint, IntegerValue);
	}else {
		// it was a float (with point) value
		sprintf(FinalText, pText, pCardinalPoint, Value);
	}
	Index = BaseDrone.IndexStringCompass;
	// now we copy finaltext  in our extra ng string
	if (Get(enumGET.STRINGNG, Index, 0)==false) {

		// weird, we didn't get our extra ng string
		return;
	}
	strcpy(GET.pStringNG, FinalText);
}
// update the value for  drone string with MsgIndex (MSG_...) reference, passing (further) Value
// note: don't pass ever the "_SHORT_" version of text, pass always the normal version and then it will be UpdateTelemetricValue, to change it
//		to "short" version, when VIEW_CAM_DRONE is active
// remark: this function doens't call a print string to show the text, all telemtric texts should have been already dislayed with EnableTelemetry()
void UpdateTelemetricValue(int MsgIndex, float Value)
{
	int StringIndex;
	char *pText;
	int IntegerValue;
	char FinalText[256];
	int Index;

	
	if (IsCamForTelemetry()==false) return;

	StringIndex = BaseDrone.FirstStringIndex;
	// if user didn't set a first string index, it means he doesn't want any text to display
	if (StringIndex==-1) return;
	// telemetric data text have always a value to show (distance, height, battery level ect)

	// verify if there is to change from long to short version
	if (MsgIndex >= MSG_DISTANCE && MsgIndex <= MSG_SHORT_COMPASS) {
		if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE) {
			// there is cam drone active: use short version
			MsgIndex++;
		}
	}

	StringIndex += MsgIndex;

	pText =LocateNGString(StringIndex);

	if (pText==NULL) return;

	// about the kind of numeric formatter ("%d" or "%f")
	// there is a little complication: if the formatter is "%d", we'll have to use a value in integer (int) format
	// while if it was in floating point format ("%f") we'll use originale Value in floating point format

	// for this target we'll use the IsIntegerNumber() function to discover the formattter type
	if (IsIntegerNumber(pText)==true) {
		IntegerValue = (int) Value;
		sprintf(FinalText, pText, IntegerValue);
	}else {
		// it was a float (with point) value
		sprintf(FinalText, pText, Value);
	}

	// now we have to copy the final text in a new extra ng string (that we had allocated in cbInitLevel() function
	switch (MsgIndex) {
	case MSG_DISTANCE:
	case MSG_SHORT_DISTANCE:
		Index = BaseDrone.IndexStringDistance;
		break;
	case MSG_HEIGHT:
	case MSG_SHORT_HEIGHT:
		Index = BaseDrone.IndexStringHeight;
		break;
	case MSG_BATTERY:
	case MSG_SHORT_BATTERY:
		Index = BaseDrone.IndexStringBattery;
		break;
	case MSG_SIGNAL:
	case MSG_SHORT_SIGNAL:
		Index = BaseDrone.IndexStringSignal;
		break;
	case MSG_COMPASS:
	case MSG_SHORT_COMPASS:
		Index = BaseDrone.IndexStringCompass;
		break;
	}
	// now we copy finaltext (with real number) in our extra ng string
	if (Get(enumGET.STRINGNG, Index, 0)==false) {

		// weird, anywya we didn't get our extra ng string
		return;
	}
	strcpy(GET.pStringNG, FinalText);
		
}
// return a value in meters or yards (in according with current VIEW_ settings) receiving a distance in game unitgs (1024 = one sector)
float ConvertUnits(float GameUnits)
{
	float Value;

	// get value in meters
	Value = GameUnits / 512.0f;
	// if it has been set yard, convert meters in yards
	if (BaseDrone.ViewFlags  & VIEW_USE_YARDS) {
		Value *= 1.09361f;
	}
	return Value;
}
// receive a value in meters or yards (in according with DRF_USE_YARDS flag
// and return the value in tomb raider units
int ConvertLinearUnitToGameUnits(int MeterYards)
{
	float Temp;

	// first convert the value from yards to meters (if set)
	Temp = (float) MeterYards;
	if (BaseDrone.ViewFlags & VIEW_USE_YARDS) {
		Temp /= 1.09361f;
	}
	// now convert meters in game units
	Temp *=  512.0f;
	
	return (int) Temp;
}


// update all temetric data
// note: this function DOESN'T print on screen, the strings should have been already showed with EnableTelemetry() function
//      while this function updates only texts in internal string buffers linked with already "on air" strings
//      Anyway... if the strings have not yet been displayed (calling EnableTelemetry() function), it will be UpdateTelemetry() 
//              to call EnableTelemetry() but only if there are VIEW_CAM_CHASE_DRONE or VIEW_CAM_DRONE active
// this function should be called for each fame when the drone is flying (and there is cam view that supports telemetry)
void UpdateTelemetry(StrItemTr4 *pDrone)
{
	float Value;
	float Max;
	float NWalls;
	int SaveY;
	int i;
	char *pLetter;
	short Direction;
	short MinDiff;
	short DiffNow;
	float DistanceNow;
	bool TestShowNow; // show immediately


	// ------------------------------------------------ DISTANCE ------------------------------
	// we compute distance only in horizsonal x,z ignoring Y (that will be the height value)
	Value= (float) GetDistanceXZ(BaseDrone.StartPoint.CordX, BaseDrone.StartPoint.CordZ, 
					pDrone->CordX, pDrone->CordZ);
	// now we convert game units in meters or yards
	Value = ConvertUnits(Value);
	UpdateTelemetricValue(MSG_DISTANCE, Value);


	// ----------------------------------------------- HEIGHT -----------------------------------
	Value = (float) (BaseDrone.StartPoint.CordY - pDrone->CordY);
	Value = ConvertUnits(Value);
	UpdateTelemetricValue(MSG_HEIGHT, Value);

	// --------------------------------------------- BATTERY LEVEL ----------------------------------
	if (BaseDrone.Flags & DRF_USE_BATTERIES) {
		// only if it works with battery we update this
		// the max amount of battery level is given by: Number of minutes for battery * 60 (to get seconds) * 30 (for the frame for each second)
		Max = (float) (BaseDrone.BatteryMinutes * 60 * 30);

		Value = (100.0f * BaseDrone.BatteryLevel) / Max;
		UpdateTelemetricValue(MSG_BATTERY, Value);

		if (Value < PROF_WARN_LEVEL_LOW_BATTERY) {
			ShowMessage(false, MSG_LOW_BATTERY, PROF_FRAME_DURATE_WARNINGS, NULL);
		}
		
		BaseDrone.PercBattery = Value;
	}else {
		BaseDrone.PercBattery = 100;
	}

	// -------------------------------------- COMPASS DEGRESS ------------------------------------------
	// here we'll show degress, respect north (it means: if drone is aiming at north then 0 degrees)
	Value = (float) pDrone->OrientationH;

	// discover the cardinal point where drone's facing is closer
	Direction = (short) Value;

	// try with north

	MinDiff = Direction;
	pLetter="N";

	// try with west
	DiffNow = Direction - 0x4000;
	if (abs(DiffNow) < abs(MinDiff)) {
		MinDiff= DiffNow;
		pLetter="W";
	}

	// try with south
	DiffNow = Direction - 0x7fff;
	if (abs(DiffNow) < abs(MinDiff)) {
		MinDiff = DiffNow;
		pLetter="S";
	}

	// try with east
	DiffNow = Direction + 0x4000;
	if (abs(DiffNow) < abs(MinDiff)) {
		MinDiff = DiffNow;
		pLetter="E";
	}

	Value = (float) MinDiff;
	// convert in 360 degress
	Value /= (float) (65536.0f/360.0f);

	UpdateCompass(Value, pLetter);


	// ---------------------------------------- SIGNAL STRENGHT -----------------------------
	// a bit complicated: first we computed the total distance between Lara (she owns the controller) and the drone
	DistanceNow =  (float) GetDistanceXYZ(GET.pLara->CordX, GET.pLara->CordY+PROF_CONTROLLER_LARA_YGAP, GET.pLara->CordZ,
									pDrone->CordX, pDrone->CordY, pDrone->CordZ);

	// when the drone is less than half sector from controller, set as 256 to have 99 % signal
	if (DistanceNow < 512) DistanceNow =256;

	// now we verify, respect max distance, what is in percentage of current distance
	// we convert in meters/yards the current distance
	Value = ConvertUnits(DistanceNow);

	// change distance for a trigger request?
	if (BaseDrone.UserChangeDistance != 0) {


		Value = Value + BaseDrone.UserChangeDistance;
		// if it wasn't "forever" disable for next cycles
		if (BaseDrone.UserChangeDistMode == 2) BaseDrone.UserChangeDistance=0;
	}
	// now we compute the percentage for signal
	Value = 100.0f - ((Value *100.0f) / (float) BaseDrone.MaxDistance);
	// now we have to count the walls between these two points
	// anyway, if the signal is already less or even than 0 it's not ncessary
	if (Value <= 1.000f) Value=0;


	// if it has been set DRF_WALL_REDUCTION
	if (Value > 1.000f && (BaseDrone.Flags & DRF_WALL_REDUCTION)!=0) {

		// a little correction to lara coordinates: since the Y pos of lara is on her feet but the controller (and its antenna) is very higher
		// we change (temporarirly) the Y coordinate of lara to verify the straight line between the controller's antenna and the drone
		SaveY = GET.pLara->CordY;
		GET.pLara->CordY += PROF_CONTROLLER_LARA_YGAP; // this is the height (respect feet) of controller's antennas

		NWalls = ComputeAmountOfWalls(GET.pLara, pDrone);

		if (BaseDrone.UserChangeWalls != 0) {

			// change the walls in accoridng with value set in a trigger
			NWalls = NWalls + (BaseDrone.UserChangeWalls / 4.0f);

			// if it wasn't "forever" disable the value (for future cycles)
			if (BaseDrone.UserChangeWallMode == 2) BaseDrone.UserChangeWalls =0;
		}

		// now we restore the orignal Y coordinate for Lara
		GET.pLara->CordY = SaveY;

		// now we reduce by 1/3 for each wall, the current signal

		if (NWalls != 0) {

			// recompute formula, considering walls as a bigger distance from controller
			DistanceNow +=  (NWalls * 1024.0f * PROF_MORE_DISTANCE_FOR_ONE_WALL);
			// now we reapeat the formula with this new (simulated) value for current distance
			Value = ConvertUnits(DistanceNow);
			// now we get the percentage for signal
			Value = 100.0f - ((Value *100.0f) / (float) BaseDrone.MaxDistance);


			// if value is less than 1.0 we'll set at 0
			if (Value < 1.0f) Value = 0;

		}
	}
	// with mods from triggers, the strenght could become bigger than 100 or a negative number, so we'll try to void this weirdness
	if (Value > 100.0) Value = 100.0;
	if (Value < 0) Value =0;
	// if there is a cutscene in progress, give always 99.9
	if (BaseDrone.TestCutScene == true) Value = 99.9f;


	BaseDrone.PercSignal = Value;

	UpdateTelemetricValue(MSG_SIGNAL, Value);


	BaseDrone.PercSignal = Value;

	if (Value < PROF_WARN_LEVEL_LOW_SIGNAL) {

		ShowMessage(false, MSG_LOW_SIGNAL, PROF_SHORT_TIME_WARNING_MSG, NULL);

	}else {
		// it's greateer than "lost drone" level, but if it's less than PROF_WARN_LEVEL_LOW_SIGNAL, give warning for low signal, too

		// remove also lost drone at least that the problem was not for no_battery
		if ((BaseDrone.DronePhase & DP_NO_BATTERY)==0) {
			RemoveMSG(MSG_LOST_DRONE);
		}
		if (Value < PROF_WARN_LEVEL_LOW_SIGNAL) {
			ShowMessage(false, MSG_LOW_SIGNAL,PROF_SHORT_TIME_WARNING_MSG, NULL);
		}else {

			RemoveMSG(MSG_LOW_SIGNAL);
		}
	}

	// ------------------------------- WARNING MESSAGES ------------------------------------

	// send messages for main phases

	if (BaseDrone.DronePhase & DP_CRASH_IN_PROGRESS) {
		ShowMessage(true, MSG_FALLING_DOWN, PROF_FRAME_DURATE_WARNINGS, NULL);
	}
	if (BaseDrone.DronePhase & DP_RETURN_TO_HOME) { 
		ShowMessage(false, MSG_RETURN_TO_HOME, PROF_FRAME_DURATE_WARNINGS, NULL);
	}

	if (BaseDrone.DronePhase & DP_LOST_DRONE) {
		ShowMessage(false, MSG_LOST_DRONE, PROF_FRAME_DURATE_WARNINGS, NULL);
	}

	if (BaseDrone.DronePhase & DP_EMERGENCY_LANDING) {
		ShowMessage(false, MSG_EMERGENCY_LANDING, PROF_FRAME_DURATE_WARNINGS, NULL);
	}

	if ((BaseDrone.DronePhase & DP_CHASE_TARGET) != 0 && (BaseDrone.DronePhase & DP_LANDING) != 0) {
		ShowMessage(false, MSG_LOOKING_FOR_LANDING, PROF_SHORT_TIME_WARNING_MSG, NULL);

	}
	
	if ((BaseDrone.DronePhase & DP_CHASE_TARGET) == 0 && (BaseDrone.DronePhase & DP_LANDING) != 0) {
		ShowMessage(false, MSG_LANDING, PROF_SHORT_TIME_WARNING_MSG, NULL);
	}

	if (BaseDrone.DronePhase & DP_RECOVERING_SAFE_POSITION) {
		ShowMessage(false, MSG_SAFE_RECOVERY, PROF_LONG_TIME_WARNING_MSG, NULL );
	}

	if (BaseDrone.DronePhase & DP_TAKE_OFF) {
		ShowMessage(false, MSG_TAKE_OFF, PROF_FRAME_DURATE_WARNINGS, NULL);
	}

	if (BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT) {
		ShowMessage(false, MSG_IMPACT, PROF_SHORT_TIME_WARNING_MSG, NULL);
	}

	// check for user (from trigger) message
	if (BaseDrone.UserMsgIndex != -1) {
		// manage "mode" set in trigger:
		// 0:Place in the list (allows other messages) and for standard time
		// 1:Place in the list (allows other messages) and forever (until a flipeffect 53 to remove it)
		// 2:Immediately for standard time
		// 3:Immediately and forever (until a flipeffect 53 to remove it)
		TestShowNow=false;
		if (BaseDrone.UserMsgMode & 0x002) TestShowNow=true;

		ShowMessage(TestShowNow, BaseDrone.UserMsgIndex, PROF_LONG_TIME_WARNING_MSG, NULL);

		// if mode was NOT forever, then disable this message for next cycles
		if ((BaseDrone.UserMsgMode & 0x001)==0) BaseDrone.UserMsgIndex =-1;

	

	}


	
	// --------------------------------------- MANAGEMNT OF MESSAGES (WARNINGS)  --------------------------------

	if (BaseDrone.WarningFrameDurate > 0) {
		// decrease time for current message but, if currently screen is hidden for noise, suspend the decreazing
		if ((BaseDrone.DronePhase & DP_NOISES_ON_SCREEN)==0) BaseDrone.WarningFrameDurate--;
	}
	if (BaseDrone.WarningFrameDurate == 0) {
		// if there are messages in waiting state, display the first
		if (BaseDrone.TotMessages > 0) {
			// show NOW the message (no "waiting list")
			ShowMessage(true, BaseDrone.VetMessages[0].TypeMSG, BaseDrone.VetMessages[0].Frames, NULL );

			// remove the first
			for (i=0;i < PROF_MAX_MESSAGE_LIST-1;i++) {
				BaseDrone.VetMessages[i] = BaseDrone.VetMessages[i+1];
			}

			BaseDrone.TotMessages--;

		}

	}

	// if there is no displayed message (and neither in waiting list) set default "ready" message
	if (BaseDrone.WarningFrameDurate == 0  && BaseDrone.TotMessages==0 && BaseDrone.TestCutScene == false) {
		ShowMessage(true, MSG_READY,PROF_SHORT_TIME_WARNING_MSG, NULL);
	}

	// if the telemtric strings were not yet enabled, now we'll put them "on air"
	if (BaseDrone.TestTelemetryON==false && IsCamForTelemetry()==true) EnableTelemetry();
	if (BaseDrone.TestWaWarnTelemetryON == false) EnableWarningsTelemetry();
}
// return true if is active one automatic phase 
bool IsAutomaticPhase(void)
{
	if (BaseDrone.DronePhase & (DP_LANDING | DP_RETURN_TO_HOME | DP_PREPARING_TO_PICKUP |
									DP_TAKE_OFF | DP_CHASE_TARGET | DP_REACH_Y_TARGET |
									DP_REBOUND_ON_IMPACT | DP_LOST_DRONE | DP_CRASH_IN_PROGRESS |
									DP_RECOVERING_SAFE_POSITION )) return true;
	return false;

}
// this function read directly the keyboard, skipping further blocked commands in tomb raider input
// VirtualKey are VK_... Windows Virtual Key codes 

bool IsKeyDown(int VirtualKey)
{
	if (GetAsyncKeyState(VirtualKey) < 0) 
		return true;
	else
		return false;
	
}

// show mask image
// this function will show the image used with VIEW_CAM_DRONE
void ShowMaskImage(void)
{
	int ImageId;
	StrScriptImage *pImage;

	if (BaseDrone.TestMaskImageOn == true) return;

	// let's see if there is an image to show
	ImageId = BaseDrone.MaskImageIndex;

	if (ImageId == -1) {
		SendToErrorLog(false, "ERROR: mask image id has not been set");
		// disable the VIEW_CAM_DRONE
		BaseDrone.ViewFlags &= ~VIEW_CAM_DRONE;
		BaseDrone.ViewCamNow= VIEW_NO_CAM;
		return;
	}


	// locate the Image= script command
	if (Find(enumFIND.IMAGE_COMMAND, 0,0,0,ImageId,NULL)== false) {
		// missing image
		SendToErrorLog(false, "ERROR: Missing the Image= script command with id=%d", ImageId);
		return;

	}
	// modify image flags to be compatible with mask image
	pImage = FIND.pImage;

	// disable forbidden flags
	pImage->Flags &= ~(IF_EFFECT_ZOOM | IF_EFFECT_FROM_TOP | IF_EFFECT_FROM_BOTTOM | 
							IF_EFFECT_FROM_LEFT | IF_EFFECT_FROM_RIGHT | IF_EFFECT_CROSS_FADE);

	// enable required flags
	pImage->Flags |= (IF_POP_IMAGE | IF_OVER_FIXED_CAMERA );

	// ok, now we can perform the flipeffect 217
	PerformFlipeffect(NULL, 217, pImage->IdCommand , 0);
	
	BaseDrone.TestMaskImageOn=true;
}

// if there was displayed mask image, this function will remove it
void RemoveMaskImage(void)
{
	if (BaseDrone.TestMaskImageOn == false) return;

	PerformFlipeffect(NULL, 218, 0, 0);
	BaseDrone.TestMaskImageOn =false;
}

// visualizza image per help
void ShowHelpImage(StrScriptImage *pImage)
{

	// we'll use the 217 flipeffect to show the image:
	/*
	; Set Trigger Type - FLIPEFFECT 217
	; Exporting: TRIGGER(220:0) for FLIPEFFECT(217) {Tomb_NextGeneration}
	; <#> : Images. Show image with data in <&>Image script command for (E)Seconds
	; <&> : Image=   220
	; (E) : Forever (use other action/effect to disable it)
	*/
	// but, first to call it, we have to verify the settings in pImage (from Image= script command) to verify that
	// there wern't problematic (wrong) flags
	// and, on the other hand, the some required flags were present

	// disable some forbidden flags:
	pImage->Flags &= ~(IF_EFFECT_ZOOM | IF_EFFECT_FROM_TOP | IF_EFFECT_FROM_BOTTOM | IF_POP_IMAGE |
							IF_EFFECT_FROM_LEFT | IF_EFFECT_FROM_RIGHT | IF_EFFECT_CROSS_FADE);

	// and enable some required flags:
	pImage->Flags |= ( IF_OVER_FIXED_CAMERA | IF_QUIT_ESCAPE);

	
	// ok, now we can perform the flipeffect 217
	PerformFlipeffect(NULL, 217, pImage->IdCommand , 0);
}

// show help
// it will be text or image help, in according with settings in CUST_DRONE command
void ShowHelp(void)
{
	int ImageId;
	int ImageIndex;
	int IndexHelpText; 

	// let's see if there is an image to show
	ImageId = BaseDrone.HelpImageIndex;

	ImageIndex=-1;
	if (ImageId != -1) {
		// locate the Image= script command
		if (Find(enumFIND.IMAGE_COMMAND, 0,0,0,ImageId,NULL)== false) {
			// missing image
			SendToErrorLog(false, "ERROR: Missing the Image= script command with id=%d", ImageId);
		}else {
			// show image 

			// remove all telemetric string
			RemoveTelemetry();
			RemoveWarningsTelemetry();

			ShowHelpImage(FIND.pImage);

			// rimettere telemetria
			EnableTelemetry();
			EnableWarningsTelemetry();
			return;
		}
	}
	// there was no help image
	// let's see if  there is a text to sbow
	IndexHelpText =-1;

	if (BaseDrone.FirstStringIndex != -1) {
		IndexHelpText = BaseDrone.FirstStringIndex + MSG_HELP_TEXT;
	}

	if (IndexHelpText != -1) {
		if (LocateNGString(IndexHelpText)!= NULL) {
			// set size of text
			SetSizeChar();
			// show text 
			PerformFlipeffect(NULL, 424, IndexHelpText, 0);
			BaseDrone.DronePhase |= DP_HELP_IN_PROGRESS;

		}
	}

}

// return true when there is in progress a DP_CHASE_TARGET or DP_REACH_Y_TARGET phase
bool IsSomeTarget(void)
{
	if ((BaseDrone.DronePhase & (DP_CHASE_TARGET | DP_REACH_Y_TARGET))==0) return false;
	return true;
}
// try to set targets (earlier in vertical and then horizontal) to move the drone over the start position (home, where the drone took off)
// if the function is able to find a path, it will return true and will set a vertical and/or horizzontal target
// when it's not possible (obstacles in the return path) it will return false
// note: if pNewTarget is different than NULL, it will be used this position as target, ignoring the StartPosition values
bool FindTargetRTH(StrItemTr4 *pDrone, GAME_VECTOR *pNewTarget)
{
	GAME_VECTOR OldPos;
	GAME_VECTOR PosNow;
	GAME_VECTOR GeoPos;
	int Attempt;
	int Y_End;
	WORD SaveFacing;
	int IncX, IncY, IncZ;
	WORD Direction;
	bool TestOk_H;
	bool TestOk_V;
	int CollType;
	GAME_VECTOR TargetNow;
	bool TestTrueRTH;


	if (pNewTarget != NULL) {
		TargetNow = *pNewTarget;
		TestTrueRTH=false;
	}else {
		TargetNow = BaseDrone.StartPoint;
		TestTrueRTH = true;
	}
	// save current position of drone
	CopyItemToPos(pDrone, OldPos);
	SaveFacing = pDrone->OrientationH;

	CopyItemToPos(pDrone, PosNow);

	// perform one attempt moving up the drone, and then another movign it down
	for (Attempt = 0; Attempt< 3;Attempt++) {

		// ripristina in drone sua coordinata originale
		CopyPosToItem(PosNow, pDrone);
	

		if (CheckFloor(PosNow.CordX, PosNow.CordY, PosNow.CordZ, PosNow.Room)==false) {
			// if neither in start positon of drone there is a valid floor, then rth failed
			return false;
		}
		TestOk_V=true;
		switch (Attempt) {
		case 0:
			// first attempt: trying at same current altitude of drone (no up/down changes)
			IncY = 0;
			// finale y position to check: same of current
			Y_End= PosNow.CordY;

			if (Y_End > TargetNow.CordY) TestOk_V=false;
			
			break;

		case 1:
			// second attempt: movign up the drone
			IncY = -128;
			// set a final (reasonable) heigth to reach in this test
			// taking as reference the Y coord of TargetNow to reach (final target, the home)
			Y_End = TargetNow.CordY - 1024*4;

			// if ending y is over the ceiling, set it a bit lower than ceiling
			if (Y_End < FLOOR.CeilingHeight) Y_End= FLOOR.CeilingHeight + 256;
			// if end y is is below the TargetNow its not moving up then we could never reach it
			if (Y_End  > TargetNow.CordY) TestOk_V=false;
			// if end y is below the current drone position , it's not moving up we could reach it
			if (Y_End > PosNow.CordY) TestOk_V=false;
			// now we set the firt y cord to check 
			pDrone->CordY = TargetNow.CordY;

			if (TestOk_V == true &&  TestTrueRTH==true) {
				pDrone->CordY -= 128;
			}

			break;
		case 2:
			// third attempt: moving down the drone
			IncY = +128;
			// if drone is already below final target, then it's not moving furtherly down that we can reach it
			if (pDrone->CordY > TargetNow.CordY) TestOk_V=false;
			Y_End = PosNow.CordY + 1024 * 4;

			// if this coordinate is lower than TargetNow then correct
			if (Y_End < TargetNow.CordY) {
				// use targetnow as reference
				Y_End = TargetNow.CordY - 1024;


			}
			if (Y_End > FLOOR.FloorHeight) Y_End= FLOOR.FloorHeight - 256;
			// if Y_End is upper than current drone position, then it's not possible perform this attempt
			if (Y_End < PosNow.CordY) TestOk_V=false;

			break;
		}


		while (TestOk_V ==true) {

			pDrone->CordY += IncY;

			// verify if, there is a free line between current position and the positin over StartPoint at same height

			// we'll parse the straight line (always on same Y coordinate) to reach StartPoint for current (simulated) dronee's position
			Direction = GetDirection(pDrone->CordX, pDrone->CordZ, TargetNow.CordX, TargetNow.CordZ);
			// set (temporarily) the drone with right facing to aim in current checked direction (it required by CheckCollisionForDrone())
			pDrone->OrientationH = Direction; 
			GetIncrements(Direction, &IncX, &IncZ, 256);

			TestOk_H=true;


			do {
				pDrone->CordX += IncX;
				pDrone->CordZ += IncZ;

				// update room
				if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room)==true) {
					pDrone->Room = FLOOR.RoomIndex;
				}

				CopyItemToPos(pDrone, GeoPos);

				CollType = CheckCollisionForDrone(pDrone, false, &GeoPos, PROF_GAME_FORWARD);


				if (CollType != COLL_NO_COLLISION) {
					// there is a collision: failed attempt in this direction
					TestOk_H=false;
				}else {
					// free way.
					// now we have to verify if we (about) reached the final position (at startpoint)
					// let's say that, if the difference between two pair of coordinates is less the 200, we are about right
					if (Abs(pDrone->CordX - TargetNow.CordX) < 200 && 
							Abs(pDrone->CordZ - TargetNow.CordZ) < 200) break;
				}



			}while (TestOk_H==true);

			// completed the scanning on this horizontal straight line:
			if (TestOk_H==true) {
				// found the target!
				BaseDrone.Target = TargetNow;
				BaseDrone.Target_Y_Only = pDrone->CordY;

				// enable chase target phases
				if (BaseDrone.Target_Y_Only != BaseDrone.Target.CordY) {
					BaseDrone.DronePhase |= DP_REACH_Y_TARGET;
				}
				BaseDrone.DronePhase |= DP_CHASE_TARGET;

				// restore drone sructure
				CopyPosToItem(OldPos, pDrone);
				// restore original facing
				pDrone->OrientationH = SaveFacing;

				return true;
			}
			
			// let's verify if we reached (about) Y_End
			if (Abs(Y_End - pDrone->CordY) < 200) {
				break;
			}
			// now we restore X and z coordinates
			// and go on to change only Y coordinate
			pDrone->CordX = PosNow.CordX;
			pDrone->CordZ = PosNow.CordZ;
			
			

		};

	}

	// failed!
	// restore original position of drone
	CopyPosToItem(OldPos, pDrone);
	// restore original facing
	pDrone->OrientationH = SaveFacing;
	return false;

}
// this function move horizontally drone (in wild way) to avoid that it collide with items below it
void AvoidItemsForCrash(StrItemTr4 * pDrone)
{
	int CollType;
	GAME_VECTOR Geo;
	GAME_VECTOR OldPos;
	int i;
	int IncX, IncZ;
	int NewY;


	CopyItemToPos(pDrone, OldPos);

	// check that pDrone->CordY wasn't already beyond the ground
	NewY = pDrone->CordY;

	if ((NewY+PROF_GAP_OVER_FLOOR) > pDrone->HeightFloor) NewY = pDrone->HeightFloor - PROF_GAP_OVER_FLOOR;
	pDrone->CordY = NewY;

	// force drone in the middle of sector
	if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room)==true) {
		pDrone->CordX = FLOOR.SectorCoords.MiddleX;
		pDrone->CordZ = FLOOR.SectorCoords.MiddleZ;
	}
	// verify collisions
	i=0;
	do {

		pDrone->CordY = NewY;
		CopyItemToPos(pDrone, Geo);

		CollType= CheckCollisionForDrone(pDrone, false, &Geo, PROF_GAME_DOWN);		

		if (CollType != COLL_NO_COLLISION) {

			// no good sector, try another

			// restore start position
			CopyPosToItem(OldPos, pDrone);

			IncX = VetIncAttempts[i].x * 1024;
			IncZ = VetIncAttempts[i].y * 1024;

			if (IncX == 0 && IncZ==0) {
				// epic fail: no one free sector 
				CopyPosToItem(OldPos, pDrone);
				return;
			}

			pDrone->CordX = OldPos.CordX + IncX;
			pDrone->CordZ = OldPos.CordZ + IncZ;
			i++;
		}

	}while (CollType!= COLL_NO_COLLISION);

	// ok, this sector is good to avoid collision
	// force drone to move here
	// let last x,z coordinate and restore y coordimate
	pDrone->CordY = OldPos.CordY;	

}
// set the color of drone's back light
// if TestSwitchOn == true, then switch on the green light, otherwise it will be switched off
void ChangeBackLight(StrItemTr4 *pDrone, bool TestSwitchOn)
{
	if (TestSwitchOn==true) {
		// set visible the light green mesh
		pDrone->MeshVisibilityMask |= 2;
	}else {
		// set as  invisible the "light green" mesh
		pDrone->MeshVisibilityMask &= ~2;
	}
}
// to do bling the Drone's back light each PROF_BLINKING_TIME frams
void BlinkBackLight(StrItemTr4 *pDrone)
{
	BaseDrone.BlinkingCounter++;
	if (BaseDrone.BlinkingCounter >= PROF_BLINKING_TIME) {
		// invert the visibily of mesh
		BaseDrone.BlinkingCounter=0;
		// the mesh has index = 1 so its flag is 2  (2 <<  MeshIndex)
		if (pDrone->MeshVisibilityMask  & 0x0002) {
			// the green light was ON, set invisble this mash to get dark green (switch off)
			pDrone->MeshVisibilityMask &= ~2;
		}else {
			// it was invisible the mesh, now we set it visible
			pDrone->MeshVisibilityMask |= 2;
		}
	}

}
// add a real light, syncronized with blinking back light, to get the chance to drive the drone also in dark rooms
void AddRealLight(StrItemTr4 *pDrone)
{
	int IncX, IncZ;
	DWORD x, z;
	int y;

	// add the light only while the drone's back green led is on
	if ((pDrone->MeshVisibilityMask & 0x2)==0) return;

	// turn off light if drone has not open arms
	if (pDrone->StateIdCurrent == 7) return;

	// no light also if drone is inviisble
	if (BaseDrone.TestVisibleRealDrone == false) return;


	// ok, let's place this light
	// we'll place it close to back green led, anyway with the idea that, to spread this light, was not the little back green led, but 
	//			rather the four "feet" of drone

	GetIncrements(pDrone->OrientationH + 0x7fff, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);

	x= pDrone->CordX + IncX;
	z= pDrone->CordZ + IncZ;
	y = pDrone->CordY - (PROF_FULL_HSIZE_DRONE /2);
	TriggerDynamic(x,y,z, 16, 0,200,0);

}

// this function will simulate a floating on surface, moving a bit up and down the drone
void FloatingDrone(GAME_VECTOR *pDronePos)
{
	int Min;
	int Max;
	int WaterRoom;
	int WaterStrenght;
	int IncY;
	int Y_Base;

	// if we are in the pause of swinging (when drone is in upper position, skip movements in this cyle
	BaseDrone.FloatingPause--;
	if (BaseDrone.FloatingPause > 0) return;
	BaseDrone.FloatingPause =0;

	// discover min / max limits in swinging

	// we'll set the swinging range take as middle point the Y position of water surface (really, a bit lower), creating a range greatger or littler, in according with
	// movement of water in given room

	// first, we get floor data about position below the drone (to work on floor (water) room
	if (CheckFloor(pDronePos->CordX, pDronePos->CordY + 200, pDronePos->CordZ, pDronePos->Room)==false) return;

	// so we get the room index
	WaterRoom = FLOOR.RoomIndex;

	// now we discover the kind of water movement intensity
	Get(enumGET.ROOM, WaterRoom,0);

	WaterStrenght = GET.pRoom->WaterIntensity;
	Y_Base = FLOOR.WaterHeight + (PROF_FULL_HSIZE_DRONE / 2);

	// stronger it will be the water movement and bigger will be our movement range
	Min = Y_Base - (PROF_GAP_SWINGING_ON_FLOATING * WaterStrenght);
	Max = Y_Base + (PROF_GAP_SWINGING_ON_FLOATING * WaterStrenght);

	// now let's if we have to move up or down
	IncY = BaseDrone.FloatingIncY;

	if (IncY > 0) {
		pDronePos->CordY += IncY;
		if (pDronePos->CordY >= Max) {
			pDronePos->CordY = Max;
			// invert direction for next cycle
			BaseDrone.FloatingIncY = -PROF_FLOATING_VSPEED;
			// and set a short pause
			BaseDrone.FloatingPause = PROF_FLOATING_PAUSE_ON_PEAK;
			// add ripples
			SetupRipple(pDronePos->CordX , FLOOR.WaterHeight, pDronePos->CordZ , PROF_HALF_SIZE_DRONE, 2);
		}
	}

	if (IncY < 0) {
		pDronePos->CordY += IncY;
		if (pDronePos->CordY < Min) {
			pDronePos->CordY = Min;
			// invert direction
			BaseDrone.FloatingIncY = +PROF_FLOATING_VSPEED;
			// and set a short pause
			BaseDrone.FloatingPause = PROF_FLOATING_PAUSE_ON_PEAK;

			
	
		}
	}

}
// this function could work with drone items, indifferently it was real drone or pickup drone
// it will be used to enable or disable the shadow below the drone since, when it is floating, it's better don't display the shadow on water surface
void DisplayShadow(StrItemTr4 *pDrone, bool TestShow)
{
	int ShadowSize;

	Get(enumGET.SLOT, pDrone->SlotID,0);

	if (TestShow==true) {
		ShadowSize = 128;
	}else {
		ShadowSize = 0;
	}

	GET.pSlot->FootStep = ShadowSize;

}
// this function will handle the pickup drone when it has been let on a water surface

void HandlePickupDrone(void)
{
	GAME_VECTOR TempPos;
	GAME_VECTOR NewPos;
	StrItemTr4 *pDrone;
	StrItemTr4 *pLara;
	int Index;
	int AnimIndex;
	int FrameNow;
	int Distance;
	short Direction;
	int IdealDistance;
	int IncX, IncZ;
	bool TestOk;


	Index = BaseDrone.IndexPickupDrone;
	if (Index==-1) return;
	Get(enumGET.ITEM, Index,0);
	pDrone = GET.pItem;
	// since the function to do swinging the drone on the water, requires as input a GAME_VECTOR structure, I had to swap pickup position 
	// with a temporary structure like that
	CopyItemToPos(pDrone, TempPos);

	FloatingDrone(&TempPos);
	// and now I set new coordinatre to drone
	CopyPosToItem(TempPos, pDrone);

	// to give to Lara the chance to pickup the drone when it is floating on water surface it's necessary handle this new way to pickup an item

	// animatio  7 of LaraDrone slot, will be used to pickup the drone
	// as first step, we have to verify if this animation has not been alrady performed
	// this is a bit complicated because the animation if from DroneLara slot but we have to verify the currnet animation from normal lara slot
	// we locate the slot of Drone_lara to discover the first absolte index of its animations
	Get(enumGET.SLOT, enumSLOT.DRONE_LARA,0);

	AnimIndex = GET.pSlot->IndexFirstAnim + 7;

	// ok, was not so complicated
	// now we have to verify if lara is playing own this animation
	Get(enumGET.LARA, 0,0);
	pLara = GET.pLara;

	if (pLara->AnimationNow == AnimIndex) {
		// yes, it is own the (custom) pickup animation
		// now we have to verify when there is right (last) frame to remove pickup and select it as picked up to put it to inventory
		// discover relative frame
		FrameNow= Convert(enumCONV.FrameIndexFromAbsToRelative, pLara->FrameNow, AnimIndex,NULL);

		if (FrameNow == PROF_FRAME_PICKUP_FROM_WATER) {
			// ok, now we remove pickup drone and set as picked up item
			KillItem(BaseDrone.IndexPickupDrone);
			BaseDrone.IndexPickupDrone = -1;
			// we  remove the phases about 
			BaseDrone.DronePhase &= ~(DP_DRONE_PICKUP | DP_FLOATING);
			BaseDrone.DronePhase |= DP_NO_DRONES;
			// now we set drone as picked up item
			AddDisplayPickup(BaseDrone.PickupDroneSlot);
			return;
		}


	}else {
		// no picking up animation
		// we have to check if there are condition to start the floating pickup animation
		// lara should perform the 110 animation of lara (from real lara's slot)
		// and hit Action key
		if (pLara->AnimationNow == 110 && (*Trng.pGlobTomb4->pAdr->pInputGameCommands & enumCMD.ACTION)!=0 ) {
			// now we need lara was very close to floating drone
			Distance= GetDistanceXZ(pLara->CordX, pLara->CordZ, pDrone->CordX, pDrone->CordZ);

			

			if (Distance >= PROF_FLOAT_DISTANCE_MIN && Distance <= PROF_FLOAT_DISTANCE_MAX) {
				// distance is good, now it's necessry that lara was looking at drone
				Direction = GetDirection(pLara->CordX, pLara->CordZ, pDrone->CordX, pDrone->CordZ);
				// the difference, between lara's facing and ideal facing, should not bigger than PROF_FLOAT_MAX_ORIENT_FACING
				Direction = Direction - pLara->OrientationH;

				if (Abs(Direction) <= PROF_FLOAT_MAX_ORIENT_FACING) {
					// all ok!
					// we start animation to pickup drone
					ForceAnimationForLaraFromSlot(7, enumSLOT.DRONE_LARA);
					
				}
			}
		}
	}

	// ------- COLLISIONS
	// to avoid that lara was able to pass across floating drone, we'll add some code to manage collision
	// we manage this only when lara is floating on water, too

	if (*Trng.pGlobTomb4->pAdr->pLaraLocationFlags == LLF_FLOATING || 
			*Trng.pGlobTomb4->pAdr->pLaraLocationFlags == LLF_LOW_WATER) {
		// if lara is closer to drone (checking only (x,z) plan than ideal disance to pickup, move
		// the drone aways to preserve that distance
		IdealDistance = (PROF_FLOAT_DISTANCE_MIN+PROF_FLOAT_DISTANCE_MAX) / 2;
		Distance = GetDistanceXZ(GET.pLara->CordX, GET.pLara->CordZ, pDrone->CordX, pDrone->CordZ);

		if (Distance < IdealDistance) {
			// now we should move the drone... but, if the drone in this movement could be moved out of water, then 
			// use another method; keep lara awyay and let the drone in same position
			Direction = GetDirection(pLara->CordX, pLara->CordZ, pDrone->CordX, pDrone->CordZ);

			// compute the new position for drone, after the movement versus direction
			CopyItemToPos(pDrone, NewPos);

			GetIncrements(Direction, &IncX, &IncZ, IdealDistance);

			NewPos.CordX = GET.pLara->CordX + IncX;
			NewPos.CordZ = GET.pLara->CordZ + IncZ;

			// now check a further distance to verify drone side that could hit earlier some obstacle
			GetIncrements(Direction, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);

			TestOk=true;

			if (CheckFloor(NewPos.CordX+IncX, NewPos.CordY, NewPos.CordZ+IncZ, NewPos.Room)==false) {
				// invalid floor: drone cannot be moved here
				TestOk=false;
			}
			// if this point it's not on water: dont' move here
			if (FLOOR.WaterHeight == WALL_FLOOR) {
				TestOk=false;
			}

			if (TestOk==true) {
				// ok, move the drone in newpos position
				CopyPosToItem(NewPos, pDrone);
				UpdateItemRoom(BaseDrone.IndexPickupDrone);
			}else {
				// other method: push away lara
				// compute inc in opposite direction
				GetIncrements(Direction + 0x7fff, &IncX, &IncZ, IdealDistance);

				GET.pLara->CordX = pDrone->CordX + IncX;
				GET.pLara->CordZ = pDrone->CordZ + IncZ;
			}
		}
		

	}

	// simulate swinging on water (I'll use chnge on VOrient and ROient, since pickup items don't handle fine common animaions)
	// PROF_FLOAT_PICKUP_MAX_SWING

	pDrone->OrientationV += BaseDrone.FloatIncRotV;
	pDrone->OrientationT += BaseDrone.FloatIncRotT;

	// check for limit and sign inversion

	if (BaseDrone.FloatIncRotT > 0) {
		if (pDrone->OrientationT > PROF_FLOAT_PICKUP_MAX_SWING) {
			pDrone->OrientationT = PROF_FLOAT_PICKUP_MAX_SWING;
			BaseDrone.FloatIncRotT = -BaseDrone.FloatIncRotT;
		}
	}else {
		if (pDrone->OrientationT < -PROF_FLOAT_PICKUP_MAX_SWING) {
			pDrone->OrientationT = -PROF_FLOAT_PICKUP_MAX_SWING;
			BaseDrone.FloatIncRotT = -BaseDrone.FloatIncRotT;
		}
	}


	if (BaseDrone.FloatIncRotV > 0) {
		if (pDrone->OrientationV > PROF_FLOAT_PICKUP_MAX_SWING) {
			pDrone->OrientationV = PROF_FLOAT_PICKUP_MAX_SWING;
			BaseDrone.FloatIncRotV = -BaseDrone.FloatIncRotV;
		}
	}else {
		if (pDrone->OrientationV < -PROF_FLOAT_PICKUP_MAX_SWING) {
			pDrone->OrientationV = -PROF_FLOAT_PICKUP_MAX_SWING;
			BaseDrone.FloatIncRotV = -BaseDrone.FloatIncRotV;
		}
	}
	

}
// this function verifies if there are condition to perform a splash on water surface
bool IsOkForWaves(StrItemTr4 *pDrone)
{
	int i;
	int IncX;
	int IncZ;
	GAME_VECTOR TempPos;


	// it's necessary the below the drone there was a water room
	if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room)==false) return false;

	if (FLOOR.WaterHeight == WALL_FLOOR) return false;

	// the distance between drone and the water surface has to be less or even than PROF_DISTANCE_WATER_FOR_WAVES
	if ((FLOOR.WaterHeight - pDrone->CordY) > PROF_DISTANCE_WATER_FOR_WAVES) return false;

	// it should be ok but there is to fix a bug in tomb4: the shockwave on water is very large and tomb4 code doesn't take care
	// if the wave go over the water surface, invading also close ground.
	// to avoid this bad effect, we'll NOT add waves when the drone position is too close to ground sectors
	// PROF_DISTANCE_FROM_GROUND_FOR_WAVES
	// we'll check only hortogonal sectors
	CopyItemToPos(pDrone, TempPos);
	TempPos.CordY = FLOOR.WaterHeight;

	for (i=0;i<4;i++) {
		IncX = VetIncAttempts[i].x;
		IncZ = VetIncAttempts[i].y;

		TempPos.CordX = pDrone->CordX + IncX * 1024;
		TempPos.CordZ = pDrone->CordZ + IncZ * 1024;
		
		// remark: se checkfloor() == false, it will be ok, because it means a full wall and the extra waving will be not visible there
		if (CheckFloor(TempPos.CordX, TempPos.CordY, TempPos.CordZ, TempPos.Room) == true) {
			// the infaust situation is when the point has not water
			if (FLOOR.WaterHeight == WALL_FLOOR) {
				// and the floor is lower or even than height floor of water surface (Below the drone in its original postion)
				if (FLOOR.FloorHeight >= TempPos.CordY) return false;

			}
		}
	}
	return true;	

}
// start a rebounding
// this function discover the direction where to move (rebounding) the drone
void SetReboundDirection(StrItemTr4 *pDrone, GAME_VECTOR *pNewPos, int CollType)
{

	GAME_VECTOR *pOld;
	GAME_VECTOR SavePos;
	GAME_VECTOR Geo;
	GAME_VECTOR NextPos;
	int Old_Y_Inc;
	WORD NewDirection;
	int H_Speed;
	int	V_Speed;
	int OldSpeed;
	int Old_X_Inc;
	int Old_Z_Inc;
	int IncX, IncZ;
	bool TestOnlyVertical;

	// discover last direction
	pOld = &BaseDrone.LastPosition;
	// comute increments that affect the collision
	Old_X_Inc = pNewPos->CordX - pOld->CordX;
	Old_Z_Inc = pNewPos->CordZ - pOld->CordZ;
	// and in vertical
	Old_Y_Inc = pNewPos->CordY - pOld->CordY;

	// discover if drone hit a wall on only the ceiling
	TestOnlyVertical=false;
	if (CollType == COLL_CEILING) TestOnlyVertical=true;

	// discover old horixzontal speed (how distance has been covered)
	OldSpeed = GetDistanceXZ(pOld->CordX, pOld->CordZ, pNewPos->CordX, pNewPos->CordZ);
	
	// now we have to discover what old increment invert (changing the sign) to simulate a diagonal rebound on hortogonal obstacle (supposing walls)
	// if it's possible, we'll change only one old increment
	// note: if direction didn't involve X	axis, then it will be not this inc to be changed
	IncX = Old_X_Inc;
	IncZ = Old_Z_Inc;

	if (Old_X_Inc != 0 && TestOnlyVertical==false) {

		CopyItemToPos(pDrone, SavePos);

		// first attempt: invert only the sign of x increment
		IncX = -Old_X_Inc;
		IncZ = Old_Z_Inc;

		// let's verify if, avoiding change on Z axis, the drone will have another collision
		pDrone->CordX = pNewPos->CordX + IncX;
		pDrone->CordY = pNewPos->CordY;
		pDrone->CordZ = pNewPos->CordZ + IncZ;
		pDrone->Room = pNewPos->Room;
		SendToLog("Check X Inversion: IncX=%d  IncZ=%d", IncX, IncZ);
		CopyItemToPos(pDrone, Geo);
		// set also coordinate for geometry
		if (IncX > 0) {
			Geo.CordX +=  PROF_HALF_SIZE_DRONE;
		}
		if (IncX < 0) {
			Geo.CordX -= PROF_HALF_SIZE_DRONE;
		}
		if (IncZ > 0) {
			Geo.CordZ += PROF_HALF_SIZE_DRONE;
		}
		if (IncZ < 0) {
			Geo.CordZ -= PROF_HALF_SIZE_DRONE;
		}

		CollType=CheckCollisionForDrone(pDrone, false, &Geo, 0);
	
		// if there is a collision, then don't change incx
		if (CollType != COLL_NO_COLLISION) {
			// no good x inversion: restore original incX
			IncX = Old_X_Inc;

		}
		CopyPosToItem(SavePos, pDrone);
	}

	// try to change on Z axis if change on X didn't happen
	if (IncX == Old_X_Inc && Old_Z_Inc != 0 && TestOnlyVertical==false) {
		IncZ = -Old_Z_Inc;
		SendToLog("Use Inverted Z: IncX=%d IncZ=%d", IncX, IncZ);
	}

	// now we discvoer the new direction given by IncX, IncZ
	NextPos=*pNewPos;
	NextPos.CordX += IncX;
	NextPos.CordZ += IncZ;

	NewDirection = GetDirection(pNewPos->CordX, pNewPos->CordZ, NextPos.CordX, NextPos.CordZ);

	H_Speed = OldSpeed * 2;
	// compute inverted vertical position if there was a collison with ceiling
	V_Speed = 0;
	if (CollType & COLL_CEILING) {
		V_Speed = Old_Y_Inc * -3;
	}
	BaseDrone.Rebound_H_Speed  = H_Speed;
	BaseDrone.Rebound_H_Direction = NewDirection;
	BaseDrone.Rebound_V_Speed = V_Speed;
	if (V_Speed == 0) {
		// if it was missing a vertical rebound, let anyway loosing altitude
		BaseDrone.Rebound_V_LoseHeight = PROF_VSPEED;
	}else {
		// while, if there has been set a vertical rebound don't loose furtherly altitude		
		BaseDrone.Rebound_V_LoseHeight=0;
	}

	// restore old position
	*pNewPos = *pOld;


}
// this function tries to detect following situation:
// there is a collision that should stop the drore but...
// if the direction of drone is own that to move aways from obstacle, then remove collision to let drone going on
// Above sitution happens when the drone is so "pasted" with obstacle that, any direction, will get a collision outcome
bool IsToIgnoreCollision(GAME_VECTOR *pOld, GAME_VECTOR *pNew, int CollType)
{
	int IncX;
	int IncY;
	int IncZ;
	GAME_VECTOR ObjPos;
	GAME_VECTOR NextPos;
	int ObjIncX;
	int ObjIncZ;
	WORD Direction;
	StrCollisionAbsBox BoxAbs;
	StrTriplePoint Center;

	// we have to discover the direction that drone tried to follow in currnet cycle
	// Y increment: if it will be negative, it means the drone was moving upward
	IncY = pNew->CordY - pOld->CordY;

	// horizontal movements
	IncX = pNew->CordX - pOld->CordX;
	IncZ = pNew->CordZ - pOld->CordZ;

	// if there is no movement, then we quit
	if (IncY==0 && IncX ==0 && IncZ==0) return false;

	// now we have to discover (very hard in some circustances) where (respect drone) was the obstacle (upward, dowward, at north, easth ect)
	// we stat from easier situaiton: when drone collided with some object, moveable or static
	if (CollType & COLL_MOVEABLE_ITEM) {
		// with a moveable item: we have to discover its position
		Get(enumGET.ITEM, BaseDrone.CollisionItemIndex, 0);
		// now, we cannot using simply the origin coordinates of this item, because its collision box could be displaced respect origin,
		// like it happen with big push button for drone, where origin is in the center of the square but the item is on one of border of square
		// so we'll use the TurnCollisionBoxItem() function to get the middle point of collision box
		TurnCollisionBoxItem(GET.pItem, &BoxAbs, &Center);

		ObjPos.CordX = Center.CordX;
		ObjPos.CordY = Center.CordY;
		ObjPos.CordZ = Center.CordZ;

		LogOnDebug("Middle   Item Position: x=%d  y=%d  z=%d", ObjPos.CordX, ObjPos.CordY, ObjPos.CordZ);		
	}

	if (CollType & COLL_STATIC_ITEM) {
		// with a static item
		Get(enumGET.STATIC, BaseDrone.CollisionStaticRoom, BaseDrone.CollisionStaticIndex);
		// now we get the middle point of collision box of this static
		TurnCollisionBoxMesh(GET.pStatic, &BoxAbs, &Center);

		ObjPos.CordX = Center.CordX;
		ObjPos.CordY = Center.CordY;
		ObjPos.CordZ = Center.CordZ;
	}

	// now, if there was a collison with some item, let's if currnet drone direction is good to escape from that item
	if ((CollType & (COLL_MOVEABLE_ITEM | COLL_STATIC_ITEM)) != 0) {
		// if drone is moving upward, and the item was downstaris,then it's ok
		if (IncY < 0 &&  ObjPos.CordY > pNew->CordY ) return true;

		// now, let's check the opposite: drone was moving down and the object was upstairs
		if (IncY > 0 && ObjPos.CordY < pNew->CordY) return true;

		// if there was a vertical movement but it has not been good, the it is bad
		if (IncY != 0) return false;

		// now we check for horizontal direction
		ObjIncX = pNew->CordX - ObjPos.CordX;
		ObjIncZ = pNew->CordZ - ObjPos.CordZ;

		// its like if the object was movign with ObjIncZ, ObjIncZ direction to touch the drone,
		// now, if drone is moving with some direction (to escape from object) is good
		if (ObjIncX > 0 && IncX > 0) return true;
		if (ObjIncX < 0 && IncX < 0) return true;

		if (IncX != 0) return false;

		if (ObjIncZ > 0 && IncZ > 0) return true;
		if (ObjIncZ < 0 && IncZ < 0) return true;

		// if it's not good, then it's bad
		return false;
	}
	
	// there is no collision with items but with room geometry
	// perform a test, on the side of drone where was its last direction, to see if it's on that border that drone is colliding
	// if it's not, it means that player is driving the drone to a free direction

	Direction = GetDirection(pOld->CordX, pOld->CordZ, pNew->CordX, pNew->CordZ);

	GetIncrements(Direction, &IncX, &IncZ, PROF_HALF_SIZE_DRONE+PROF_HSPEED);
	if (IncY < 0) {
		IncY -= PROF_FULL_HSIZE_DRONE;
	}

	NextPos.CordX = pNew->CordX + IncX;
	NextPos.CordY = pNew->CordY + IncY;
	NextPos.CordZ = pNew->CordZ + IncZ;
	NextPos.Room = pNew->Room;


	if (CheckFloor(NextPos.CordX, NextPos.CordY, NextPos.CordZ, NextPos.Room) == false) {
		// if, in that future position, there is no valid floor, then its gone badly
		return false;
	}
	// if drone is below the floor: bad

	if (NextPos.CordY > FLOOR.FloorHeight) return false;
	// if drone is upper than ceiling: bad
	if (NextPos.CordY < FLOOR.CeilingHeight) return false;
	// if there is gray sector and drone cannot moving on them: bad
	if (FLOOR.TestGraySector == true && (BaseDrone.Flags & DRF_FORBIDDEN_BOXES) != 0) return false;

	// at end, it should be ok
	return true;
}
// show log #debug# 
void LogCamera(char * pMexIntro, StrAdrCamera *pCam)
{
	LogOnDebug("%s ModoNow=%d ModoNext=%d  pIndexCamNow=%d  TargetNow=0x%X  SecondsTimeCamera=%d",
		pMexIntro,
		*pCam->pIndexCameraNow, *pCam->pModeCameraNext , *pCam->pIndexCameraNow, *pCam->pTargetCameraNow, *pCam->pSecondsTimerCamera);



}

void DisableCam(void)
{
	StrAdrCamera *pCam;

	pCam = & Trng.pGlobTomb4->pAdr->Camera;
	*pCam->pModeCameraNext  = 0;
	*pCam->pIndexCameraNext = -1;
	*pCam->pTargetCameraNext = NULL;
	Trng.pGlobTomb4->pAdr->CamRotation=0;
	// remove further lost drone/disturb
	if (BaseDrone.DronePhase & DP_NOISES_ON_SCREEN) {
		BaseDrone.DronePhase &= ~DP_NOISES_ON_SCREEN;

		PerformFlipeffect(NULL, 358, BaseDrone.SpriteCmdId, 0);
		PerformFlipeffect(NULL, 358, BaseDrone.SpriteCmdId+1, 0);
	}
}
// change the tilt degrees of drone camera to look at lara's coordinate
void SetTiltCamForFollowMe(StrItemTr4 *pDrone,  DWORD LaraX, int LaraY, DWORD LaraZ)
{
	DWORD DroneX;
	int DroneY;
	DWORD DroneZ;
	int IncX, IncZ;
	short Direction;
	int Distance;

	// compute the specific coordinates of cam of drone
	GetIncrements(pDrone->OrientationH, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);

	DroneX  = pDrone->CordX + IncX;
	DroneY  = pDrone->CordY;
	DroneZ = pDrone->CordZ + IncZ;
	
	// now discover angle of tilt, for cam of drone, to look at Lara's coordinates

	// we have to move lara in front of drone (facing 0), keeping same currrnet horizontal distance

	Distance = GetDistanceXZ(DroneX, DroneZ, LaraX, LaraZ);

	// let's change the lara's position
	LaraX = DroneX;
	LaraZ = DroneZ + Distance;

	// now we can work on (Y, Z) plane to discover the veritcal direction for Drone ->  Lara direction

	Direction = GetDirection(DroneY, DroneZ, LaraY, LaraZ);

	// remove from current angle the further inclination of drone
	// (v orientation has inverted sign respect camera tilt)
	Direction += pDrone->OrientationV;

	// now check for limits, in the case current inclination was out of camera range
	if (Direction < PROF_CAM_MIN_TILT) Direction=PROF_CAM_MIN_TILT;

	if (Direction > PROF_CAM_MAX_TILT) Direction = PROF_CAM_MAX_TILT;

	BaseDrone.TiltCamera = Direction;


}
// only for log, show cooridnate as units and as sectors
char *LogCords(DWORD x, DWORD z)
{
	static char Buffer[100];

	sprintf(Buffer, "(x=%d ; z=%d) Sector: (%d ; %d)",
		x, z, x >> 10, z >> 10);
	return Buffer;
}

// this function tries to discover if there is a flipeffect, already scanned but not yet performed, for this sector
// to know in advance if the drone, on current sector, is going to activate a flipeffect that reduces the signal.
// It will be used to avoid to save, as last safe position, the sector where there is a reduction of signal
bool IsReductionFlip(void)
{
	int i;
	StrRecordFlip *pFlip;

	// perform also a check for (already enabled) reduction of signal in current sector
	if (BaseDrone.UserChangeDistance > 0 || BaseDrone.UserChangeWalls > 0) return true;

	for (i=0;i<Trng.pGlobTomb4->TotScanFlipEffects;i++) {
		pFlip = &Trng.pGlobTomb4->VetScanFlipEffects[i];

		if (pFlip->PluginId == Trng.IdMyPlugin && 
			(pFlip->Numero == 48 || pFlip->Numero == 54) && (pFlip->Timer & 0xff) != 0 ) {
			// there is a flipeffect to reduce the signal.
			LogOnDebug("DETECTED (in advance) flipeffect to reduce signal");
			return true;


		}
	}
	return false;

}

void ProcDroneControl(short ItemIndex)
{
	bool TestRecompute;
	int TotAttempts;
	bool TestNoDirections; // when it's true it means that, in current cycle, no command to move the drone (horizontally or verically) has been received
	WORD StateId;
	int Y;
	DWORD Pitch;
	bool TestSky;
	int HSpeed;
	int YCordSky;
	int NewY;
	int Distance;
	short OldRoll;
	int SaveY;
	bool TestQuitUserCmd;
	short IncRot;
	int FakeKeys;
	int DifY;
	bool TestOk;
	bool TestInsideFloor;
	bool TestInsideWall;
	DWORD Cx, Cz;
	int Cy;
	int IndexAnim;
	static GAME_VECTOR StartCam;
	GAME_VECTOR SavePos;
	short DifDirection;
	WORD Direction;
	bool TestSamePosition;
	bool TestUpdateMoving;
	bool TestDiagonals;
	WORD LaraStateId;
	int OldIncX, OldIncZ;
	bool TestModVFacing;
	bool TestModTFacing;
	int BackUpKeys;
	int i;
	int IncV;
	int IncT;
	int DiffV;
	int DiffT;
	int InputKeys;
	int IncX, IncZ;
	GAME_VECTOR OldPos;
	GAME_VECTOR NewPos;  //new position after (attempted) movement
	GAME_VECTOR Coll; // position for precise check on geometry (newpos+halfize of drone)
	int IncY;
	short Room;
	StrItemTr4 *pDrone;
	bool TestLanding;
	int CollType;  // COLL_... constant values
	StrAdrCamera *pCam;
	bool TestHelp; // player hit the help key
	bool TestReachedTarget; // if in this game cycle has been reached a prefixed target
	bool TestRTH_Key; 
	bool TestOnWater; // true when drone is flying over a water surface
	int GapYOverFloor;
	GAME_VECTOR FollowMeTarget;

	// ---------------------------------------- INITALIZE DATA FOR THIS GAME CYCLE  ----------------------------------------------------------

	if (BaseDrone.TestPresent==false) return;

	
	// get most data about drone and lara that will be used in this function
	Get(enumGET.ITEM, ItemIndex, 0);
	// save in a shortcut the str item of  drone:
	pDrone = GET.pItem;
	Get(enumGET.LARA,0,0);
	if (BaseDrone.TestCutScene==false) {

		// if read drone is invisible and lara is not holding the controller, we can skip all control procedure
		if (BaseDrone.TestVisibleRealDrone == false && GET.pLara->StateIdCurrent != 96) {
			// real drone is invisble and lara is doing other matters: skip control procedure
			// only work on drones could be on picup drone but only if it is floating on water
			if (BaseDrone.IndexPickupDrone != -1 && (BaseDrone.DronePhase & DP_FLOATING) != 0) {
				// management for floating effects and picking up on water of piclupdrone
				HandlePickupDrone();
			}
			return;
		}
	}
	StateId = pDrone->StateIdCurrent;



	LaraStateId= GET.pLara->StateIdCurrent;
	TestNoDirections=false;
	BaseDrone.TestCollision = false;
	TestHelp=false;
	TestReachedTarget=false;
	TestRTH_Key=false;
	TestOnWater=false;
	// ------------------------------------------- READ AND FILTER GAME #COMMANDS -----------------------------------------------------------\

	// read hit (but blocked) game commands
	InputKeys = Trng.pGlobTomb4->KeysStopped;

	if (BaseDrone.TestCutScene) InputKeys=0;

	if (BaseDrone.TestUserCommand == true && BaseDrone.UserCommand == UCMD_DIVERT_DRONE) {
		// disable all keys except quit drone

		InputKeys &= PROF_GAME_QUIT;
	}

	if ((InputKeys & (PROF_GAME_UP | PROF_GAME_DOWN | PROF_GAME_LEFT | PROF_GAME_RIGHT | PROF_GAME_FORWARD | PROF_GAME_BACKWARD))==0) {

		TestNoDirections=true;
	
	}

	// -------- check for #ALTITUDE LIMIT
	TestSky=false;
	if (IsCmd(PROF_GAME_UP) != 0) {

		// if room is outside set as limit the ceiling of top room
		Get(enumGET.ROOM, pDrone->Room, 0);
		if (GET.pRoom->FlagsRoom & enumFROOM.HORIZON ) {
			if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room)==true) {
				YCordSky=FLOOR.CeilingHeight;
				TestSky=true;

			}
		}
		// if it has been set altitude limit (via trigger) use this value
		if (BaseDrone.TestAlitudeLimit == true) {
			TestSky=true;
			YCordSky = BaseDrone.AltitudeLimit;
		}

		if (TestSky == true) {
			IncY = PROF_YGAP_TO_KEEP_HEIGHT+20;
			// drone is raising and there is an Altitude Limit: if the drone is in the range between YLimit / (YLimite + IncY*3))
			// remove up command and set y coordinate to preserve (drone will float around this altitude) the as (YLimit - IncY)
			
			Cy = pDrone->CordY;

			if (Cy <= (YCordSky+IncY*3) ) {
				// drone is critical zone below the limit
				
				// remove UP command
				InputKeys &= ~PROF_GAME_UP;
				// set y keep to preserve
				BaseDrone.Old_Y_ToKeep = YCordSky + IncY*2;


				// recompute TestNoDirection, since now we removed the up command
				if ((InputKeys & (PROF_GAME_UP | PROF_GAME_DOWN | PROF_GAME_LEFT | PROF_GAME_RIGHT | PROF_GAME_FORWARD | PROF_GAME_BACKWARD))==0) {

					TestNoDirections=true;
	
				}
			}
			// if it wasn't forever, disable for next cycle
			if (BaseDrone.TestAlitudeLimit==true) {
				if (BaseDrone.TestLimitForever == false) BaseDrone.TestAlitudeLimit =false;
			}
		}
	}
	// special commands will work only when we are in drone move, i.e. when lara is holding the controller
	if (BaseDrone.TestStoppedKeys==true) {
		// verify per special key (direct code for keyboard)
		TestHelp = IsKeyDown(PROF_VK_SHOW_HELP);

		TestRTH_Key = IsKeyDown(PROF_VK_RETURN_TO_HOME);

	}

	
	// management of double state  keys to void to read, many in a row, of their triggering

	if (IsCmd(PROF_GAME_TAKE_OFF_LANDING)==0) BaseDrone.TestSuspendTakeOff =false;
	if (IsCmd(PROF_GAME_QUIT) ==0) BaseDrone.TestSuspendQuit = false;
	if (IsCmd(PROF_GAME_SWAP_CAM)==0) BaseDrone.TestSuspendDrawWeapon=false;
	if (IsCmd(enumCMD.ACTION)==0) BaseDrone.TestSuspendAction=false;
	if (IsCmd(enumCMD.ENTER )==0) BaseDrone.TestSuspendEnter=false;
	if (IsCmd(enumCMD.INVENTORY)==0) BaseDrone.TestSuspendInventory=false;
	if (TestHelp == false) BaseDrone.TestSuspendHelpKey =false;
	if (TestRTH_Key == false) BaseDrone.TestSuspendRthKey = false;
	if (IsCmd(PROF_GAME_SWITCH_LIGHTS)== 0) BaseDrone.TestSuspendLightSwitch=false;

	// if we are in some automatic phase, ignore all input commands, to avoid interferences from player
	if (IsAutomaticPhase()==true) {
		// disable all keys, except the quit game command, to quit drone mode, swap cam view and SaveGame and LoadGame	
		InputKeys &= (PROF_GAME_QUIT | enumCMD.LOAD_GAME | enumCMD.SAVE_GAME | PROF_GAME_SWAP_CAM | PROF_GAME_SWITCH_LIGHTS) ;
	}
	// if some basic keyboard commands are suspended, remove them
	if (BaseDrone.TestSuspendAction == true) InputKeys &= ~enumCMD.ACTION;
	if (BaseDrone.TestSuspendEnter == true) InputKeys &= ~enumCMD.ENTER;
	if (BaseDrone.TestSuspendInventory == true) InputKeys &= ~enumCMD.INVENTORY;
	if (BaseDrone.TestSuspendLightSwitch == true) InputKeys &= ~PROF_GAME_SWITCH_LIGHTS;
	if (BaseDrone.TestSuspendHelpKey == true) TestHelp=false;
	if (BaseDrone.TestSuspendRthKey ==true) TestRTH_Key=false;

	if (BaseDrone.TestStartedSaveLoadGame==true) {
		// here we could perform some particular management for the, just completed, save/game operation, but really not so many ideas now...
		// se we simply remove that signal
		BaseDrone.TestStartedSaveLoadGame=false;
	}

	// ------------------------------------------ MANAGE DIRECT KEYBOARD COMMANDS ---------------------------------

	// show help?
	if (TestHelp==true) {
		// if there is VIEW_CAM_DRONE it's not possible showing a second image for help
		if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE && BaseDrone.MaskImageIndex != -1) {
			// in this case, we'll remove cam drone, waiting next cycel to show the help
			RemoveMaskImage();
			BaseDrone.ViewCamNow = VIEW_CAM_CHASE_DRONE;
			TestRemovedDroneCam=true;
		}else {
			// show help
			BaseDrone.TestSuspendHelpKey = true;
			ShowHelp();
			if (TestRemovedDroneCam==true) {
				// restore drone cam
				ChangeViewCam(VIEW_CAM_DRONE);
				TestRemovedDroneCam=false;
			}
		}
	}


	// remove testual help from screen?
	if ((InputKeys & enumCMD.INVENTORY) !=0 && (BaseDrone.DronePhase & DP_HELP_IN_PROGRESS)!=0) {
		// yes. there wash help text on screen: remove the string and remove inventory key
		i=BaseDrone.FirstStringIndex + MSG_HELP_TEXT;
		PerformFlipeffect(NULL, 204, i, 0);
		// remove help phase
		BaseDrone.DronePhase &= ~DP_HELP_IN_PROGRESS;
		// disable invetory key
		InputKeys &= ~enumCMD.INVENTORY;
		BaseDrone.TestSuspendInventory = true;
	}

	
	// ------------------------------------------------ UPDATE ROOM AND #FLOOR INFO ------------------------------------
	Room = pDrone->Room;
	GapYOverFloor = PROF_GAP_OVER_FLOOR;

	if (CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, Room)==true) {
		// drone is over a valid floor
		// update values about floor only when (now) it is a valid floor)

		if (Room != pDrone->Room) {
			UpdateItemRoom(ItemIndex);
		}
		// verify if there is water
		if (FLOOR.WaterHeight != WALL_FLOOR) {
			TestOnWater=true;
			// when drone is close to water surface don't try to keep it over floo
			GapYOverFloor=0;
			// we are over water, set the water surface as it was FloorHeight
			pDrone->HeightFloor = FLOOR.WaterHeight;
		}else {
	
			pDrone->HeightFloor = FLOOR.FloorHeight;
		}
		// forbid the drone to sink underground (but ignore this controll if it is floating on water)
		if ((BaseDrone.DronePhase & DP_FLOATING) ==0) {
			if (pDrone->CordY > (pDrone->HeightFloor  -GapYOverFloor)) {
				pDrone->CordY = (pDrone->HeightFloor  -GapYOverFloor);
			}
		}

	}


	// the change of drone's position, will be not made immediately on real coordinate but we'll use
	// other variables (NewPos...) to know in advance where the drone should go and forbid that, in the
	// case drone had proximity sensors

	CopyItemToPos(pDrone, NewPos);
	// save current drone's coordintes also in OldPos (to keep unchanged)
	CopyItemToPos(pDrone, OldPos);



	// ------------------------------------------------- #ROTATION MANAGEMENT ------------------------------------------

	// perform rotation commands (no issue about collisions in this case)
	if (BaseDrone.DronePhase & DP_FLYING) {

		if (IsCmd(PROF_GAME_TURN_LEFT)==true) {
			// rturning left
			pDrone->OrientationH -= PROF_ROTATE_SPEED;

			// removing the flags of this command (since it is double (SHIFT+LEFT) otherwise it will be be read also LEFT as move left
			InputKeys &= ~PROF_GAME_TURN_LEFT; 
		}
		if (IsCmd(PROF_GAME_TURN_RIGHT) == true) {
			// turning righ
			pDrone->OrientationH += PROF_ROTATE_SPEED;
			// removing double keys
			InputKeys &= ~PROF_GAME_TURN_RIGHT;
		}
		// ------------------  TILT CAMERA ------------------------
		if (IsCmd(PROF_GAME_CAM_DOWN_TILT) == true) {
			// moving down the drone's cam
			 BaseDrone.TiltCamera -= PROF_SPEED_CAM_TILT;
			 if (BaseDrone.TiltCamera < PROF_CAM_MIN_TILT) BaseDrone.TiltCamera = PROF_CAM_MIN_TILT;
			 // removign double key
			 InputKeys &= ~PROF_GAME_CAM_DOWN_TILT;
		}
		if (IsCmd(PROF_GAME_CAM_UP_TILT) == true) {
			// moving up drone's cam
			BaseDrone.TiltCamera += PROF_SPEED_CAM_TILT;
			if (BaseDrone.TiltCamera > PROF_CAM_MAX_TILT) BaseDrone.TiltCamera=PROF_CAM_MAX_TILT;
			
			// removing double key
			InputKeys &= ~PROF_GAME_CAM_UP_TILT;

		}

	}
	
	// earleir it was here the check for no direction

	// ---------------------------------------------- #GRAVITY SIMULATION ----------------------------------------

	// simulate gravity only when there have been no directional commands or automatic movements
	if (IsAutomaticPhase()==false  && 
				TestNoDirections==true && (BaseDrone.DronePhase & DP_FLYING)!=0) {
	
		IncY = PROF_GRAVITY_SPEED;
		if ((BaseDrone.DronePhase & DP_RECOVER_OLD_HEIGHT) ==0) {
			// using inertial speed up, reducing a bit each cycle
			IncY += BaseDrone.SpeedVertical ;
			BaseDrone.SpeedVertical++;
			if (BaseDrone.SpeedVertical  > 0) BaseDrone.SpeedVertical  =0;

		}
		NewPos.CordY   += IncY;


	}



	// ---------------------------------------------------- QUIT FOR #DAMAGED LARA -----------------------------------------

	// if lara has been hurt (by drone or other enmey) quit immeediately driving drone mode
	// perform only if lara was in driving drone mode, of course
	if (GET.pLara->StateIdCurrent == 96) {
		if (GET.pLara->FlagsMain & enumFITEM.ITEM_HAS_BEEN_HIT) {
			// start quit drone (at least we are not alrady in this phase
			if ((BaseDrone.DronePhase & DP_QUIT_DRONE_MODE) == 0) {
				if (BaseDrone.DronePhase & DP_TAKE_OFF) {
					BaseDrone.DronePhase |= DP_FAILED_TAKE_OFF;
					BaseDrone.DronePhase &= ~DP_TAKE_OFF;
				}
				QuitDroneMode();
				// disable all keys
				InputKeys=0;
			}
		}
	}
	// -------------------------------- #BLINKING BACK #LIGHT ----------------------------------------
	// BLINKING BACK LIGHT?
	// to do blinking green light only when propeller are running
	if ((StateId >=2 && StateId <=4) || StateId == 8) {
		BlinkBackLight(pDrone);
	}else {

		// SET FIXED LIGHT!
		// when propellers are still, stop blinking
		// if battery has maxlevel, switch on light
		if (BaseDrone.BatteryLevel == (BaseDrone.BatteryMinutes * 60 * 30)) {
			ChangeBackLight(pDrone, true);   // switch on green light
		}else {
			ChangeBackLight(pDrone, false); // switch off the light
		}
	}
	// ENABLE/DISABLE landing lights?
	if (IsCmd(PROF_GAME_SWITCH_LIGHTS)) {
		// invert the landing light state
		if (BaseDrone.TestLandingLights == true) {
			BaseDrone.TestLandingLights = false;
		}else {
			BaseDrone.TestLandingLights = true;
		}
		BaseDrone.TestSuspendLightSwitch =true;
	}

	// show also landing lights if they have been enabled or if drone is landing
	if (BaseDrone.TestLandingLights==true || (BaseDrone.DronePhase & DP_LANDING)!= 0)	{
		AddRealLight(pDrone);
	}
	// ---------------------------------  MANAGEMNT OF REACHING #TARGET -------------------------------------------------------
	TestReachedTarget=false;
	if (BaseDrone.DronePhase & DP_FLYING) {
		// is there "follow me" cutscnee?
		if (BaseDrone.TestCutScene == true && BaseDrone.TestUserCommand==true && BaseDrone.UserCommand == UCMD_FOLLOW_LARA &&
			(BaseDrone.DronePhase & DP_TAKE_OFF)==0) {
			// set the target, build on lara position and min horizontal and vertical distance
			// save to FollowMeTarget
			// now we'll use the function to reach home (return to home) but with this new target


			// check difrecton betweem drone and lara
			Direction= GetDirection(pDrone->CordX, pDrone->CordZ, GET.pLara->CordX, GET.pLara->CordZ);
			// now locate position to stop MinHDistance before reaching lara
			Distance = GetDistanceXZ(pDrone->CordX, pDrone->CordZ, GET.pLara->CordX, GET.pLara->CordZ);
			Distance -= BaseDrone.UserMinHDistnce;
			// modify target only if distance is greater the 256
			if (Distance > 256) {
				// now compute this intermediate point
				GetIncrements(Direction, &IncX, &IncZ, Distance);

				FollowMeTarget.CordX = pDrone->CordX + IncX;
				FollowMeTarget.CordZ = pDrone->CordZ + IncZ;
				FollowMeTarget.Room = GET.pLara->Room;

				// now we compute Y target
				FollowMeTarget.CordY = GET.pLara->CordY - BaseDrone.UserMinVDistance;
				
				// we remove all targets
				BaseDrone.DronePhase &= ~(DP_CHASE_TARGET | DP_REACH_Y_TARGET);

				if (FindTargetRTH(pDrone, &FollowMeTarget)==false) {
					LogOnDebug("Failed target for follow me: DroneY.y=%d ; attempted TargetY=%d ;(Old_TargetY=%d  (Try with OldGoodTarget y=%d))", 
						pDrone->CordY, FollowMeTarget.CordY, BaseDrone.Target_Y_Only, BaseDrone.LastLaraTargetOk.CordY  );
					if (BaseDrone.LastLaraTargetOk.CordX != 0) {
						// retry with old laratargetok
						FollowMeTarget = BaseDrone.LastLaraTargetOk;
						if (FindTargetRTH(pDrone, &FollowMeTarget)==true) {
							LogOnDebug("Restored old target. TargetYOnly=%d", BaseDrone.Target_Y_Only );
						}
					}
				}else {
					// found path for target: save currnet lara target position
					BaseDrone.LastLaraTargetOk = FollowMeTarget;


				}

			}

		}

		if (IsSomeTarget()==true) {
			// since the MoveToTarget() change real drone position, we have to move the NewPos coordinate to drone and then restore then
			CopyItemToPos(pDrone, SavePos);

			// there was a target movement in progress
			TestReachedTarget=MoveToTarget(pDrone);
			// update the movment of drone in NewPos 
			CopyItemToPos(pDrone, NewPos);
			// and restore original coordinates to drone
			CopyPosToItem(SavePos, pDrone);

		
		}
		//  FAILURE OF REACHING TARGET?
		if (IsSomeTarget()==true) {
			if (BaseDrone.TestOldCollision==true) {
				ManageFailure(pDrone);
			}
		}
	}
	// ------------------------------------ MANAGE #FAILURE ---------------------------------------
	// if drone is frozen (it's not able to solve a failure moment) enable emergency landing
	if ((BaseDrone.DronePhase & DP_FAILURE)!= 0 && BaseDrone.PercSignal == 0) {
		// previous phase failed, the drone is not controllable by player (no signal)
		// in this situation, if there is not phase in progress, start an emergency landin
		if ((BaseDrone.DronePhase & (DP_EMERGENCY_LANDING | DP_CRASH_IN_PROGRESS | DP_RECOVERING_SAFE_POSITION | 
										DP_CHASE_TARGET | DP_REACH_Y_TARGET | DP_LANDING))==0) {
			// start emergency landing
			BaseDrone.DronePhase |= (DP_EMERGENCY_LANDING | DP_LANDING);
			// remove user commands if it was follow me
			if (BaseDrone.UserCommand == UCMD_FOLLOW_LARA)  BaseDrone.TestUserCommand=false;

		}
	}

	// ------------------------------------ #RTH RETURN TO HOME ----------------------------------------

	// FAILED RTH?
	if (BaseDrone.DronePhase & DP_RETURN_TO_HOME) {
		if (BaseDrone.TestOldCollision == true) {
			// stopped by collision: failed
			ManageFailure(pDrone);
		}

	}
	// START RTH?
	if (TestRTH_Key==true && (BaseDrone.DronePhase & DP_RETURN_TO_HOME)==0) {
		// start return to home
		BaseDrone.DronePhase |= DP_RETURN_TO_HOME;

		if (FindTargetRTH(pDrone, NULL)==false) {
			// failed
			ManageFailure(pDrone);
		}

	}
	// TO DO COMPLETE RTH?
	if (TestReachedTarget==true  && (BaseDrone.DronePhase & DP_RETURN_TO_HOME) != 0)  {
		// jump completd chasing targets
		// now just move down the drone
		// start a landing
		BaseDrone.DronePhase |= DP_LANDING;
		BaseDrone.DronePhase &= ~DP_RETURN_TO_HOME;
		LogOnDebug("REACHED RETURN TO HOME: %s           <----------------", LogCords(BaseDrone.Target.CordX, BaseDrone.Target.CordZ));

	}

	// -------------------------------------------- CHECK FOR #CUTSCENE AND #USER COMMANDS ---------------------------
	// --- START LANDING FOR CUTSCENE? (dopo aver raggiunto target)

	if (BaseDrone.TestCutScene == true && TestReachedTarget==true) {
		// #follow me
		if (BaseDrone.TestUserCommand == true && BaseDrone.UserCommand == UCMD_FOLLOW_LARA) {
			// follow me
			// we reached min distance in horizontal
			// now we move down the drone until min vertical distance
			Y = GET.pLara->CordY - BaseDrone.UserMinVDistance;
			if (Abs(Y - pDrone->CordY) > 100) {
				// non ancora raggiunto

				// fare un altro target y per farlo scendere o salire
				// verificare pero' che non vada a sbattere su soffitto o pavimeto
				CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room);
				if (Y > (FLOOR.FloorHeight-256)) Y=FLOOR.FloorHeight - 256;

				// vedere se c'e' superfice acqua
				if (FLOOR.WaterHeight != WALL_FLOOR) {
					if (Y > (FLOOR.WaterHeight - 256)) Y=FLOOR.WaterHeight - 256;
				}
				// che non vada  sbattere sul soffitto
				if (Y < (FLOOR.CeilingHeight + 256)) Y=FLOOR.CeilingHeight + 256;

				BaseDrone.Target_Y_Only = Y;
				BaseDrone.DronePhase |= DP_REACH_Y_TARGET;

			}


		}else {
			// common cutscene we start the landing
			// start landing
			BaseDrone.DronePhase |= DP_LANDING;
		}
	}
	// ---- USER COMMAND TO PERFORM?
	if (BaseDrone.TestUserCommand==true) {
		switch (BaseDrone.UserCommand) {
		case UCMD_FOLLOW_LARA:
			// if there have been a collision
			if (IsSomeTarget()==false) {
				// drone has not target in this moment
				// if drone is lower than Lara, set as y coordinate to keep that one of target
				NewY = GET.pLara->CordY -BaseDrone.UserMinVDistance;
				// verify the ideal altitute was not possibile in this moment for ceiling
				CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room);
				if ((NewY-PROF_FULL_HSIZE_DRONE-100)  < FLOOR.CeilingHeight) {
					NewY = FLOOR.CeilingHeight + PROF_FULL_HSIZE_DRONE + 100;
				}

				DifY = pDrone->CordY - NewY;

				if (DifY > 0) {
					// imposta recovery height al valore ideale a meno che fosse gia' impostato quel valore
					if (BaseDrone.Old_Y_ToKeep != NewY) {
						BaseDrone.Old_Y_ToKeep = NewY;
						BaseDrone.DronePhase |= DP_RECOVER_OLD_HEIGHT;


					}
				}
			}

			// ROTATE drone and change tilt camera to look at lara
			// rotate only if there is no chase target alone (if there is also reach y target, it's ok)
			TestOk=true;

			if ((BaseDrone.DronePhase & DP_REACH_Y_TARGET)==0 && (BaseDrone.DronePhase & DP_CHASE_TARGET) != 0) TestOk=false;

			if ((BaseDrone.DronePhase & DP_FLYING)==0 || (BaseDrone.DronePhase & DP_TAKE_OFF) != 0) TestOk=false;

			if (TestOk==true) {
				Direction = GetDirection( pDrone->CordX, pDrone->CordZ, GET.pLara->CordX, GET.pLara->CordZ);

				// now Direction is the perfect direction to look at lara, we compare this ideal facing
				// with that current of drone
				DifDirection = GetLittlestRotation(pDrone->OrientationH , Direction);

				// if the (absolute) difference is greater than 0x2000 (about 45 degrees) we'll rotate lara
				// to get her facing, closer to ideal direction
				if (abs(DifDirection) >= 0x1000 ) {
					// we have to turn drone

					// let's discover what is better (shorter) clockwise direction
					if (DifDirection < 0) {
						IncRot = -PROF_LARA_ROTATE_SPEED;

					}else {
						IncRot = PROF_LARA_ROTATE_SPEED;
					}
					pDrone->OrientationH += IncRot;
				}

			}

			// change TILT camera
			// but don't tilt camera if there is no free line of fire between drone and lara
			if (ComputeAmountOfWalls(pDrone, GET.pLara) == 0) {

				SetTiltCamForFollowMe(pDrone, GET.pLara->CordX, GET.pLara->CordY - 700, GET.pLara->CordZ);
			}

			break;

		case UCMD_ROLLING:
			OldRoll= Trng.pGlobTomb4->pAdr->CamRotation;
			Trng.pGlobTomb4->pAdr->CamRotation += BaseDrone.UserParameter;
			// check we performed a full rolling
			TestQuitUserCmd=false;

			if (BaseDrone.UserParameter > 0) {
				if (Trng.pGlobTomb4->pAdr->CamRotation >=0 && OldRoll < 0) {
					// completed
					TestQuitUserCmd=true;
				}
			}else {
				if (Trng.pGlobTomb4->pAdr->CamRotation <= 0 && OldRoll > 0) {
					TestQuitUserCmd=true;
				}
			}

			if (TestQuitUserCmd==true) {
				BaseDrone.TestUserCommand =false;
				Trng.pGlobTomb4->pAdr->CamRotation=0;
			}
		}


	}
	// ---- COMPLETED USER COMMAND?
	if (BaseDrone.TestUserCommand==true) {
		switch (BaseDrone.UserCommand) {
		case UCMD_LANDING:
			// if there is no more landing, completged
			if ((BaseDrone.DronePhase & DP_LANDING)==0) {
				BaseDrone.TestUserCommand = false;
			}
			break;
		case UCMD_FALLING_DOWN:
			if ((BaseDrone.DronePhase & DP_FLYING)==0) {
				BaseDrone.TestUserCommand = false;
				BaseDrone.DronePhase &= ~(DP_LOST_DRONE | DP_CRASH_IN_PROGRESS | DP_NO_SIGNAL);
			}
			break;
		case UCMD_SHAKE_AND_TROUBLE:
			if ((BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT)==0) {
				BaseDrone.TestUserCommand =false;
			}
			break;
		case UCMD_DIVERT_DRONE:

			if (BaseDrone.DronePhase & DP_LANDING) {
				// drone is landing, ok
				BaseDrone.TestUserCommand =false;
			}

			if (TestReachedTarget == true) {
				// drone is reached the horizontal target
				// now let's see if we need to move drone vertically to reach also a different y position
				// if there is a reach y target, we have not yet completed the command
				if ((BaseDrone.DronePhase & DP_REACH_Y_TARGET)==0) {

					if (Abs(BaseDrone.Target.CordY - pDrone->CordY) < 10) {
						// ok, we completed the command
						BaseDrone.TestUserCommand = false;
					}else {
						// there is to reach a different height
						// if the y is on the ground, just set a landing
						CheckFloor(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room);
						if (FLOOR.FloorHeight == BaseDrone.Target.CordY) {
							// yes: set a landing
							BaseDrone.DronePhase |= DP_LANDING;
						}else {
							// now, we have to set a reaching y target
							BaseDrone.Target_Y_Only = BaseDrone.Target.CordY;
							BaseDrone.DronePhase |= DP_REACH_Y_TARGET;
						}
					}
				}
			}
			break;
		}

	}


	// -------------------------------------------------- CHECK FOR MANUAL OR AUTOMATIC #LANDING on GROUNG OR #WATER -------------------------------------------


	// FAILURE OF LANDING?
	if ((BaseDrone.DronePhase & DP_LANDING)!= 0 && BaseDrone.TestOldCollision == true) {
		// there was a landing phase but it has been stopped by a collisione
		ManageFailure(pDrone);


	}
	// START LANDING FOR GROUND CONTACT ? (because drone touches the ground or the water surface)
	// if drone was flying and now it's touching the ground, this is a landing
	// let's see if we have to start a Landing phase
	if ((NewPos.CordY+GapYOverFloor) >= pDrone->HeightFloor  && (BaseDrone.DronePhase & DP_LANDING)==0) {

		TestLanding=true;
		// anyway, if the drone was taking off, don't consider a landing
		if (BaseDrone.DronePhase & DP_TAKE_OFF) TestLanding =false;

		// and neither if player gave up command
		if (IsCmd(PROF_GAME_UP)) TestLanding =false;



		// if drone was not flying, it's not a landing
		if (StateId !=2 && StateId != 4) TestLanding = false;

		if (TestLanding) {
			// YES. Start landing pahse
			BaseDrone.DronePhase |= DP_LANDING;

			// animation to stop properller
			ForceAnimationForItem(pDrone, 2, -1);
			BaseDrone.Old_Y_ToKeep = NewPos.CordY;



		}
	}
	
	// PLAYER REQUIRES LANDING?
	// detecting a request for landing (always with enter/action key)
	if ((BaseDrone.DronePhase & DP_FLYING) && (BaseDrone.DronePhase & DP_TAKE_OFF)==0) {
		if (BaseDrone.TestSuspendTakeOff ==false && IsCmd(PROF_GAME_TAKE_OFF_LANDING)) {
			BaseDrone.DronePhase |= DP_LANDING;
			BaseDrone.TestSuspendTakeOff  =true;
		}
	}

	// ----------- TOUCHED THE GROUND?
	// verifiy if landing phase has been completed
	if ((BaseDrone.DronePhase & DP_LANDING)!= 0 && (BaseDrone.DronePhase & DP_FLYING)!=0) {

		// verify if drone touched ground/water surface

		if ((NewPos.CordY+GapYOverFloor) >= pDrone->HeightFloor) {
			// yes!
			BaseDrone.DronePhase &= ~DP_FLYING;
			// if it has been enabled, activat further heavy triggers in this sector
			if (BaseDrone.Flags & DRF_ENGAGE_PAD_HEAVY) {
				EngageTriggersOnSector(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room, true);
			}

			NewPos.CordY  = pDrone->HeightFloor  + GapYOverFloor;
			if (TestOnWater==true) {
				// if it landed on water surface create a "splash" effect
				Splash(pDrone);
			}


			// start animation to stop propellers
			// animation to slow down propellers and then stop them
			ForceAnimationForItem(pDrone, 2, -1);
			if (BaseDrone.Flags & DRF_MAGNET_SKILL) {
				// check if in current sector there is a KEY item with ocb 512
				if (Find(enumFIND.ITEMS_SECTOR, -1, pDrone->Room , 512, 0, &pDrone->CordX )==true) {
					// there are items with ocb = 512
					// verifiy if it is a KEY slot item
					for (i=0;i<FIND.TotItems;i++) {
						Get(enumGET.ITEM, FIND.VetItems[i], 0);
						if (GET.pItem->SlotID >= enumSLOT.KEY_ITEM1 &&
							GET.pItem->SlotID <= enumSLOT.KEY_ITEM12) {
								// yes!
								// store this slot item (to give to lara when she'll pickup the drone)
								// and remove the item
								BaseDrone.PickedUpKey = GET.pItem->SlotID;
								KillItem(FIND.VetItems[i]);
								ShowMessage(false, MSG_TAKEN_ITEM, PROF_LONG_TIME_WARNING_MSG, NULL);
								break;
						}

						
					}


				}
			}
			

		}
	}

	// ----- MANAGE TARGET LANDING IN PROGRESS
	if ((BaseDrone.DronePhase & DP_LANDING) != 0 && (BaseDrone.DronePhase & DP_FLYING)!=0 ) {

		// landing is in progress
		// analyse to move (horizontally) drone to avoid sectors that are wrong for landing
		// if there is not already a target, find one now
		
		if (IsSomeTarget()==false) {
			if (BaseDrone.DronePhase & DP_FAILED_TAKE_OFF) {
				// to do land the drone from where it took off
				BaseDrone.Target_Y_Only = pDrone->HeightFloor;
				BaseDrone.DronePhase |= DP_REACH_Y_TARGET;
			}else {
				// look for ideal sector where landing
				FindTargetForLanding(pDrone);
			}
		}
		// let's see if there is yet no target to reach , it means we are in right vertical to land
		if (IsSomeTarget()==false  ) {

			// we have only to move down the drone
			// anyway I'll keep a standard code that, theratically, could handle also a moving up of the drone
			IncY =0;

			// now we can work on verical
			DifY = pDrone->HeightFloor  - NewPos.CordY;
			// if dify = 0 we have already reached the right height, so we can cancel the DP_RAISING_DRONE phase
			if (DifY != 0) {
			
				// not yet reached: move drone in vertical.
				// we have to set a reasonable Y increment

				if (DifY > 0) {
					IncY = PROF_VSPEED;
					if (IncY > DifY) IncY = DifY;
				}else {
					IncY = -PROF_VSPEED;
					if (Abs(IncY) > Abs(DifY)) IncY = DifY;
				}
					
			}
				
			// update drone position
			NewPos.CordY  += IncY;
		}
			
			
	}

	// -------- END LANDING PHASE?
	if (BaseDrone.DronePhase & DP_LANDING) {
		// COMPLETED THE LANDING?
		// verify if landing has been completed
		if (StateId == 1) {
			// YES. drone stopped the propellers
			// remove landing pahse
			BaseDrone.DronePhase &= ~(DP_EMERGENCY_LANDING | DP_LANDING);
			// if drone landed on water: set the phase
			if (TestOnWater==true) {
				BaseDrone.DronePhase |= DP_FLOATING;
				BaseDrone.FloatingIncY = PROF_FLOATING_VSPEED;
				DisplayShadow(pDrone, false);
				ForceNewAnimationAtFrame(pDrone, 7, 26);

			}

			// and other phases that cannot work with the drone on the ground
			BaseDrone.DronePhase &= ~(DP_FLYING | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION | 
											DP_CHASE_TARGET | DP_RETURN_TO_HOME | DP_REACH_Y_TARGET) ;

	
			// now, to set if pass to READY phase or PICKUP phase, we chech what is the state id of lara
			if (GET.pLara->StateIdCurrent == 96) {
				// lara is still with controller in her hands. We set READY (for a new flight) phase
				BaseDrone.DronePhase |= DP_READY;

			}else {
				// lara has not controller: close the drone and set for pickup phase
				BaseDrone.DronePhase |= DP_PREPARING_TO_PICKUP;
				ForceAnimationForItem(pDrone, 4, -1);
			}
			
		}
	}

	

	// -------------------------- MANAGE #FLOATING ON THE WATER ---------------------------------

	// QUIT FLOATING?
	if ((BaseDrone.DronePhase & DP_FLOATING)!= 0 && (BaseDrone.DronePhase & DP_DRONE_PICKUP)==0) {
		// if there has been a take off, or a moving upward, quit the floating
		if ((BaseDrone.DronePhase & DP_TAKE_OFF) != 0 || IsCmd(PROF_GAME_UP) != 0) {
			BaseDrone.DronePhase &= ~DP_FLOATING;
			DisplayShadow(pDrone, true);
		}
	}

	// MANAGE FLOATING IN PROGRESS
	if (BaseDrone.DronePhase & DP_FLOATING) {
		// to do "float" the drone on water surface
		FloatingDrone(&NewPos);


	}

	// SIMULATION WAVES on water surface
	// if the drone is flying and it is very close to water surface to do splash below it on water surface
	if ((BaseDrone.DronePhase & DP_FLYING) != 0) {
		if (IsOkForWaves(pDrone)==true)  {

			BaseDrone.DelayForWaves--;
			if (BaseDrone.DelayForWaves < 0) {
				BaseDrone.DelayForWaves = PROF_DURANTE_PAUSE_BETWEEN_WAVES;
				// to do work the splash effect, it's necessary that y coordintre was really on water surface
				// we'll change tremporarily that value
				SaveY=pDrone->CordY;
				pDrone->CordY = pDrone->HeightFloor + 1;
				Splash(pDrone);
				pDrone->CordY = SaveY;
			}
				
		}
	}

	// -------------------------- MANAGE FOR RECOVERING #SAFE POSITION ------------------------------------------

	if (BaseDrone.DronePhase & DP_RECOVERING_SAFE_POSITION) {
		// verify if we reached target

		if (TestReachedTarget==true) {
			// yes! we can remove recover position phase
			BaseDrone.DronePhase &= ~DP_RECOVERING_SAFE_POSITION;
			// and lost drone (but it should have already been removed
			BaseDrone.DronePhase &= ~DP_LOST_DRONE;
			LogOnDebug("REACHED Last Safe Position: %s           <----------------", LogCords(BaseDrone.Target.CordX, BaseDrone.Target.CordZ));

		}else {
			// not yet. Let's see if we have to set the target
			// (while, in the case there was alrwdy a set target, we have only to wait)
			if (IsSomeTarget()==false) {
				// not yet set a target: set now!
				// try to reach Last safe position
				// we set as current target the last safe pos
				
				BaseDrone.DronePhase |= DP_CHASE_TARGET;
				BaseDrone.Target = BaseDrone.LastSafePoint;
				LogOnDebug("MOVE to Last Safe Position: %s", LogCords(BaseDrone.Target.CordX, BaseDrone.Target.CordZ));

				// if there is a difference on y axis, enable also DP_RAISING phase (that could work also to move down the drone)
				if (abs(BaseDrone.LastSafePoint.CordY - pDrone->CordY) > 256) {
					BaseDrone.DronePhase |= DP_REACH_Y_TARGET;
					BaseDrone.Target_Y_Only = BaseDrone.LastSafePoint.CordY;
				}
			}

		}
	}
	// ---------------------------------------#CRASH DP_CRASH_IN_PROGRESS MANAGEMENT -------------------------------------

	// Starting falling down?
	if ((BaseDrone.DronePhase & DP_CRASH_IN_PROGRESS)==0  && (BaseDrone.DronePhase & DP_FLYING)!=0 ) {
		// not yet active but if percbattery reached 0, start now
		if ((BaseDrone.Flags & DRF_USE_BATTERIES)!=0 && BaseDrone.BatteryLevel == 0) {
			BaseDrone.DronePhase |= (DP_CRASH_IN_PROGRESS | DP_LOST_DRONE | DP_NO_BATTERY);
			BaseDrone.FallingSpeed = PROF_VSPEED;
			// remove ohter automatic pahses
			BaseDrone.DronePhase &= ~(DP_RETURN_TO_HOME| DP_CHASE_TARGET | DP_READY |
											DP_REACH_Y_TARGET | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION |
											DP_EMERGENCY_LANDING | DP_LANDING);
		}
	}
	if (BaseDrone.DronePhase & DP_CRASH_IN_PROGRESS) {
		// no matter: falling down
		// increase falling speed
		BaseDrone.FallingSpeed++;
		// until limit
		if (BaseDrone.FallingSpeed > PROF_MAX_FALLING_SPEED ) BaseDrone.FallingSpeed = PROF_MAX_FALLING_SPEED;

		NewPos.CordY += BaseDrone.FallingSpeed;
		CopyPosToItem(NewPos, pDrone);

		// if drone is going to collide with some items (below it) move suddenly in horizontal to avoid
		AvoidItemsForCrash(pDrone);
		CopyItemToPos(pDrone, NewPos);
		
		// if drone reached ground stop crash and set for prepare pickup

		if ((NewPos.CordY+GapYOverFloor) >= pDrone->HeightFloor) {
			// crash on the ground
			// stop the phase crash, flying and all other automatic phases
			BaseDrone.DronePhase &= ~(DP_CRASH_IN_PROGRESS | DP_FLYING | DP_READY |DP_RETURN_TO_HOME| DP_CHASE_TARGET |
											DP_REACH_Y_TARGET | DP_REBOUND_ON_IMPACT | DP_RECOVERING_SAFE_POSITION |
											DP_EMERGENCY_LANDING | DP_LANDING);
			NewPos.CordY = pDrone->HeightFloor - GapYOverFloor;
			// force this position
			CopyPosToItem(NewPos, pDrone);

			// toggle controller at lara, quitting by drone mode
			QuitDroneMode();
		}

	}
	// ------------------------------------------- MANAGE BLOCKED KEYS AND #QUIT DRONE MODE -----------------------------------



	// if we are in drone mode (keyboard has been disabled) giving always the chance to quit
	if (BaseDrone.TestStoppedKeys==true) {
		// if player hit Escape (inventory) start quit drone move pahse
		if (BaseDrone.TestSuspendQuit == false && IsCmd(PROF_GAME_QUIT)) {
			BaseDrone.TestSuspendQuit =true;
			QuitDroneMode();		
		}
	}

	// enable new keyboard if there is quit drone phase and the invetory key (in this moment) is not engaged
	if ((BaseDrone.DronePhase & DP_QUIT_DRONE_MODE) && BaseDrone.TestStoppedKeys == true) {
		if (BaseDrone.TestSuspendQuit == false) {
			Trng.pGlobTomb4->KeysToStop = BaseDrone.OldStopMask;
			BaseDrone.TestStoppedKeys=false;

		}
	}
	if (BaseDrone.DronePhase & DP_QUIT_DRONE_MODE) {
		// verify if we completed the quit.
		// it's necessary that drone was a pickup and that we enable newly the stopped keys
		if (BaseDrone.DronePhase & DP_DRONE_PICKUP) {
			// ok, now just removing keyboard stopping
			if (BaseDrone.TestStoppedKeys) {
				// we can enable new keyboard only if in this moment the player was not hitting "Escape" otherwise it will open inventory
				if (BaseDrone.TestSuspendQuit == false ) {
					// ok, finally we completed the quit drone mode
					Trng.pGlobTomb4->KeysToStop = BaseDrone.OldStopMask;
					BaseDrone.TestStoppedKeys=false;



				}
			}
			
		}else {
			// it's not yet a pickup
			switch (pDrone->StateIdCurrent) {
			case 1:
				// 1:still on the ground but yet with open armss
				// , if drone is in StateId==1 (open and still arms) force animation to close arms
				ForceAnimationForItem(pDrone, 4, -1);
				BaseDrone.DronePhase |= DP_PREPARING_TO_PICKUP;
				break;
			case 2:
				// 2: propellers are still running
				// if there is no landing in progress, force to stop propellers
				if ((BaseDrone.DronePhase & DP_LANDING)==0) {
					ForceAnimationForItem(pDrone, 2,-1);
				}
				break;

			}

		}

	}
	if (BaseDrone.DronePhase & DP_PREPARING_TO_PICKUP) {
		// if drone is in 7 state id, it means it has closed arms
		if (StateId == 7) {
			// we completed the preparng to pickup phase
			BaseDrone.DronePhase &= ~DP_PREPARING_TO_PICKUP;
			BaseDrone.IndexPickupDrone = TransformDroneToPickUp(0);
			if (BaseDrone.TestCutScene == true) {
				// cutscene has been completed
				LogOnDebug("CUTSCENE COMPLETED");
				BaseDrone.TestCutScene=false;
				if (BaseDrone.TestUserCommand == true && BaseDrone.UserCommand == UCMD_FOLLOW_LARA) {
					BaseDrone.TestUserCommand=false;
			
				}
				DisableCam();
			}
		}

	}

	// is quit drone phase complete?
	if (BaseDrone.DronePhase & DP_QUIT_DRONE_MODE) {
		if ((BaseDrone.DronePhase & DP_DRONE_PICKUP) && GET.pLara->StateIdCurrent != 96) {
			// yeah, drone is a pickup e lara is not holding the controller.
			BaseDrone.DronePhase &= ~DP_QUIT_DRONE_MODE;
			RemoveWarningsTelemetry();


		}
	}
	// --------------------------------- MANAGE PREPARING TO #FLY ---------------------------------------------

	if (BaseDrone.DronePhase & DP_PREPARING_TO_FLY) {
		// verifiy if lara completed anim to extract controller and if now she is in StateId 96
		// where she is continuosly with hands on the controller

		if (GET.pLara->StateIdCurrent == 96 || BaseDrone.TestCutScene==true) {
			if (BaseDrone.DronePhase & DP_DRONE_PICKUP) {
				// ok, now we can convert pickup in real drone and open the arm for
				
				// replace pickup item with real drone
				TransformPickupToRealDrone();
				// update data for real drone
				CopyItemToPos(pDrone, NewPos);
				// this is also the moment to show the hint about the key to show the help
				if (BaseDrone.TestAlreadyShowedHint == false) {
					i = BaseDrone.FirstStringIndex;
					if (i != -1) {
						i += MSG_HINT_FOR_HELP;
					
						SetSizeChar();
						PerformFlipeffect(NULL, 425, i, PROF_SECONDS_FOR_HELP_HINT);
						// set as "already showed" to avoid to show it newly (at least that there was flag to show always the hint)
						if ((BaseDrone.ViewFlags & VIEW_SHOW_TIP_FOR_HELP)==0) {
							BaseDrone.TestAlreadyShowedHint =true;
						}
					}
				}
			}else {
				// real drone has been already created, now we wait when arms are open
				if (StateId == 1) {
					// now we can quit preparing fly phase
					BaseDrone.DronePhase &= ~ DP_PREPARING_TO_FLY;
					BaseDrone.DronePhase |= DP_READY;

					// initialise speed values
					BaseDrone.SpeedNow.Direction = 0x1345;
					BaseDrone.SpeedNow.Speed =0;

					BaseDrone.SpeedOld.Direction = 0x1345;
					BaseDrone.SpeedOld.Speed =0;
					EnableWarningsTelemetry();

					// if drone was on water (floating) start animation to swing drone
					if (BaseDrone.DronePhase & DP_FLOATING) {
						ForceNewAnimationAtFrame(pDrone, 7, 26);
					}

				}
			}

			
		}
	}
	



	// ---------------------------------------- MANAGE FOR MANUAL OR AUTOMATIC #TAKE OFF ---------------------------------------

	// manage start of take off
	if (BaseDrone.DronePhase & DP_READY) {
		BaseDrone.TotLastTargets =0;

		// commands to take off:  enter = automatic take off  / UP cursor -> manual take off
		if ((IsCmd(PROF_GAME_TAKE_OFF_LANDING) || BaseDrone.TestCutScene == true) && BaseDrone.TestSuspendTakeOff == false ) {

			// command for take off
			// if there is proximity sensor and lara si too close refuse to take off
			TestOk=true;
			if (BaseDrone.Flags & DRF_PROXIMITY_SENSOR) {
				if (GetDistanceXZ(GET.pLara->CordX, GET.pLara->CordZ, pDrone->CordX, pDrone->CordZ) < PROF_MIN_DISTANCE_LARA_FOR_TAKE_OFF) {
					TestOk=false;
					ShowMessage(true, MSG_OBSTACLE, PROF_FRAME_DURATE_WARNINGS, NULL);
				}

			}
			if (TestOk==true) {

				BaseDrone.DronePhase |= DP_FLYING | DP_TAKE_OFF;


				if (BaseDrone.ViewCamNow == VIEW_NO_CAM && BaseDrone.TestCutScene==false ) BaseDrone.ViewCamNow=VIEW_CAM_LARA;
			
				BaseDrone.StartPoint = OldPos;
				BaseDrone.TestSuspendTakeOff =true;
			}
		}

		if (IsCmd(PROF_GAME_UP)) {
			BaseDrone.DronePhase |= DP_FLYING;
			BaseDrone.StartPoint = OldPos;
		}

		// if it has been started flying, set animation to run propellers
		if (BaseDrone.DronePhase & DP_FLYING) {
			// remove ready
			BaseDrone.DronePhase &= ~DP_READY;
			ForceAnimationForItem(pDrone,1, -1);
			CopyItemToPos(pDrone, BaseDrone.LastPosition);
		}
	}

	// manage automatic take off
	if (BaseDrone.DronePhase & DP_TAKE_OFF) {
		// if drone has not yet reached wished height (one meter, 512 units) go on to simulate UP command
		if ((pDrone->HeightFloor- NewPos.CordY ) < PROF_TAKE_OFF_HEIGHT) {
		
			InputKeys |= PROF_GAME_UP;
		}else {
			// drone reached wished height: quit automatic take off
			BaseDrone.DronePhase &= ~DP_TAKE_OFF;

		}
	}

	

	// ------------------------------- MANAGE #CAM #VIEW --------------------------------------------------------------
	
	// QUIT CAM VIEW?
	if (GET.pLara->StateIdCurrent != 96 && BaseDrone.TestCutScene==false) {
		// remove each special view
		BaseDrone.ViewCamNow = VIEW_NO_CAM;
		RemoveMaskImage();
		RemoveWarningsTelemetry();
	}

	// REMOVE VIEW_CAM_CHASE_DRONE for no signal?
	if ((BaseDrone.ViewCamNow == VIEW_CAM_CHASE_DRONE) != 0  &&
			(BaseDrone.Flags & DRF_NOISE_EFFECT_ON_NO_SIGNAL) != 0) {
		if (BaseDrone.PercSignal == 0 && BaseDrone.TestCutScene == false) {
			BaseDrone.ViewCamNow= VIEW_CAM_LARA;
			RemoveMaskImage();

		}
	}
	if (IsPhaseForCamView(pDrone)==true || IsToKeepSpecialViewCam(pDrone)==true) {
		// drone is flying (or on the ground but ready) and lara is holding the controller
		// set current cam mode
		// get a shortcut (a pointer) to camera structure with tomb4 data 
		pCam = & Trng.pGlobTomb4->pAdr->Camera;



		// ------------ CHECK FOR SWAPPING VIEW MODE ------------------------
		if (IsCmd(PROF_GAME_SWAP_CAM) && BaseDrone.TestSuspendDrawWeapon == false) {
			BaseDrone.TestSuspendDrawWeapon=true;
			ChangeViewCam(-1);
		}
		if (BaseDrone.TestCutScene == false) {

			// whatever was cam type, we have to keep lara (about) in direction of drone
			// in the case she was facing to a very differen direction, we'll do rotate her
			Direction = GetDirection(GET.pLara->CordX, GET.pLara->CordZ, pDrone->CordX, pDrone->CordZ);

			// now Direction is the perfect direction to watch the drone, we compare this ideal facing
			// with that current of lara
			DifDirection = GetLittlestRotation(GET.pLara->OrientationH, Direction);

			// if the (absolute) difference is greater than 0x2000 (about 45 degrees) we'll rotate lara
			// to get her facing, closer to ideal direction
			if (abs(DifDirection) >= 0x2000 ) {
				// we have to turn lara
				BaseDrone.DronePhase |= DP_TURN_LARA;
				// let's discover what is better (shorter) clockwise direction


				if (DifDirection < 0) {
					IncRot = -PROF_LARA_ROTATE_SPEED;
					IndexAnim = 5;
				}else {
					IncRot = PROF_LARA_ROTATE_SPEED;
					IndexAnim = 4;
				}

				BaseDrone.IncRot = IncRot;

				// force animation to rotate 
				// at right or left (IndexAnim)
				// REMARK: I removed the change of animation (to show lara is moving her legs to turn) when
				// there is VIEW_CAM_LARA, because there were bad shacking (rapid movements) in the view

				// animate lara to turn left/right 
				if (BaseDrone.ViewCamNow != VIEW_CAM_LARA) {
					ForceAnimationForLaraFromSlot(IndexAnim, enumSLOT.DRONE_LARA);
				}
			}

			if (BaseDrone.DronePhase & DP_TURN_LARA) {
			

				// verifiy if we can quit the turn lara phase
				if (abs(DifDirection) < 0x1000) {
					// current difference is acceptable: 

					// force normal animation with lara holdign controller without turning
			
					ForceAnimationForLaraFromSlot(2, enumSLOT.DRONE_LARA);	
					BaseDrone.DronePhase &= ~DP_TURN_LARA;
				}else {
					// not yet reached ideal facing
					GET.pLara->OrientationH += BaseDrone.IncRot;

				}
			}

		}
		if (BaseDrone.ViewCamNow == VIEW_CAM_LARA) {

			// ------------------------------  CAM LARA (Lara is looking at drone) ------------------------
	
			// lara look at drone
			*pCam->pModeCameraNext =2;
			*pCam->pTargetCameraNext = pDrone;
			Trng.pGlobTomb4->pAdr->CamRotation=0;

		}


		if (BaseDrone.ViewCamNow == VIEW_CAM_DRONE) {

			// --------------------------------  DRONE CAM (the cam is inside the drone) ------------------------------

			ShowMaskImage();
			
			// check for min max limit of tilt
			if (BaseDrone.TiltCamera < PROF_CAM_MIN_TILT) BaseDrone.TiltCamera = PROF_CAM_MIN_TILT;

			if (BaseDrone.TiltCamera > PROF_CAM_MAX_TILT) BaseDrone.TiltCamera = PROF_CAM_MAX_TILT;

			Get(enumGET.CAMERA, BaseDrone.IndexCamera, 0);

			GET.pCamera->Flags = 0x80;

			// set drone as target
			*pCam->pModeCameraNow = 0;
			*pCam->pModeCameraNext =5;

			*pCam->pTargetCameraNow = NULL;
			*pCam->pTargetCameraNext = &TargetFakeItem;
			// for this kind of camera un need of a fakeitem that will be used as target


			// set index of active camera with my camera index

			*pCam->pIndexCameraNow = -1;
			*pCam->pIndexCameraNext = BaseDrone.IndexCamera;

			TotAttempts=0;
			do {
				TestRecompute=false;
				// the cam will be inside the drone, about in its head

				// try to move a bit forward to have close to the head
				GetIncrements(pDrone->OrientationH, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);

				GET.pCamera->CordX  = pDrone->CordX + IncX;
				GET.pCamera->CordY  = pDrone->CordY;
				GET.pCamera->CordZ = pDrone->CordZ + IncZ;
				GET.pCamera->Room = pDrone->Room;


				// now we have to set the positon of our fake item
				// we use same method for chase drone mode, but in this case it will be the fakeitem to be placed in according with tiltcamera
				// while the cam will be the pivot of rotation
				Cx= GET.pCamera->CordX;
				Cy= GET.pCamera->CordY;
				Cz= GET.pCamera->CordZ;
			
				
				// convert 360th degrees to word direction
				Direction = BaseDrone.TiltCamera - pDrone->OrientationV;

				// compute on (Y, Z) plane
				// for chase cam it's not so important the distance from drone and the fake target since 
				// we are interested only for the direction so we set half of cam distance and that will used 
				// to avoid that fake targer was inside a wall (this means that drone is too close to some wall)
				GetIncrements(Direction, &IncY, &IncZ, PROF_DRONE_CAM_DISTANCE / 2);
				// and use only Y to discover the Y distance respect drone
				Cy += IncY;
			
				// compute increments on (X, Z) plane but only for Z distance got by previous analyse on (Y,Z) plane
				if (abs(IncZ) > 0) {
					GetIncrements(pDrone->OrientationH, &IncX, &IncZ, abs(IncZ));
					Cx += IncX;
					Cz += IncZ;
				}
				// now we have to check that the fake target was not in the floor (undergound) or in a wall
				// note: really we'll condider that, when the drone is very close to the floor, the fake target
				//		we'll be always underground, indifferently by the tilt degrees
				//      so, if the drone is very close to the fooor we'll use alwasy a frontal view
				TestInsideFloor=false;
				TestInsideWall=false;

				if (CheckFloor(Cx, Cy, Cz, pDrone->Room)==false) {
					// if invalid floor, it means it is in a wall
					TestInsideWall=true;
				}else {
					// verify if DRONE (and not fake item) is very close to floor
					if ((pDrone->CordY + PROF_DRONE_CAM_DISTANCE/2) > pDrone->HeightFloor  && TestOnWater==false) {
						TestInsideFloor=true;
					}else {
						// it's not too close to floor, but we have to verify if there is a wall in front drone
						if (FLOOR.FloorHeight < pDrone->CordY) TestInsideWall=true;
					}

				}
				if (TestInsideWall==true) {
					// look down (and not in front)
					BaseDrone.TiltCamera = PROF_CAM_MAX_TILT;
					TestRecompute=true;
				}
				if (TestInsideFloor==true) {
					// lood in front (and not down)
 					BaseDrone.TiltCamera = PROF_CAM_MIN_TILT;
					TestRecompute=true;
				}

				if (TestInsideFloor && TestInsideWall) {
					// fake target is underground and inside a wall
					// in this case we can only change the view cam mode (that it will be elaborated in next side of this code)
					BaseDrone.ViewCamNow = VIEW_CAM_CHASE_DRONE;
					RemoveMaskImage();
					// wiht an intermediate angle to have the cam back and higher than drone
					BaseDrone.TiltCamera = (PROF_CAM_MAX_TILT + PROF_CAM_MIN_TILT) / 2;
					// and avoid to recompute
					TestRecompute=false;
				}
				// keep count of attempts to avoid endless loop in some particular situation
				TotAttempts++;
			}while(TestRecompute==true && TotAttempts < 2);
			// now we set the position of our fake item
			// Anyway, since the tomb raider camera management will use the collision box of the item,
			// we have to fill this fake structure also with FirstAnim and FirstFrame values to locate a reasonable collisione box
			// we could use the same drone's data for this target
			TargetFakeItem.AnimationNow = pDrone->AnimationNow;
			TargetFakeItem.FrameNow = pDrone->FrameNow;
			TargetFakeItem.CordX = Cx;
			TargetFakeItem.CordY = Cy;
			TargetFakeItem.CordZ = Cz;
			TargetFakeItem.Room= GET.pCamera->Room;
			if (!(BaseDrone.TestUserCommand == true && BaseDrone.UserCommand == UCMD_ROLLING)) {
				Trng.pGlobTomb4->pAdr->CamRotation = pDrone->OrientationT;
			}
		}

		if (BaseDrone.ViewCamNow == VIEW_CAM_CHASE_DRONE) {

			// -------------------------------- CHASE_DRONE CAM (The cam chases the drone) ---------------------


			if (BaseDrone.TiltCamera > PROF_CAM_MAX_TILT) BaseDrone.TiltCamera = PROF_CAM_MAX_TILT;
			// I had to set as minimum limit 30 (instead by 0) because with lower degree than 30 there are changes of cam facing

			if (BaseDrone.TiltCamera < PROF_CAM_MIN_TILT) BaseDrone.TiltCamera = PROF_CAM_MIN_TILT;

			// place the cam over or behind the drone and set the drone as target
			// get structure of my camera
			Get(enumGET.CAMERA, BaseDrone.IndexCamera, 0);

			GET.pCamera->Flags = 0x80;

			// set drone as target
			*pCam->pModeCameraNow = 0; 
			*pCam->pModeCameraNext =5;

			*pCam->pTargetCameraNow = NULL; 
			*pCam->pTargetCameraNext = pDrone;
			// set index of active camera with my camera index

			*pCam->pIndexCameraNow = -1 ; 
			*pCam->pIndexCameraNext = BaseDrone.IndexCamera;

			// set positon of camera
			// the compute of cam's position depends by distance from drone PROF_CHASE_CAM_DISTANCE
			// and current cam's tilt (vertical degrees) where 0 means the cam is behind of drone at same height of drone respect the floor (like a tail)
			TestRecompute=false;
			TotAttempts=0;
			do {

				Cx= pDrone->CordX;
				Cy= pDrone->CordY;
				Cz= pDrone->CordZ;

				Direction = BaseDrone.TiltCamera;

				// and invert the direction (by 180 degrees) because the cam should be backward and not forward respect drone
				Direction += 0x8000;

				// compute on (Y, Z) plane


				GetIncrements(Direction, &IncY, &IncZ, PROF_CHASE_CAM_DISTANCE);
				Cy += IncY;
				// compute increments on (X, Z) plane but only for Z distance got by previous analyse on (Y,Z) plane
				if (abs(IncZ) > 0) {

					GetIncrements(pDrone->OrientationH + 0x7fff, &IncX, &IncZ, abs(IncZ));

					// and now we change position on (x,z) plane
					Cx += IncX;
					Cz += IncZ;			
				}

				// this should be the new position, but, in the case there was a collision con ceiling, move down the cam with 90 degrees
				if (CheckFloor(Cx, Cy, Cz, pDrone->Room)==false) {
					// if the floor is invalid, it meanns that, the camera, is already in full wall. Bad matter
					// in this case move the cam over the drone, to avoid the wall
					BaseDrone.TiltCamera = PROF_CAM_MAX_TILT;
					LogOnDebug("ChaseCam: invalid floor, set max tilt");
					TestRecompute=true;
				}else {
					// the floor is valid: verify if the cam is higher than ceiling
					if (Cy < FLOOR.CeilingHeight ) {
						// in this case, move back the cam, to look in front
						BaseDrone.TiltCamera=PROF_CAM_MIN_TILT;
						TestRecompute=true;
						LogOnDebug("ChaseCam: touch ceiling, set min tilt");
					}
					
				
				}
				// if it has been enabled TestRecompute, it wll compute new cam position
				// anyway we could happen and endless loop
				// so we verify that this is not second attempt
				TotAttempts++;

			}while (TestRecompute==true && TotAttempts < 2);
			

			GET.pCamera->CordX = Cx;
			GET.pCamera->CordY = Cy;
			GET.pCamera->CordZ = Cz;

			GET.pCamera->Room = pDrone->Room;

			if (BaseDrone.TestUserCommand == true && BaseDrone.UserCommand == UCMD_ROLLING) {
				pDrone->OrientationT = Trng.pGlobTomb4->pAdr->CamRotation;
			} else {	
				Trng.pGlobTomb4->pAdr->CamRotation=0;
			}
			
		}

	}else {
		// disable cam
		DisableCam();

		}



	// ------------------------------- MANAGEMENT PRESERVING #HEIGHT ---------------------
	

	// --- DISABLE RECOVER HEIGHT?
	if (BaseDrone.DronePhase & DP_RECOVER_OLD_HEIGHT) {

		// there is recovry height in progress, anywy disable if there is some automatic phase
		if (IsAutomaticPhase()==true || TestNoDirections == false || (BaseDrone.DronePhase & DP_FLYING)==0) {
			// disable recover height
			BaseDrone.DronePhase &= ~DP_RECOVER_OLD_HEIGHT;

		}
	}



	// ----- ENABLE RECOVERY HEIGHT?
	if ((BaseDrone.DronePhase  & DP_RECOVER_OLD_HEIGHT)==0) {
		if (IsAutomaticPhase()== false && TestNoDirections == true && (BaseDrone.DronePhase & DP_FLYING)!=0) {

			// verifiy if we need come in recovery heigth phase
			if (NewPos.CordY > BaseDrone.Old_Y_ToKeep && Abs(BaseDrone.Old_Y_ToKeep - NewPos.CordY ) > PROF_YGAP_TO_KEEP_HEIGHT) {
				BaseDrone.DronePhase |= DP_RECOVER_OLD_HEIGHT;


			}
		}
	}

	// --- PERFORM RECOVERY HEIGHT?
	if (BaseDrone.DronePhase  & DP_RECOVER_OLD_HEIGHT) {

		// let's increase speed (oldvspeed) gradually, until to reach max speed 
		BaseDrone.SpeedVertical  --;
		if (BaseDrone.SpeedVertical  < -(PROF_GRAVITY_SPEED*2)) {
			BaseDrone.SpeedVertical  = -(PROF_GRAVITY_SPEED*2);
		}
		NewPos.CordY  += BaseDrone.SpeedVertical ;

		// let's see if we reached right heigth
		if (NewPos.CordY <= BaseDrone.Old_Y_ToKeep) {
			// ok: quit the recover speed phase

			BaseDrone.DronePhase &= ~DP_RECOVER_OLD_HEIGHT;

		}
	}

	// ------------------------------- MANAGE GAME COMMAND TO DRIVE DRONE ------------------------------------------
	CollType= COLL_NO_COLLISION;
	// manage commands in flying mode
	if ((BaseDrone.DronePhase & DP_FLYING) && (GET.pLara->StateIdCurrent == 96 || BaseDrone.TestCutScene==true)) {
		// perform change of coordintess on NewPos.. variables,

		// ------ COMMAND UP/DOWN
		if (IsCmd(PROF_GAME_UP)) {
			NewPos.CordY  -= PROF_VSPEED;
		}

		// handle all other movement game commands
		// command down
		if (IsCmd(PROF_GAME_DOWN)) {
			// reduce the old heigth to preserve
			NewPos.CordY  += PROF_VSPEED;

			// check if we touched the floor

			if ((NewPos.CordY+GapYOverFloor)  >= pDrone->HeightFloor ) {
				NewPos.CordY  = pDrone->HeightFloor - GapYOverFloor;

				BaseDrone.DronePhase |= DP_LANDING;
			}
		}
		
		// -------------------------------- MANAGE DIRECTIONAL COMMANDS ---------------------------------

		// to avoid some issue (about over speed in diagonal movements) the diagonal directions will be
		// managed earlier (when it is present) and  as a specific direction.
		// Mote, when there is a diangola direction, the hortogonal directions
		// will be ignored, to avoid an overload, of course

		TestDiagonals=false;

		if (IsCmd(PROF_GAME_FORWARD+PROF_GAME_RIGHT)) {
			TestDiagonals=true;
			Direction = pDrone->OrientationH + 0x2000;
			UpdateSpeed(Direction);
			GetIncrements(Direction, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
			NewPos.CordX  += IncX;
			NewPos.CordZ  += IncZ;

		}

		if (IsCmd(PROF_GAME_FORWARD+PROF_GAME_LEFT)) {
			TestDiagonals=true;
			Direction = pDrone->OrientationH - 0x2000;
			UpdateSpeed(Direction);
			GetIncrements(Direction, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
			NewPos.CordX  += IncX;
			NewPos.CordZ  += IncZ;

		}

		if (IsCmd(PROF_GAME_BACKWARD+PROF_GAME_LEFT)) {
			TestDiagonals=true;
			Direction = pDrone->OrientationH + 0xA000;
			UpdateSpeed(Direction);
			GetIncrements(Direction, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
			NewPos.CordX  += IncX;
			NewPos.CordZ  += IncZ;

		}
		if (IsCmd(PROF_GAME_BACKWARD+PROF_GAME_RIGHT)) {
			TestDiagonals=true;
			Direction = pDrone->OrientationH + 0x6000;
			UpdateSpeed(Direction);
			GetIncrements(Direction, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
			NewPos.CordX  += IncX;
			NewPos.CordZ  += IncZ;

		}

		// check hortogonal direction only if diagonal directions were missing
		if (TestDiagonals==false) {

			if (IsCmd(PROF_GAME_FORWARD)) {
				UpdateSpeed(pDrone->OrientationH);

				GetIncrements(pDrone->OrientationH, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
				NewPos.CordX  += IncX;
				NewPos.CordZ  += IncZ;
			}

			if (IsCmd(PROF_GAME_BACKWARD)) {
				// change orientation, to face backward of drone
				UpdateSpeed(pDrone->OrientationH +0x7fff);

				GetIncrements(pDrone->OrientationH + 0x7fff, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
				NewPos.CordX  += IncX;
				NewPos.CordZ  += IncZ;
			}

			if (IsCmd(PROF_GAME_LEFT)) {
				//Change orintation, to face left side of drone
				UpdateSpeed(pDrone->OrientationH -0x4000);
				GetIncrements(pDrone->OrientationH -0x4000, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
				NewPos.CordX  += IncX;
				NewPos.CordZ  += IncZ;
			}

			if (IsCmd(PROF_GAME_RIGHT)) {
				// change orientation, to face right side of drone
				UpdateSpeed(pDrone->OrientationH+0x4000);

				GetIncrements(pDrone->OrientationH +0x4000, &IncX, &IncZ, BaseDrone.SpeedNow.Speed);
				NewPos.CordX  += IncX;
				NewPos.CordZ  += IncZ;
			}
		

		}
		// if there has been no direction command, move SpeedNow to OldSpeed and then clear speednow
		if (IsCmd(PROF_GAME_FORWARD)==0 && IsCmd(PROF_GAME_BACKWARD) == 0 &&
			IsCmd(PROF_GAME_LEFT)==0 && IsCmd(PROF_GAME_RIGHT)==0) {
				// copiarla solo se e' maggior edella old attuale
				if (BaseDrone.SpeedNow.Speed > BaseDrone.SpeedOld.Speed) {
					BaseDrone.SpeedOld = BaseDrone.SpeedNow;
				}
				BaseDrone.SpeedNow.Speed=0;
		}

		Coll = NewPos;

		// -------------------------- MANAGE #INTERTIAL SPEED -------------------------------------
		// decrease by 1 old speed
		BaseDrone.SpeedOld.Speed--;
		if (BaseDrone.SpeedOld.Speed < 0) BaseDrone.SpeedOld.Speed=0;

		if (BaseDrone.SpeedOld.Speed > 0) {
			// move furtherly drone in previous direction
			GetIncrements(BaseDrone.SpeedOld.Direction, &OldIncX, &OldIncZ, BaseDrone.SpeedOld.Speed);
			NewPos.CordX += OldIncX;
			NewPos.CordZ += OldIncZ;

			Coll = NewPos;

			// if there were no directional command (Coll position should be not updated)
			// set the Coll position (with half size of drone) using the intertial speed
			if (IsCmd(PROF_GAME_FORWARD) == 0 && IsCmd(PROF_GAME_FORWARD)==0 &&
				IsCmd(PROF_GAME_LEFT) ==0 && IsCmd(PROF_GAME_RIGHT)==0) {

				GetIncrements(BaseDrone.SpeedOld.Direction, &OldIncX, &OldIncZ, PROF_HALF_SIZE_DRONE);
				Coll.CordX += OldIncX;
				Coll.CordZ += OldIncZ;

			}

		}


		// -------------------------- CHECK FOR #COLLISIONS WITH ROOM GEOMETRY -------------------------------

		// now, (further complication) to verify if drone is touching walls or ceiling, we have to add to its
		// (new) coordinates, a displacemnte with size of the the half size of drone (collision box) object
		// in the same current direction of last directional command.
		// well since the collision box of (flying) drone has these sizes: SizeX = 263 ; SizeY =  57 ; SizeZ = 237
		// while the position (NewPosX ; NewPosY ; NewPosZ) is only the center of the drone, we'll have to
		// add the half of size, in the rigth direction. We'll save this new point in CollX, Colly and CollZ variables
		// note: as further horizontal distance, we'll choose a approssimate value of 120 units that is (about) the half of SizeX or SizeZ
		//       anyway youn can modify this value saved as profile constant: PROF_HALF_SIZE_DRONE



		if (IsCmd(PROF_GAME_FORWARD)) {
			GetIncrements(pDrone->OrientationH, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);
			Coll.CordX  += IncX;
			Coll.CordZ  += IncZ;
		}

		if (IsCmd(PROF_GAME_BACKWARD)) {
			// change orientation, to face backward of drone
			GetIncrements(pDrone->OrientationH + 0x7fff, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);
			Coll.CordX  += IncX;
			Coll.CordZ  += IncZ;
		}

		if (IsCmd(PROF_GAME_LEFT)) {
			//Change orintation, to face left side of drone
			GetIncrements(pDrone->OrientationH -0x4000, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);
			Coll.CordX  += IncX;
			Coll.CordZ  += IncZ;
		}

		if (IsCmd(PROF_GAME_RIGHT)) {
			// change orientation, to face right side of drone
			GetIncrements(pDrone->OrientationH +0x4000, &IncX, &IncZ, PROF_HALF_SIZE_DRONE);
			Coll.CordX  += IncX;
			Coll.CordZ  += IncZ;
		}

		// note: about up/down movement we'll check only for upwardd movementes, since the downward movement
		//		has already had a check for landing management
		if (IsDroneMovingUp(NewPos.CordY)==true ) {
			// in this case there is no problem about direction of movement (we don't need of GetIncrements()
			// and we'll use full size of the drone object, since the origin is at its bottom and not in the middle.
			Coll.CordY  -= PROF_FULL_HSIZE_DRONE;
		}
		// salva current coordinates of drone
		CopyItemToPos(pDrone, SavePos);

		// set in pDrone the new coorditates (after attempted movement)
		// we need to copy futurer coordinate in real drone because we need of check collision with items

		CopyPosToItem(NewPos, pDrone);
		// if the drone is moving in automatic way (and there are no real directional commands) simulated the keys 
		FakeKeys= InputKeys;
		if (TestNoDirections==true ) {
			// simulate commands in according with different position of drone, between Old and New
			if (NewPos.CordY > BaseDrone.LastPosition.CordY ) FakeKeys |= PROF_GAME_DOWN;

			if (NewPos.CordY < BaseDrone.LastPosition.CordY ) FakeKeys |= PROF_GAME_UP;
			// for direction it's easier, because all automatic phases will move always forward the drone
			// now just only discovering if horizontal position changed
			if (OldPos.CordX != NewPos.CordX || OldPos.CordZ != NewPos.CordZ) FakeKeys |= PROF_GAME_FORWARD;
		}

		CollType= CheckCollisionForDrone(pDrone, true, &Coll, FakeKeys);
		// restore oroginal position of drone
		CopyPosToItem(SavePos, pDrone);

		if (CollType != COLL_NO_COLLISION) {

			// if collision is with floor and we are landing, ignore it
			if ((CollType & COLL_FLOOR) != 0 && (BaseDrone.DronePhase & DP_LANDING) != 0) {			
				CollType &= ~COLL_FLOOR;
			}

		}
		if (CollType != COLL_NO_COLLISION) {
			// there has been a collision (or a stop to avoid impact)
			BaseDrone.TestCollision =true;
		}
		if (CollType & COLL_CEILING) {
			BaseDrone.Old_Y_ToKeep = FLOOR.CeilingHeight + 128;

			// remove furthe raising or take_off modes
			BaseDrone.DronePhase &=  ~(DP_TAKE_OFF | DP_REACH_Y_TARGET);

		}

		
	}




	// ----------------------- ANALYSIS OF FURTHER COLLISIONS --------------------------------------


	TestUpdateMoving = true;
	TestSamePosition = false;



	// ------  IGNORE COLLISION?
	if (BaseDrone.TestCollision == true) {
		LogOnDebug("Detected COLLISION  (Drone: x=%d y=%d z=%d", pDrone->CordX, pDrone->CordY, pDrone->CordZ);
		if (IsToIgnoreCollision(&OldPos, &NewPos, CollType)==true) {
			LogOnDebug("Ignore Collision");
			CollType=COLL_NO_COLLISION;
			BaseDrone.TestCollision=false;
		}


	}
	// verify if there has been really a movement of drone 
	// (but, no check if there was rebounding in progress)
	if ((BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT)==0) {
		// if new coordinates  are same of olds, there is nothing to update
		if (BaseDrone.TestUserChangePos == false && OldPos.CordX == NewPos.CordX && OldPos.CordY == NewPos.CordY && OldPos.CordZ == NewPos.CordZ ) {
			TestSamePosition = true;
			TestUpdateMoving=false;

		}
	}
	FakeKeys= InputKeys;
	if (IsSomeTarget()==true  ) {
		// simulate commands in according with different position of drone, between Old and New
		if (NewPos.CordY > BaseDrone.LastPosition.CordY ) FakeKeys |= PROF_GAME_DOWN;

		if (NewPos.CordY < BaseDrone.LastPosition.CordY ) FakeKeys |= PROF_GAME_UP;
		// for direction it's easier, because all automatic phases will move always forward the drone
		// now just only discovering if horizontal position changed
		if (OldPos.CordX != NewPos.CordX || OldPos.CordZ != NewPos.CordZ) FakeKeys |= PROF_GAME_FORWARD;
	}
	// update coordinate drone if there is no collisione
	// now we have all infos about collisions, with room geometry or with items (static or moveables)

	if (TestSamePosition==false) {
		// drone attempted to move...
		// verifiy if there were collision and how to manage them


		if (CollType != COLL_NO_COLLISION) {
			if (BaseDrone.Flags & DRF_PROXIMITY_SENSOR) {
				// no movement
				TestUpdateMoving=false;
				// reset also speedo old and new
				BaseDrone.SpeedNow.Speed=0;
				BaseDrone.SpeedOld.Speed =0;
				ShowMessage(false, MSG_OBSTACLE, PROF_SHORT_TIME_WARNING_MSG, NULL);

			}
		}
	}


	// -------------------------- #REBOUND MANAGE DP_REBOUND_ON_IMPACT -----------------------------------

	// FAILED REBOUDING?
	if (BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT) {
		if (BaseDrone.TestCollision == true) {
			LogOnDebug("FAILED REBOUNDING");
			// also in rebouding we find another collsion
			ManageFailure(pDrone);
			BaseDrone.DronePhase &= ~DP_REBOUND_ON_IMPACT;
		}

	}



	// START REBOUNDING ?
	if ((BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT)==0) {
		// if there is a collision but it's missing the DRF_PROXIMITY_SENSOR flag, start a rebound
		if (BaseDrone.TestCollision == true && (BaseDrone.Flags & DRF_PROXIMITY_SENSOR)==0) {
			// DON'T perform rebound if drone is going to land or quit drone mode
			if ((BaseDrone.DronePhase & (DP_QUIT_DRONE_MODE | DP_LANDING | DP_PREPARING_TO_PICKUP | DP_EMERGENCY_LANDING | 
						DP_CRASH_IN_PROGRESS | DP_FAILURE | DP_FAILED_TAKE_OFF) )==0) {
				LogOnDebug("START REBOUNDING");
				SetReboundDirection(pDrone, &NewPos, CollType);
				BaseDrone.DronePhase |= DP_REBOUND_ON_IMPACT;

				// remove intertial speed
				BaseDrone.SpeedNow.Speed =0;
				BaseDrone.SpeedVertical =0;
				BaseDrone.SpeedOld.Speed =0;
				// start anim 3 (drone is troubling)
				ForceNewAnimationAtFrame(pDrone, 3, 0);
				TestUpdateMoving=true;
			}
			
		}
	}
	// MANAGE REBOUND IN PROGRESS
	if (BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT) {

		// COMPLETED REBOUND?
		if (BaseDrone.Rebound_H_Speed ==0 && BaseDrone.Rebound_V_Speed == 0 && BaseDrone.Rebound_V_LoseHeight==0) {
			// we can quit DP_REBOUND_ON_IMPACT phase
			BaseDrone.DronePhase &= ~DP_REBOUND_ON_IMPACT;

		}else {
			// chekc increments for reboudn direction
			if (BaseDrone.Rebound_H_Speed > 0) {
				GetIncrements(BaseDrone.Rebound_H_Direction , &IncX, &IncZ, BaseDrone.Rebound_H_Speed);
				NewPos.CordX += IncX;
				NewPos.CordZ += IncZ;
			}

			// change also y coordinate
			NewPos.CordY += BaseDrone.Rebound_V_Speed;

			// reduce speed
			BaseDrone.Rebound_H_Speed -=4;
			if (BaseDrone.Rebound_H_Speed  < 0) BaseDrone.Rebound_H_Speed=0;

			if (BaseDrone.Rebound_V_Speed != 0) {
				if (BaseDrone.Rebound_V_Speed > 0) {
					BaseDrone.Rebound_V_Speed -=2;
					if (BaseDrone.Rebound_V_Speed < 0) BaseDrone.Rebound_V_Speed=0;
				}
				if (BaseDrone.Rebound_V_Speed < 0) {
					BaseDrone.Rebound_V_Speed +=2;
					if (BaseDrone.Rebound_V_Speed > 0) BaseDrone.Rebound_V_Speed=0;
				}
			}

			// loosing of height
			NewPos.CordY += BaseDrone.Rebound_V_LoseHeight;
			BaseDrone.Rebound_V_LoseHeight--;
			if (BaseDrone.Rebound_V_LoseHeight < 0) BaseDrone.Rebound_V_LoseHeight=0;
			
		}
	}

	// ------------------------ UPDATE DRONE'S POSITION ---------------------------------------------
	if (TestUpdateMoving==true) {
		// save last direction
		BaseDrone.LastDirection = GetDirection(OldPos.CordX , OldPos.CordZ , NewPos.CordX, NewPos.CordZ);
		// omologare cambimento

		CopyPosToItem(NewPos, pDrone);
		UpdateItemRoom(BaseDrone.IndexRealDrone);


	}
	// detect heavy over triggers
	if (BaseDrone.DronePhase & DP_FLYING) {
		if (BaseDrone.Flags & DRF_ENGAGE_OVER_HEAVY) {
			// engage heavy triggers

			EngageTriggersOnSector(pDrone->CordX, pDrone->CordY, pDrone->CordZ, pDrone->Room, true);
			
		}
	}


	// ---------------------------------------- #SOUND #SFX
	if (BaseDrone.DronePhase & DP_FLYING) {

		// motor sound
		// stop to play if there is a rebound in progress
		if ((BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT)==0) {
			// use variable pitch in according with speed
			Pitch = 0x10000; // standard pitch

			if (BaseDrone.Flags & DRF_DYNAMIC_ENGINE_SOUND) {
				// scoprire velocita' orizzontale
				HSpeed = GetDistanceXZ(pDrone->CordX, pDrone->CordZ, BaseDrone.LastPosition.CordX, BaseDrone.LastPosition.CordZ);


				// increase pitch for speed
				if (HSpeed  != 0) {
					Pitch += (BaseDrone.SpeedNow.Speed  << 10);
				}else {

					if (Pitch == 0x10000 && (BaseDrone.DronePhase & DP_CRASH_IN_PROGRESS)) {
						Pitch -= 0x8000;
					}


					// no horizontal speed: change the pitch for vertical movement
					if (IsCmd(PROF_GAME_UP) || (BaseDrone.DronePhase & DP_TAKE_OFF)) {
						Pitch += 0x6000;
					}
					if (IsCmd(PROF_GAME_DOWN)|| (BaseDrone.DronePhase & DP_LANDING)) {
						Pitch -= 0x4000;
					}
				}
			
				LogOnDebug("Pitch=0x%X  HSpeed=%d", Pitch, HSpeed);
			}

			// flag 0x004 enable variable pitch, that has to be passed shifted of 8 bits at left (as multiplying by 256)
			SoundEffect(PROF_SFX_MOTOR, &pDrone->CordX, 0x0004 + (Pitch << 8));
		}
		
	}else {
		// if drone is NOT flying stop the further previous playback of propeller sound : PROF_SFX_MOTOR
		// perform only when drone is stopping propellers
		if (pDrone->StateIdCurrent == 3) {
			// note: the StopEffect() function doesn't accept absolute sfx index (that you see in "SoundSfx indices list" of ng_center
			// but the relative (of exisinting single samples fx in currnet tr4 level) index
			i = Convert(enumCONV.SfxSoundIndexFromAbsToSampleIndex,PROF_SFX_MOTOR,0,NULL);
			// note: really it looks that it didn't work. :-/
			StopEffect(i);
		}
	}

	if (BaseDrone.DronePhase & DP_REBOUND_ON_IMPACT) {
		// perform sound for hit (if it wasn't already playding)
		if (BaseDrone.Rebound_H_Speed >= PROF_HSPEED) {
			if (IsSfxPlaying(PROF_SFX_BIG_HIT) == false) {
				SoundEffect(PROF_SFX_BIG_HIT, &pDrone->CordX, 0);
			}
		}else {
			// sound for low speed
			if (IsSfxPlaying(PROF_SFX_LITTLE_HIT) == false) {
				SoundEffect(PROF_SFX_LITTLE_HIT, &pDrone->CordX, 0);
			}

		}


	}


	// ----------------------- MANAGE #TILT OF DRONE ---------------------------------------------------
	// we have to remeber kind of facing we are going to change, because then we'll have to restore normal facing for not affected directions
	TestModVFacing=false;
	TestModTFacing=false;

	// save real received commands
	BackUpKeys = InputKeys;

	// use FakeKeys (keys simulated)

	
	// if drone is moving for CHASE_TARGET (automatic horizontal movement for landing, recover position or return to home)
	// convert its direction to fake directional game command, to have right tilt in according with direction
	if (IsSomeTarget()==true) {
		InputKeys= FakeKeys;
		// verify it it moved in last cycle
		if (OldPos.CordX != NewPos.CordX || OldPos.CordZ != NewPos.CordZ) {
			// it moved!

			TestUpdateMoving=true;
		}

	}

	if (BaseDrone.DronePhase & DP_FLYING) {

		if (TestUpdateMoving==true) {
			// increase the tilt, following currnet direction, until reach max tilt

			// verify the direction to to change
			if (IsCmd(PROF_GAME_BACKWARD)) {
				// increase the V facing
				TestModVFacing =true;

				// if the vertical facing was that for opposite direction (earlier there has been forward command) force to start from 0
				if (pDrone->OrientationV < 0) pDrone->OrientationV =0;

				pDrone->OrientationV += PROF_DRONE_TILT_SPEED;
				// if we passed over limit, set the limit
				if (pDrone->OrientationV > PROF_DRONE_MAX_TILT) pDrone->OrientationV = PROF_DRONE_MAX_TILT;
			}	

			if (IsCmd(PROF_GAME_FORWARD)) {
				TestModVFacing=true;
				if (pDrone->OrientationV > 0) pDrone->OrientationV=0;

				pDrone->OrientationV -= PROF_DRONE_TILT_SPEED;
				if (pDrone->OrientationV < -PROF_DRONE_MAX_TILT) pDrone->OrientationV = -PROF_DRONE_MAX_TILT;
			}

			if (IsCmd(PROF_GAME_LEFT)) {
				TestModTFacing=true;
				if (pDrone->OrientationT > 0) pDrone->OrientationT = 0;

				pDrone->OrientationT -= PROF_DRONE_TILT_SPEED;
				if (pDrone->OrientationT < -PROF_DRONE_MAX_TILT) pDrone->OrientationT = -PROF_DRONE_MAX_TILT;
			}

			if (IsCmd(PROF_GAME_RIGHT)) {
				TestModTFacing=true;
				if (pDrone->OrientationT < 0) pDrone->OrientationT =0;

				pDrone->OrientationT += PROF_DRONE_TILT_SPEED;
				if (pDrone->OrientationT > PROF_DRONE_MAX_TILT) pDrone->OrientationT = PROF_DRONE_MAX_TILT;
			}

		}
	}
	// on not affected axes, restore standard value for tilt	
	if (TestModVFacing==false) {
		// restore (gradually) the normal vertical facing
		// discover sign and value for increment
		DiffV = 0 - pDrone->OrientationV;
		if (DiffV != 0) {
			if (DiffV > 0) {
				IncV = PROF_DRONE_TILT_SPEED;
				if (IncV > DiffV)  IncV = DiffV;
			}else {
				IncV = -PROF_DRONE_TILT_SPEED;
				if (IncV < DiffV) IncV = DiffV;
			}

			pDrone->OrientationV += IncV;
		}
	}

	if (TestModTFacing==false) {
		// restore gradually noral Turning facing
		DiffT = 0 - pDrone->OrientationT;
		if (DiffT != 0) {
			if (DiffT > 0) {
				IncT = PROF_DRONE_TILT_SPEED;
				if (IncT > DiffT)  IncT = DiffT;
			}else {
				IncT = -PROF_DRONE_TILT_SPEED;
				if (IncT < DiffT) IncT = DiffT;
			}

			pDrone->OrientationT += IncT;
		}
	}
	// restore real received command (that could have been changed by CHASE_DRONE code to get right drone tilt)
	InputKeys = BackUpKeys;

	// ---------------------- SAVE HEIGHT TO PRESERVE ----------------------------------

	// save the current height only when there has been an UP or DOWN command
	if (IsCmd(PROF_GAME_UP) || IsCmd(PROF_GAME_DOWN) || IsAutomaticPhase()==true) {
		if (BaseDrone.DronePhase & DP_FLYING) {
			BaseDrone.Old_Y_ToKeep = NewPos.CordY;

		}
	}
	// ------------------------------- #TELEMETRY MANAGEMENT ------------------------------

	// DISABLE TELEMETRY?  
	if (IsCamForTelemetry()==false) {
		RemoveTelemetry();
	}

	// it there has been a change in view cam type, it's necessary remove (temporarily) old telemetry to get that new string, with their different
	// positional formatters, were updated
	if (BaseDrone.ViewCamNow != BaseDrone.ViewCamOld) RemoveTelemetry();

	// UPDATE TELEMETRY?  if drone lara is holdign controller, and the drone is ready or is flying, update telemetry
	if ((LaraStateId == 96 || BaseDrone.TestCutScene ==true)  && (BaseDrone.DronePhase & (DP_FLYING | DP_READY)) !=0) {
		// update
		UpdateTelemetry(pDrone);
	}
	// ------------------------------- MANAGE #BATTERY AND #SIGNAL (AND LOST DRONE)  -------------------------------------------------------

	// ---  analyse signal
	if (BaseDrone.PercSignal == 0) {
		// drone has been lost.

		BaseDrone.DronePhase |= (DP_LOST_DRONE | DP_NO_SIGNAL);

	}else {
		// it's greateer than "lost drone" level, but if it's less than PROF_WARN_LEVEL_LOW_SIGNAL, give warning for low signal, too
		// removing further no signal
		BaseDrone.DronePhase &= ~DP_NO_SIGNAL;
	
	
		// remove also lost drone at least that the problem was not for no_battery
		if ((BaseDrone.DronePhase & DP_NO_BATTERY)==0) {
			// there wasn't no battery, so we can remove further LOST drone
			BaseDrone.DronePhase &= ~DP_LOST_DRONE;

		}
		// if drone is flying and signal strenght is good, save current drone position for further recovery last safe position
		if (BaseDrone.PercSignal > PROF_WARN_LEVEL_LOW_SIGNAL && (BaseDrone.DronePhase & DP_FLYING)!=0) {
			// signal is better than warning level: save current drone's positon as Last Safe Positon
			// veriify if to save position or less.
			// try to do not save position if drone is on a sector where it's going to execute a flipeffect to reduce the signal
			if (IsReductionFlip()==false  && 
					GetDistanceXZ(pDrone->CordX, pDrone->CordZ, BaseDrone.LastSafePoint.CordX, BaseDrone.LastSafePoint.CordZ) > 256) {
				// LogOnDebug("--------------  SAVE Last Safe Position: %s", LogCords(pDrone->CordX, pDrone->CordZ));
				CopyItemToPos(pDrone, BaseDrone.LastSafePoint);

			}
		}
	}

	if (BaseDrone.Flags & DRF_NOISE_EFFECT_ON_NO_SIGNAL) {
		// START #NOISES ON SCREEN?
		if ((BaseDrone.DronePhase & DP_LOST_DRONE) != 0  && (BaseDrone.DronePhase & DP_NOISES_ON_SCREEN)==0 && BaseDrone.ViewCamNow == VIEW_CAM_DRONE) {
			// lost drone
			if (BaseDrone.SpriteCmdId != -1) {
				BaseDrone.DronePhase |= DP_NOISES_ON_SCREEN;
				// start sprite animation
				PerformFlipeffect(NULL, 357, BaseDrone.SpriteCmdId, 0);
				// start sprite with no signal message
				PerformFlipeffect(NULL, 357, BaseDrone.SpriteCmdId +1, 0);
			}
		}

		// END NOISES ON SCREEN? 
		if (BaseDrone.DronePhase & DP_NOISES_ON_SCREEN) {
			if ((BaseDrone.PercSignal > 0 && (BaseDrone.DronePhase & DP_NO_BATTERY)==0) || BaseDrone.ViewCamNow != VIEW_CAM_DRONE) {
				BaseDrone.DronePhase &= ~DP_NOISES_ON_SCREEN;

				PerformFlipeffect(NULL, 358, BaseDrone.SpriteCmdId, 0);
				PerformFlipeffect(NULL, 358, BaseDrone.SpriteCmdId+1, 0);

			}

		}
	}
	if ((BaseDrone.DronePhase & DP_FLYING)!= 0 && (BaseDrone.Flags & DRF_USE_BATTERIES)!=0) {
		// reduce battery level (only while it's flying
		BaseDrone.BatteryLevel--;
		if (BaseDrone.BatteryLevel < 0) BaseDrone.BatteryLevel=0;
	}
	// if the drone had a failure but now it's on the ground: remove failure
	if ((BaseDrone.DronePhase & DP_FLYING)==0) {
		BaseDrone.DronePhase &= ~DP_FAILURE;
	}

	// -------------- START #EMERGENCY LANDING?
	if ((BaseDrone.DronePhase & DP_FLYING)!=0 && (BaseDrone.DronePhase & DP_FAILURE) ==0 && TestNoDirections==true &&
			(BaseDrone.DronePhase & DP_TAKE_OFF)==0) {

		// check for lost drone for low signal

		if ((BaseDrone.DronePhase & DP_LOST_DRONE)!=0 && (BaseDrone.DronePhase & DP_NO_BATTERY)==0) {

			// it's not battery, so it will be for no signal
			// if there is safe recovery start this phase
			// but, if there was landing in progress, don't try to recover safe position
			if ((BaseDrone.DronePhase & DP_LANDING)==0 &&  (BaseDrone.Flags & DRF_SAFE_RECOVERY)!=0) {
				// start recovering position if drone is flying
				BaseDrone.DronePhase |= DP_RECOVERING_SAFE_POSITION;
					
			}else {
				// no safe recovery, then perform an emergency landing

				BaseDrone.DronePhase |= (DP_EMERGENCY_LANDING | DP_LANDING);
				if(BaseDrone.UserCommand  == UCMD_FOLLOW_LARA) {
					BaseDrone.TestUserCommand = false;
					BaseDrone.DronePhase &= ~(DP_CHASE_TARGET | DP_REACH_Y_TARGET);
				}
					
			}
		}
		// ---- Low battery?
		if ((BaseDrone.DronePhase & DP_LOST_DRONE)==0 && BaseDrone.PercBattery < PROF_BATTERY_LEVEL_EMERGENCY_LANDING) {
			// drone is not lost but level of battery is very low: start emergency landing
			BaseDrone.DronePhase |= (DP_EMERGENCY_LANDING | DP_LANDING);
			if(BaseDrone.TestUserCommand==true &&  BaseDrone.UserCommand  == UCMD_FOLLOW_LARA) {
				BaseDrone.TestUserCommand=false;
				BaseDrone.DronePhase &= ~(DP_CHASE_TARGET | DP_REACH_Y_TARGET);
			}
		}

	}
	// START SAFE RECOVERY for low signal?
	if ((BaseDrone.DronePhase & DP_FLYING)!=0 && (BaseDrone.DronePhase & DP_FAILURE) ==0 && TestNoDirections==true &&
			IsAutomaticPhase()==false) {

		if (BaseDrone.PercSignal < PROF_SIGNAL_LEVEL_EMERGENCY) {
			BaseDrone.DronePhase |= DP_RECOVERING_SAFE_POSITION;
		}
	}


	// ------------------------ PERFORM DRONE'S ANIMATIONS -------------------------------------------
	if (BaseDrone.Flags & DRF_PROXIMITY_SENSOR) {
		if (BaseDrone.TestCollision==true) {
			// if there has been a collisione in this cycle, set old position with no collsione
			CopyPosToItem(BaseDrone.LastPosition, pDrone);


		}
	}
	AnimateItem(pDrone);
	// save data of this just completed game cycle
	BaseDrone.ViewCamOld = BaseDrone.ViewCamNow;
	BaseDrone.TestOldCollision = BaseDrone.TestCollision;
	// save last position of drone where there was NO collision
	if (BaseDrone.TestCollision == false) {
		CopyItemToPos(pDrone, BaseDrone.LastPosition);
	}

	BaseDrone.TestUserChangePos =false;
	
}
void InitSlotDrone(void)
{

	// initialize some drone's values

	BaseDrone.TestJustLoaded=false;
	BaseDrone.TestStartedSaveLoadGame =false;
	BaseDrone.TestPresent=false;
	BaseDrone.TestVisibleRealDrone = true;
	BaseDrone.TestAlreadyShowedHint =false;

	BaseDrone.IndexCamera =-1;
	BaseDrone.IndexPickupDrone = -1;
	BaseDrone.IndexRealDrone=-1;
	BaseDrone.IndexStringBattery =-1;
	BaseDrone.IndexStringCompass =-1;
	BaseDrone.IndexStringDistance = -1;
	BaseDrone.IndexStringHeight = -1;
	BaseDrone.IndexStringSignal = -1;
	BaseDrone.IndexStringWarnings=-1;
	
	// if is missing, not initilize
	Get(enumGET.SLOT, enumSLOT.DRONE, 0);
	if (GET.pSlot->TotMesh == 0) return;

	GET.pSlot->pProcInitialise = ProcDroneInit;
	GET.pSlot->pProcCollision = ProcDroneCollision;
	GET.pSlot->pProcControl = ProcDroneControl;
	GET.pSlot->pProcDraw = (void *) 0x44f600; // default draw procedure
	BaseDrone.TestVisibleRealDrone =true;
	GET.pSlot->FootStep = 128;  // create a shadow



	GET.pSlot->Flags = enumFSLOT.AFFECT_LARA_AT_CONTACT | 
						enumFSLOT.CHANGE_POS_ITEM |
						enumFSLOT.NO_DAMAGE_FOR_NO_EXPLOSIVE_AMMO |
						enumFSLOT.SAVE_ALL_DATA |
						enumFSLOT.SFX_LOCAL_SOUND |
						enumFSLOT.USE_COLLISION_BOX |
						enumFSLOT.PRESENT ;


}




// this function will be called for each your (common) progressive action to be peformed
void PerformMyProgrAction(StrProgressiveAction *pAction)
{
	DWORD x,z;
	int y;
	int Room;
	int IncX, IncZ;
	int PickupDrone;

	StrMovePosition Pos;
	switch (pAction->ActionType) {
	case AXN_TILT_DRONE_CAMERA:
		// verify if we completed the operation
		if (pAction->Arg1==0) {
			BaseDrone.TiltCamera = pAction->Arg2;
			pAction->ActionType = AXN_FREE;
			break;
		}
		pAction->Arg1--;
		BaseDrone.TiltCamera += pAction->VetArgShort[0];


		
		break;
	case AXN_PUT_PICKUP_DRONE:
		// verify when Lara's animation is Arg1 and the frame is Arg2. All in absolute values
		// when it happens create a pickup drone in right position
		Get(enumGET.LARA,0,0);
		if (GET.pLara->AnimationNow != pAction->Arg1 ||
			GET.pLara->FrameNow != pAction->Arg2) break;

		// it's the right frame
		// disable this progressive action
		pAction->ActionType = AXN_FREE;

		// now compute the righr coordinates for pickup drones on the ground
		// discover the position of right hand of lara
		// really the wrist
		// note: since the arm-wrist have a given orientation, the common axis is inverted, see following comments
		// note: it's complicated get a perfect position, for this reason I'll not use the RelX/Y/Z in advance
		// but a reltive moving (usign GetIncrements() function, in right relative direction for a give displacment

		Pos.RelX=0;	
		Pos.RelY=0;		
		Pos.RelZ=0;	

		GetJointAbsPosition(GET.pLara, &Pos, enumJOINT.RIGHT_WRIST);

		x = Pos.RelX;
		y = GET.pLara->CordY - 12; // little adjustment that tomb4 engine does for pickupable items, move them up of 12 units
		z = Pos.RelZ;

		// now I apply a correction moving a bit forward the pickyp
		GetIncrements(GET.pLara->OrientationH, &IncX, &IncZ, 40);

		x+= IncX;
		z+= IncZ;

		// and another adjustment at (relative) right of lara (so we have to change the facing to mvoe at right 90 degrees
		GetIncrements(GET.pLara->OrientationH + 0x4000, &IncX, &IncZ, 40);

		x+= IncX;
		z+= IncZ;

		Room = GET.pLara->Room;
		// choose the type of piclup slot, in according with current battery level
		if (BaseDrone.BatteryLevel == (BaseDrone.BatteryMinutes * 60 * 30)) {
			PickupDrone= BaseDrone.PickupFullDroneSlot;
		}else {
			PickupDrone= BaseDrone.PickupDroneSlot;
		}
		
		BaseDrone.IndexPickupDrone = CreateNewMoveable(PickupDrone, x,y,z, Room);
		
		UpdateItemRoom(BaseDrone.IndexPickupDrone);
		BaseDrone.DronePhase |= DP_DRONE_PICKUP;
		BaseDrone.DronePhase &= ~DP_NO_DRONES;
		// setting other data in item structure
		Get(enumGET.ITEM, BaseDrone.IndexPickupDrone,0);

		GET.pItem->OrientationH = GET.pLara->OrientationH;
		GET.pItem->OrientationT = GET.pLara->OrientationT;
		GET.pItem->OrientationV = GET.pLara->OrientationV;
		// show the shadow
		DisplayShadow(GET.pItem, true);

		GET.pItem->Intensity1 = 0x0c210; // I don't know, but placing clockwork beetle the code used this value, otherwise the item is grayed

		break;

	}

}
// callback called from trng for each frame in game cycle to perform your (common) progressive action
void cbProgrActionMine(void)
{
	int i;
	StrProgressiveAction *pAction;

	pAction = &MyData.VetProgrActions[0];
	for (i=0;i<MyData.TotProgrActions;i++) {
		if (pAction->ActionType != AXN_FREE) {
			PerformMyProgrAction(pAction);
		}
		pAction++;
	}


}
// inside this function you'll type call to functions to intialise your new objects or customize that olds.
// this callback will be called at start of loading new level and a bit after having started to load level data
void cbInitObjects(void) 
{
	InitSlotDrone();

}
//my call back for all global trigger
// check when there is the GT_PICKED_UP_ITEM global triggr, to verify if Lara picked up the drone
void cbTrngGlobalTriggers(int GT_Value, int Parameter)
{
	switch (GT_Value) {
	case GT_PICKED_UP_ITEM:
		if (Parameter == BaseDrone.PickupDroneSlot || Parameter == BaseDrone.PickupFullDroneSlot) {
			// lara picked up drone: reset index
			BaseDrone.IndexPickupDrone=-1;
			BaseDrone.DronePhase |= DP_NO_DRONES;
			BaseDrone.DronePhase &= ~(DP_FLOATING | DP_DRONE_PICKUP);

			// if drone had caught a key, set also this key as picked item
			if (BaseDrone.PickedUpKey != -1) {
				AddDisplayPickup(BaseDrone.PickedUpKey);
				BaseDrone.PickedUpKey=-1;
			}
		
		}
		break;
	}
	Trng.pGlobTomb4->IndiceItemCondizione;
}

// cbLoadSaveGamePanel
// this callback will be called everytime the panel load or save will be drawn or removed
int cbLoadSaveGamePanel(WORD CB_Type, WORD CBT_Flags, WORD PHASE_Type)
{
	// we are interested to act on load/save game panel, ONLY when the drone was flying, while in other circustances
	// it'll be fien the normal savegame management
	// so, if we are not in driving drone mode, we can quit, ignoring this matter
	if (BaseDrone.TestStoppedKeys == false) {
		// lara is not holding the cotnroller, the keyboard command are aleready available, so we can quit here
		return enumSRET.OK;

	}

	switch (CB_Type) {
	case CB_INVENT_BACKGROUND_CREATE:
		// it has been just created a gray panel
		if (PHASE_Type == enumPHASE.SAVE_GAME_PANEL  || PHASE_Type == enumPHASE.LOAD_GAME_PANEL) {
			// in both case (to save game or to load game) we have to enabled newly those keyboard command that
			// user will have to use to handle save/load game panel
			Trng.pGlobTomb4->KeysToStop &= ~(enumCMD.ACTION | enumCMD.ENTER | enumCMD.DOWN | enumCMD.LEFT | 
													enumCMD.RIGHT | enumCMD.UP | enumCMD.INVENTORY);
			// we set this to give the chance to ProcDroneControl() procedure that there has been a load/save game phase
			BaseDrone.TestStartedSaveLoadGame = true;

		}
		break;
	case CB_INVENT_BACKGROUND_QUIT:
		// note: this call back will work for a quitting from Save panel or an abort of Load panel but, when
		//		the player will load really a savegame, this callback will be not called, because the current level quits
		//      and it will be started the level from savegame
		//       for this reason below code shpould be handled also in cbInitLevel() function, when there has been a load savegame
		// it has been just removed some inventory panel
		// now we block newly all keyboard command (Previously set free)
		Trng.pGlobTomb4->KeysToStop |= (enumCMD.ACTION | enumCMD.ENTER | enumCMD.DOWN | enumCMD.LEFT | 
													enumCMD.RIGHT | enumCMD.UP | enumCMD.INVENTORY);
		// an we set as "suspended" some keys that could be active (because used in load/save game panel) and 
		// that could affect the drone management: like ACTION, ENTER and INVENTORY
		BaseDrone.TestSuspendAction =true;
		BaseDrone.TestSuspendEnter =true;
		BaseDrone.TestSuspendInventory=true;
	}

	return enumSRET.OK;

}
// callback called for each sfx played in tomb raider
int cbPlaySfx(int SfxIndex, StrTriplePoint *pSourcePos, DWORD SfxFlags, 
									  short SourceRoom, short RelSfxIndex, StrSoundInfos *pSfxInfo, WORD CBT_Flags)
{
	if (SfxIndex == 33) {
		// it is SPLASH sound.
		// if currently drone is fyling: skip the playing of the sound
		if (BaseDrone.DronePhase & DP_FLYING) return enumSRET.SKIP_ORIGINAL;

	}
	// go on with original code (playint the sfx sound)
	return enumSRET.OK;
}
// FOR_YOU:
// in this function RequireMyCallBacks() you'll type
// a list of:
//		GET_CALLBACK(CB_..., ,)
// one for each callback you need
bool RequireMyCallBacks(void)
{
	// protype of GET_CALLBACK:
	// GET_CALLBACK(CallBackCB, CBT_Flags, Index, MyProcToCall)
	// default callbacks required always 
	GET_CALLBACK(CB_INIT_PROGRAM, 0, 0, cbInitProgram)
	GET_CALLBACK(CB_INIT_GAME, 0, 0, cbInitGame)
	GET_CALLBACK(CB_INIT_LEVEL, 0,0, cbInitLevel)
	GET_CALLBACK(CB_SAVING_GAME, 0, 0, cbSaveMyData)
	GET_CALLBACK(CB_LOADING_GAME, 0, 0, cbLoadMyData)
	GET_CALLBACK(CB_INIT_LOAD_NEW_LEVEL, 0,0, cbInitLoadNewLevel);
	GET_CALLBACK(CB_FLIPEFFECT_MINE, 0, 0, cbFlipEffectMine);
	GET_CALLBACK(CB_ACTION_MINE, 0,0, cbActionMine);
	GET_CALLBACK(CB_CONDITION_MINE,0,0,cbConditionMine);
	GET_CALLBACK(CB_CUSTOMIZE_MINE, 0,0, cbCustomizeMine);
	GET_CALLBACK(CB_PARAMETER_MINE, 0, 0, cbParametersMine);
	GET_CALLBACK(CB_ASSIGN_SLOT_MINE, 0,0, cbAssignSlotMine);
	GET_CALLBACK(CB_CYCLE_BEGIN, 0, 0, cbCycleBegin);
	GET_CALLBACK(CB_PROGR_ACTION_MINE, 0, 0, cbProgrActionMine);
	GET_CALLBACK(CB_INIT_OBJECTS, 0, 0, cbInitObjects);

	// I ask a callback for patch 53h to catch when an item has been selected from inventory
	// I chose an CBT_AFTER patch because I need to return correct eax value to tomb4 main code
	GET_CALLBACK(enumCB.NUMERIC_TRNG_PATCH, enumCBT.AFTER | enumCBT.ASM , 0x53, cbMyPatch53);

	GET_CALLBACK(CB_EVENT_GLOBAL_TRIGGER, CBT_ANY, 0, cbTrngGlobalTriggers);

	// callback to discover when inventory panel (or load/save game panel) will be drawn or removed to handle\
	// blocked keyboard in driving drone mode
	GET_CALLBACK(CB_INVENT_BACKGROUND_CREATE, CBT_FIRST, 0, cbLoadSaveGamePanel);
	GET_CALLBACK(CB_INVENT_BACKGROUND_QUIT, CBT_FIRST, 0, cbLoadSaveGamePanel);
	// callback for playing sfx sounds, to mute the 33 sound (splash) when plugin is using spash effect only for drone overflying the water surface
	// I want the graphic effect but I don't want the relative sound
	GET_CALLBACK(CB_PLAY_SFX,CBT_FIRST, -1, cbPlaySfx);

	return true;
}
// FOR_YOU:
// This function will be the first code to be executed of your plugin
// It happens when trng will load your plugin.
// In this moment no directX graphic is yet active, so you can show
// message boxes (TryMessageBox) to advise your players or level designer 
// about something
// Note: if you wish abort all (because there is an error or something
// is missing) you have to exit from this function returning: false
bool InitializeAll(void)
{

	//  perform all your patches
	CALL_CHECK(CreateMyCodePatches)

	// call the function that requires all callback you need
	CALL_CHECK(RequireMyCallBacks)

	// TYPE_HERE: code to allocate global resource to use in the whole game


	return true;
}

// FOR_YOU: Tyis function will be called when tomb4 game is to be closed.
// you should type in this function further codes to free the global
// resource you had allocated in the InitializeAll() function 
void ReleaseAll(void)
{
	FreeLevelResources();
}


BOOL APIENTRY DllMain( HINSTANCE hInstanceDll, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved)
{

	 static WORD VetRequiredVersion[] = {1,3,0,9};

	StrTrngInfos *pSrcInfo = (StrTrngInfos *) 0x4A6E70;
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:

			
			Trng.IdMyPlugin = pSrcInfo->IdMyPlugin;

			MyDllInstance = hInstanceDll;
			GetTrngInfo();

			if (CompareTrngVersion(VetRequiredVersion) < 0) {
				SendErrorToDiskLog("tomb_nextgeneration.dll has a too low version number for plugin_drones.dll. It's necessary version 1.3.0.9 or higher", Trng.IdMyPlugin  ,false);
				return false;
			}
			
			// only for #debug#
			SendErrorToDiskLog("DLL_PROCESS_ATTACH",Trng.IdMyPlugin , false);

			// control per check control value about size and alignment with globtomb4 structure
			if (CheckControlGlobTomb4() == false) return FALSE;
			SendErrorToDiskLog("Passed CheckControlGlobTomb4()",Trng.IdMyPlugin , false);

			if  (InitializeAll()==false) {
				return FALSE;
			}
			SendErrorToDiskLog("Passed InitializeAll()",Trng.IdMyPlugin , false);
			return TRUE;
			

		case DLL_PROCESS_DETACH:
			ReleaseAll();
			break;
    }
    return TRUE;
}
